      MODULE CFPMODULE
c
c     ********************************************************************
c     DEFINE DATA NEEDED FOR CONDUIT FLOW PROCESS
c     version 1.0 March 2007
c     updated November 2007
c     ********************************************************************
      IMPLICIT NONE
      INTEGER, PARAMETER :: NNOD = 6
      DOUBLE PRECISION, PARAMETER :: PII = 3.141592654D0
      DOUBLE PRECISION, PARAMETER :: TWOPII = 2.0D0*3.141592654D0
      DOUBLE PRECISION, PARAMETER :: ONE8TH = 1.0D0/8.0D0, TWO = 2.0D0
      DOUBLE PRECISION, PARAMETER :: NEARZERO = 1.0D-30, ZERO = 0.0D0
      DOUBLE PRECISION, PARAMETER :: CM2INCH = 3.2804D0
 
CB**Mode=1, Only pipes
cb**Mode=2, Only layers
cb**only need to modify conductances after BCF, LPF or HUF for mode 2
cb**Mode=3, Pipes and layers
c
cbarc**variables needed for mode 1:
cbarc-----------------------------------------------------------------------
      INTEGER, SAVE, POINTER :: Mode, Mxnode, Mxtube, Nbr_lay, Iters
      INTEGER, SAVE, POINTER :: Activenode, Itera_max, Lsurfacedep, P_nr
      INTEGER, SAVE, POINTER, DIMENSION(:, :) :: Nbr
      INTEGER, SAVE, POINTER, DIMENSION(:, :, :) :: Ncond
c
cbarc**for time series output**
      INTEGER, SAVE, POINTER :: Notsno, Notstu, Nnodes, Ntubes, Tsno
      INTEGER, SAVE, POINTER :: Tstu
      INTEGER, SAVE, POINTER, DIMENSION(:) :: Tsnode, Tstube
CBARC**water temp, viscosities
      DOUBLE PRECISION, SAVE, POINTER :: Nu, Tc, Visctc, Vnutc, Epsilon
      DOUBLE PRECISION, SAVE, POINTER :: G, Cfprelax
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Geohight, Nodetop
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Nodebot
!     DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Lay_thick
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Beghead, Tortuos
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Roughness
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: B, B_mat, B_mat_o
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Mod2, Modd
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:) :: Con_data
c
CBARC**FOR CFP1PC
      INTEGER, SAVE, POINTER, DIMENSION(:,:) :: Itube
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:) :: Dtube
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:) :: Node_loca
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:,:) :: Top
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Hc
c
CBARC**for mode 1 direct conduit recharge
      INTEGER, SAVE, POINTER :: Iflag_rech
!     DOUBLE PRECISION, SAVE, POINTER :: Rech_fact
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Qcondir
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) ::Qcondirold
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Qbdir, Qbdirold
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) ::Qbdirsave
c
CBARC**NEEDED IN FORMULATE SUBROUTINE
      INTEGER, SAVE, POINTER :: Konv, Fturb
c
!     DOUBLE PRECISION, SAVE, POINTER :: Ttime, Tmypcg, Tlubsk, Tgllam
!     DOUBLE PRECISION, SAVE, POINTER :: Titernew, Toldtime, Clock
c
      INTEGER, SAVE, POINTER, DIMENSION(:) :: Turb
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Fx0, Tub_reynold
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Head_save, Index1
c
      !rsr changed Mat to Eq_mat
!     DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:) :: Qwd
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:) :: Eq_mat

cbarc**FOR CFP OUTPUT CONTROL AND BUDGET
      INTEGER, SAVE, POINTER :: Ktsno, Ktstu
!     INTEGER, SAVE, POINTER :: Noflow, Nocwb, Kcwb, Kflow
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Qmat, Matflow
c
      DOUBLE PRECISION, SAVE, POINTER :: Bud_source, Bud_sink, Bud_matin
      DOUBLE PRECISION, SAVE, POINTER :: Bud_matout, Bud_qbdir, Diff_tot
      DOUBLE PRECISION, SAVE, POINTER :: Total_budget, Bud_total_step
      DOUBLE PRECISION, SAVE, POINTER :: Ts_in_mat, Ts_out_mat
      DOUBLE PRECISION, SAVE, POINTER :: Ts_bud_sink, Ts_bud_source
      DOUBLE PRECISION, SAVE, POINTER :: Ts_qbdir, Ts_in, Ts_out
      DOUBLE PRECISION, SAVE, POINTER :: Diff_ts, Tot_flow, Ts_tot_flow
c
cbarc**STORAGE AND MATRIX EXCHANGE
      DOUBLE PRECISION, SAVE, POINTER :: Bud_storage
      DOUBLE PRECISION, SAVE, POINTER :: Ts_bud_storage
      DOUBLE PRECISION, SAVE, POINTER :: Ts_bud_storage_in
      DOUBLE PRECISION, SAVE, POINTER :: Ts_bud_storage_out
      DOUBLE PRECISION, SAVE, POINTER :: Bud_storage_in, Bud_storage_out
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Qstor, Nstor
c
cbarc**FOR NODE BUDGET**
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Qdir, Qfix
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Nodin, Nodout
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Qtubin, Qtubout
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:) :: Qtub
c
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Ku_in_mat
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Ku_out_mat
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Ku_qbdir
c
cbarc**add this for GSFLOW
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Rof
c
cbarc**variables needed for mode 2:
cbarc-----------------------------------------------------------------------
      INTEGER, SAVE, POINTER :: Ncl
      INTEGER, SAVE, POINTER, DIMENSION(:) :: Cl
      DOUBLE PRECISION, SAVE, POINTER :: Twater, Denswa, Viscwa

      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Lcritrey
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:) :: Tcritrey, Void
cbarc**add these
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:,:) :: klam_Cr,
     &  klam_Cc

!     DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:)::Neff

      INTEGER, SAVE, POINTER, DIMENSION(:,:,:) :: Turb_fr, Turb_ff
      INTEGER, SAVE, POINTER, DIMENSION(:,:,:) :: Tl_out
      DOUBLE PRECISION, SAVE, POINTER, DIMENSION(:,:,:) :: Crt, Cct
      END MODULE CFPMODULE
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE GWF2CFP1AR(Inunit, Incfpoc, Incfprch)
c     ********************************************************************
c     ALLOCATE AND READ DATA FOR CONDUIT FLOW PROCESS
c     March 2007 version 1.0
c     ********************************************************************
c
      USE GLOBAL, ONLY:Iout, Ncol, Nrow, Nlay, Lenuni, Itmuni, Botm
      USE CFPMODULE
      IMPLICIT NONE
      INTRINSIC DINT
cbarc**need these functions
      DOUBLE PRECISION, EXTERNAL :: DYNVISC, KINVISC
      EXTERNAL CFP1PC, CALC_DENS_VISC, CFPM1OCAR !, GWF2CFP1PSV
! Arguments
      INTEGER, INTENT(IN) :: Inunit, Incfpoc, Incfprch
! Local Variables
      INTEGER i, ic, ii, il, ir, j, idummy
      CHARACTER(LEN=80) cdummy
      DOUBLE PRECISION dummy2, dummy3, dummy4, dummy5, dummy6
!     ------------------------------------------------------------------
C------Allocate scalar data.
      ALLOCATE (Mode, Mxnode, Mxtube, Nbr_lay, Konv, Fturb, Iters)
      ALLOCATE (Activenode, Itera_max, Lsurfacedep, P_nr)
      ALLOCATE (G, Epsilon, Cfprelax, Tc, Iflag_rech)
      ALLOCATE (Ncl, Twater, Denswa, Viscwa, Ktsno, Ktstu)
!     ALLOCATE (Rech_fact, Ttime, Tmypcg, Tlubsk, Tgllam, Titernew)
!     ALLOCATE (Toldtime, Clock, Noflow, Nocwb, Kcwb, Kflow)
CBARC**FOR BUDGETS AND OUTPUT CONTROL
      ALLOCATE (Bud_source, Bud_sink, Bud_matin, Bud_matout, Bud_qbdir, &
     &          Total_budget, Bud_total_step, Ts_in_mat, Ts_out_mat,    &
     &          Ts_bud_sink, Ts_bud_source, Ts_qbdir, Ts_in, Ts_out,    &
     &          Diff_tot, Diff_ts, Tot_flow, Ts_tot_flow)
      Bud_source = ZERO
      Bud_sink = ZERO
      Bud_matin = ZERO
      Bud_matout = ZERO
      Bud_qbdir = ZERO
      Total_budget = ZERO
      Bud_total_step = ZERO
 
cbarc**STORAGE AND MATRIX EXCHANGE
      ALLOCATE (Bud_storage, Ts_bud_storage_in, Ts_bud_storage_out)
      ALLOCATE (Bud_storage_in, Bud_storage_out, Ts_bud_storage)
      Bud_storage = ZERO
      Bud_storage_in = ZERO
      Bud_storage_out = ZERO
c 
cbarc**WRITE MESSAGE TO OUTPUT IOUT
      WRITE (Iout, *)
      WRITE (Iout, *) 'CFP1AR READING FROM UNIT', Inunit
c 
cbarc**read mode to determine what is read from CFP file.
celk**read CFP input file cdummy required comment line for simulation
      READ (Inunit, *) cdummy
celk**read CFP input data type 0 in report documentation
      READ (Inunit, *) Mode
cbarc**skip pipe allocates and reads if mode=2
      IF ( Mode.NE.2 ) THEN
cbarc**read what is needed for pipes
cbarc------------------------------------------------------------------------
        WRITE (Iout, *) '---------------------------------'
        WRITE (Iout, *) 'CFP MODE 1 IS ACTIVE (PIPES) '
        WRITE (Iout, *) '---------------------------------'
celk**read CFP input file data type 1 and 2 required comment lines
        READ (Inunit, *) cdummy
        READ (Inunit, *) cdummy
 
cbarc&elk**read CFP input file data type 3 mxnode,mxtube,nbr_lay
cbarc**set nnod, this is the maximum # of connecting nodes (3-D)
        READ (Inunit, *) Mxnode, Mxtube, Nbr_lay
        WRITE (Iout, 9001) Mxnode, Mxtube
        WRITE (Iout, 9002) Nbr_lay
 
Cseba--TEST IF # OF LAYERS IN MODFLOW AND CONDUIT IS THE SAME
        IF ( Nlay.NE.Nbr_lay ) THEN
          PRINT *,                                                      &
     &    'THE NUMBER OF LAYERS IN MODFLOW AND CFP FILE IS NOT THE SAME'
          PRINT *, '  PROGRAM STOPS'
          STOP
        ENDIF
CBARC**allocate mode 1 arrays and variables that need mxnode,mxtube,nbr_lay
        ALLOCATE (Nbr(Mxnode,4+2*NNOD))
        ALLOCATE (Nodetop(Mxnode), Nodebot(Mxnode))
!       ALLOCATE (Lay_thick(Nbr_lay))
 
CBARC**allocate cfp mode 1 stress period data
        ALLOCATE (Con_data(Mxtube,6))
        ALLOCATE (Beghead(Mxnode), Modd(Mxnode), Tortuos(Mxtube),       &
     &            Roughness(Mxtube))
c 
cbarc**set activenode
        Activenode = Mxnode
c 
cbarc**for recharge
        ALLOCATE (Qcondir(Mxnode), Qcondirold(Mxnode))
c 

cbarc**alocate these for pipe flow formulate subroutines
        ALLOCATE (Mod2(Mxnode), Hc(Mxnode), B_mat(Mxnode), B(Mxnode),   &
     &            B_mat_o(Mxnode))
        B_mat = ZERO
        B_mat_o = ZERO
c 
CBARC**FOR CFP1PC
        ALLOCATE (Itube(Mxtube,3), Dtube(Mxtube,2), Node_loca(Mxnode,4))
        Itube = 0
        Dtube = ZERO
        ALLOCATE (Top(Ncol,Nrow,Nlay))
        ALLOCATE (Qbdir(Mxnode), Turb(Mxtube), Fx0(Mxnode),             &
     &            Qbdirold(Mxnode), Qbdirsave(Mxnode))
        Turb = 0
        ALLOCATE (Tub_reynold(Mxtube), Head_save(Mxnode))
        Tub_reynold = ZERO
        ALLOCATE (Index1(Activenode), Eq_mat(Activenode,Activenode))
c 
CBARC**FOR BUDGETS AND OUTPUT CONTROL
        ALLOCATE (Matflow(Mxnode), Qmat(Mxnode))
        ALLOCATE (Qstor(Mxnode), Nstor(Mxnode))
        ALLOCATE (Qdir(Mxnode), Qtub(Mxnode,NNOD), Nodin(Mxnode),       &
     &            Nodout(Mxnode), Qfix(Mxnode), Qtubin(Mxnode),         &
     &            Qtubout(Mxnode))
        ALLOCATE (Ku_in_mat(Mxnode), Ku_out_mat(Mxnode),                &
     &            Ku_qbdir(Mxnode))
        Ku_in_mat = ZERO
        Ku_out_mat = ZERO
        Ku_qbdir = ZERO
c
cbarc**add this for GSFLOW
        Allocate (Rof(mxnode))
c
cbarc**make sure length and time units are not undefined, so that g can be defined
cbarc---------------------------------------------------------------------------
        IF ( Itmuni.EQ.0 .OR. Lenuni.EQ.0 ) THEN
          PRINT *, 'ERROR IN DIS FILE, ITMUNI AND LENUNIT CANNOT BE',   &
     &          ' UNDEFINED WHEN CFP IS ACTIVE'
          STOP
        ENDIF
c 
cbarc**SET G
cbarc**units are m SEC-2
        IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.2 ) G = 9.80665D0
cbarc**units are m MIN-2
        IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.2 ) G = 9.80665D0*60.D0**TWO
cbarc**units are m HOURS-2
        IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.2 )                            &
     &       G = 9.80665D0*60.D0**TWO*60.D0**TWO
cbarc**units are m DAYS-2
        IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.2 )                            &
     &       G = 9.80665D0*60.D0**TWO*60.D0**TWO*24.D0**TWO
cbarc**units are m YEAR-2
        IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.2 )                            &
     &       G = 9.80665D0*60.D0**TWO*60.D0**TWO*24.D0**TWO*365.D0**TWO
 
cbarc**units are FT SEC-2
        IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.1 ) G = 9.80665D0*CM2INCH
cbarc**units are FT MIN-2
        IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.1 )                            &
     &       G = 9.80665D0*CM2INCH*60.D0**TWO
cbarc**units are FT HOURS-2
        IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.1 )                            &
     &       G = 9.80665D0*CM2INCH*60.D0**TWO*60.D0**TWO
cbarc**units are FT DAYS-2
        IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.1 )                            &
     &       G = 9.80665D0*CM2INCH*60.D0**TWO*60.D0**TWO*24.D0**TWO
cbarc**units are FT YEAR-2
        IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.1 )                            &
     &       G = 9.80665D0*CM2INCH*60.D0**TWO*60.D0**TWO*24.D0**TWO     &
     &           *365.D0**TWO
c 
cbarc**units are CM SEC-2
        IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.3 ) G = 9.80665D0*100.D0
cbarc**units are CM MIN-2
        IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.3 )                            &
     &       G = 9.80665D0*100.D0*60.D0**TWO
cbarc**units are CM HOURS-2
        IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.3 )                            &
     &       G = 9.80665D0*100.D0*60.D0**TWO*60.D0**TWO
cbarc**units are CM DAYS-2
        IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.3 )                            &
     &       G = 9.80665D0*100*60**TWO*60**TWO*24**TWO
cbarc**units are CM YEAR-2
        IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.3 )                            &
     &       G = 9.80665D0*100.D0*60.D0**TWO*60.D0**TWO*24.D0**TWO      &
     &           *365.D0**TWO
c 
        WRITE (Iout, *) 'GRAVITATIONAL CONSTANT (G) COMPUTED '
c
cbarc---------------------------------------------------------------------------
cbarc**allocate and initialize ncond
        ALLOCATE (Ncond(Ncol,Nrow,Nlay))
        DO il = 1, Nlay
          DO ir = 1, Nrow
            DO ic = 1, Ncol
              Ncond(ic, ir, il) = 0
            ENDDO
          ENDDO
        ENDDO
 
cbarc&elk**read comment CFC input file data type 4 and temperature in C data type 5
        READ (Inunit, '(A)') cdummy
        READ (Inunit, *) Tc
        WRITE (Iout, *) 'WATER TEMPERATURE, IN DEGREES CELCIUS, IS ', Tc
c 
cbarc**calculate dynamic viscosity
cbarc---------------------------------------------------------------------------
        ALLOCATE (Nu, Visctc, Vnutc)
cbarc**coming out of here in Pa s
        Visctc = DYNVISC(Tc) 
C--CALCULATE KINEMATIC VISCOSITY (comes out with units of m2/sec)
c 
        Vnutc = KINVISC(Tc, Visctc)
c 
cbarc**units are m2/s
        IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.2 ) Vnutc = Vnutc*1.D0
cbarc**units are M2 / MIN
        IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.2 ) Vnutc = Vnutc*60.D0
cbarc**units are M2/HOUR
        IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.2 ) Vnutc = Vnutc*60.D0**TWO
cbarc**units are M2/DAY
        IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.2 )                            &
     &       Vnutc = Vnutc*60.D0**TWO*24.D0
cbarc**units are M2/YEAR
        IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.2 )                            &
     &       Vnutc = Vnutc*60.D0**TWO*24.D0*365.D0
c 
cbarc**units are FT2 /SEC
        IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.1 )                            &
     &       Vnutc = Vnutc*CM2INCH**TWO
cbarc**units are FT2/MIN
        IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.1 )                            &
     &       Vnutc = Vnutc*CM2INCH**TWO*60.D0
cbarc**units are FT2/HR
        IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.1 )                            &
     &       Vnutc = Vnutc*CM2INCH**TWO*60.D0**TWO
cbarc**units are FT2/DAY
        IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.1 )                            &
     &       Vnutc = Vnutc*CM2INCH**TWO*60.D0**TWO*24.D0
cbarc**units are FT2/YR
        IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.1 )                            &
     &       Vnutc = Vnutc*CM2INCH**TWO*60.D0**TWO*24.D0*365.D0
c 
cbarc**units are CM2/SEC
        IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.3 ) Vnutc = Vnutc*100.D0**TWO
cbarc**units are CM2/MIN
        IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.3 )                            &
     &       Vnutc = Vnutc*100.D0**TWO*60.D0
cbarc**units are CM2/HR
        IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.3 )                            &
     &       Vnutc = Vnutc*100.D0**TWO*60.D0**TWO
cbarc**units are CM2/DAY
        IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.3 )                            &
     &       Vnutc = Vnutc*100.D0**TWO*60.D0**TWO*24.D0
cbarc**units are CM2/YR
        IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.3 )                            &
     &       Vnutc = Vnutc*100.D0**TWO*60.D0**TWO*24.D0*365.D0
c 
        WRITE (Iout, *) ' KINEMATIC VISCOSITY [L^2/T]=', Vnutc
CBARC**SET NU
        Nu = Vnutc
c 
c 
c
C--READ IN NODES, TUBES AND THEIR RELATION => NBR-ARRAY
CBARC------------------------------------------------------------
celk read CFP input data type 6 required comment line
        READ (Inunit, '(A)') cdummy
        WRITE (Iout, *)
        WRITE (Iout, *) ' NBR-ARRAY: '
celk read CFP input data type 7
celk read NO_N  MC  MR  ML  NB1  NB2  NB3  NB4  NB5  NB6  PB1  PB2  PB3  PB4  PB5  PB6
        DO i = 1, Mxnode
          READ (Inunit, *) (Nbr(i,j), j=1, (4+2*NNOD))
          WRITE (Iout, 9003) (Nbr(i,j), j=1, (4+2*NNOD))
        ENDDO
        WRITE (Iout, *) 'NBR ARRAY READ'
c 
cbirk---WRITE NODE NUMBERS TO NCOND
        DO i = 1, Mxnode
          ic = Nbr(i, 2)
          ir = Nbr(i, 3)
          il = Nbr(i, 4)
          Ncond(ic, ir, il) = i
cb        WRITE (Iout, *) ic, ir, il, Ncond(ic,ir,il)
        ENDDO
c 
cbarc**allocate and read data to determine elevation of nodes
        ALLOCATE (Geohight(Mxnode))
celk read CFP input file data type 8-10 3 required comment lines 
        READ (Inunit, '(A)') cdummy
        READ (Inunit, '(A)') cdummy
        READ (Inunit, '(A)') cdummy
celk read CFP input file data type 11 note read dummy first because of 2
celk      options for the elevation of the node height
celk      option 1 user must enter absolute node height 
        READ (Inunit, *) idummy, dummy2
CB      WRITE (Iout, *) idummy, dummy2
        IF ( idummy.EQ.1 ) THEN
          Geohight(idummy) = dummy2
          DO i = 2, Mxnode
            READ (Inunit, *) ii, Geohight(i)
            IF ( ii.NE.i ) WRITE (Iout, *)                              &
     &                     'ERROR READING NODE ELEVATIONS, LIST NODES', &
     &            ' AND ELEVATIONS IN SEQUENTIAL ORDER FROM 1 TO MXNODE'
          ENDDO
        ELSEIF ( idummy.EQ.Mxnode ) THEN
          DO i = 1, Mxnode
cbarc&elk Option 2 make the node elevation the center of the MODFLOW cell.
            Geohight(i) = dummy2 + Botm(Nbr(i,2), Nbr(i,3), Nbr(i,4))            
     &                    + (Botm(Nbr(i,2),Nbr(i,3),Nbr(i,4)-1)         
     &                    -Botm(Nbr(i,2),Nbr(i,3),Nbr(i,4)))/2
c 
          ENDDO
        ENDIF
        WRITE (Iout, *) ' NODE ELEVATIONS:'
        DO i = 1, Mxnode
          WRITE (Iout, *) i, Geohight(i)
        ENDDO
c 
cbarc**read mode 1 controls
c 
C READ FLAG OF SURFACE-AREA DEPENDENT OR CONSTANT EXCHANGE Pipe Concuctance
celk CPF input file data type 12 required comment statement
        READ (Inunit, '(A)') cdummy
celk CPF input file data type 13 SA_EXCHANGE in report this is a 0 or 1
        READ (Inunit, *) Lsurfacedep
c 
C READ CRITERION OF CONVERGENCE
celk CPF input file data type 14 required comment statement
        READ (Inunit, '(A)') cdummy
celk CPF input file data type 15 EPSILON in report the convergence criteria
        READ (Inunit, *) Epsilon
c 
C READ MAXIMUM FOR ITERATION
celk CPF input file data type 16 required comment statement
        READ (Inunit, '(A)') cdummy
celk CPF input file data type 17 NITER in report-the maximum number of iterations
        READ (Inunit, *) Itera_max
c 
C--READ IN RELAXATION PARAMETER
celk CPF input file data type 18 required comment statement
        READ (Inunit, '(A)') cdummy
celk CPF input file data type 19 RELAX in report-the relaxation perameter
        READ (Inunit, *) Cfprelax
c 
C--READ NEWTON RAPHSON PRINT FLAG
celk CPF input file data type 20 required comment statement
        READ (Inunit, '(A)') cdummy
celk CPF input file data type 21 P_NR in report-a print flag 0 or 1
        READ (Inunit, *) P_nr
CB      PRINT*, P_nr
CBARC**WRITE THIS:
        WRITE (Iout, *)                                                 &
     &              'FINISHED READING NEWTON RAPHSON ITERATION CONTROLS'
c 
cbarc**read node and tube data next
CBARC------------------------------------------------------------
        WRITE (Iout, *) 'READING NODE AND TUBE DATA'
celk CPF input file data type 22 abd 23 required comment statements
        READ (Inunit, '(A)') cdummy
        READ (Inunit, '(A)') cdummy
C READ TUBEDATA
celk CPF input file data type 24  one line for each pipe number or set all pipes constant
celk     NO_P  DIAMETER  TORTUOSITY  ROUGHNESS  LCRITREY_P  TCRITREY_P 
celk LCRITREY_P the lower critical Reynolds number (turbulent to laminar)
celk TCRITREY_P the upper critical Reynolds number (laminar to turbulent) 
          DO i = 1, Mxtube
            READ (Inunit, *) (Con_data(i,j), j=1, 6)
            IF ( i.NE.DINT(Con_data(i,1)) ) PRINT *,                    &
     &           '      ERROR IN CONDUIT INPUT FILE: TUBE DATA'
          ENDDO
cbarc**assign these for later
          DO i = 1, Mxtube
            Tortuos(i) = Con_data(i, 3)
            Roughness(i) = Con_data(i, 4)
          ENDDO
cbarc**READ HEADS
celk CFP input file data type 25 required comment statement
          READ (Inunit, '(A)') cdummy
          WRITE (Iout, *) 'READING NODE FIXED HEADS AND IBOUNDS'
          WRITE (Iout, *) 'NODE          FIXED HEAD AND/OR IBOUND'
celk CFP input file data type 26 NO_N N_HEAD in report
          DO i = 1, Mxnode
            READ (Inunit, *) idummy, Beghead(i)
            WRITE (Iout, *) i, Beghead(i)
            IF ( i.NE.idummy ) PRINT *,                                 &
     &               '      ERROR IN CONDUIT INPUT FILE: STARTING HEADS'
          ENDDO
cbarc**read 'MODD' EXCHANGE COEFFICIENTS
          WRITE (Iout, *) 'READING EXCHANGE COEFFICIENTS'
          WRITE (Iout, *) 'NODE          EXCHANGE COEFFICIENT'
celk CFP input file data type 27 required comment statement
          READ (Inunit, '(A)') cdummy
celk CFP input file data type 28 NO_N K_EXCHANGE in report
          DO i = 1, Mxnode
            READ (Inunit, *) idummy, Modd(i)
            WRITE (Iout, *) i, Modd(i)
            IF ( i.NE.idummy ) PRINT *,                                 &
     &               '      ERROR IN CONDUIT INPUT FILE: EXCHANGE TERMS'
          ENDDO
c
      ENDIF
celk--end of input for mode equal 1 or 3  ------------------- 
      IF ( Mode.NE.1 ) THEN
cbarc**jump to here if mode=2
c 
cbarc**read what is needed for preferential flow layers MODE 2
cbarc------------------------------------------------------------------------
        WRITE (Iout, *) '---------------------------------'
        WRITE (Iout, *) 'CFP MODE 2 IS ACTIVE (LAYERS) '
        WRITE (Iout, *) '---------------------------------'
 
        ALLOCATE (Turb_fr(Ncol,Nrow,Nlay), Turb_ff(Ncol,Nrow,Nlay),     &
     &            Tl_out(Ncol,Nrow,Nlay))
cbarc**
	  ALLOCATE  (klam_Cr(Ncol,Nrow,Nlay),klam_Cc(Ncol,Nrow,Nlay))
        ALLOCATE  (Crt(Ncol,Nrow,Nlay),Cct(Ncol,Nrow,Nlay))
celk CFP input file data types 29 and 30 comment lines 
        READ (Inunit, *) cdummy
        READ (Inunit, *) cdummy
Celk CFP input file data types 31 NCL number of preferential flow layers
        READ (Inunit, *) Ncl
        ALLOCATE (Cl(Ncl))
celk CFP input file data type 32 comment line
        READ (Inunit, *) cdummy
celk CFP input file data type 33 this is the actual model layer numbers CL(NCL)
        READ (Inunit, *) (Cl(i), i=1, Ncl)
        WRITE (Iout, '(A10,I3,A27)') 'THERE ARE ', Ncl,                 
     &                               ' PREFERENTIAL FLOW LAYER(S)'
        WRITE (Iout, '(A34)') 'PREFERENTIAL FLOW LAYER NUMBER(S):'
        WRITE (Iout, *) (Cl(i), i=1, Ncl)
cbarc**allocate and read water temperature to calculate density and viscosity
celk CFP input file data type 34 comment line
        READ (Inunit, *) cdummy
celk CFP input file data type 35 LTEMP in report one temperature for all layers
        READ (Inunit, *) Twater
CB    WRITE (Iout,' (A21,F6.3,A16)') 'WATER TEMPERATURE IS ', Twater,   &
CB   & ' DEGREES CELCIUS'
        CALL CALC_DENS_VISC
cbarc**allocate and read mean void diameters and critical reynolds #'s for conduit layers
        ALLOCATE (Void(Ncl), Lcritrey(Ncl), Tcritrey(Ncl))
C     ALLOCATE (Neff(Ncl))
celk CFP input file data type 36 comment lines
CELK CFP input file data type for reading in a comment and constants for each layer
        READ (Inunit, *) cdummy
        DO i = 1, Ncl
          READ (Inunit, *) cdummy
          READ (Inunit, *) Void(i), Lcritrey(i), Tcritrey(i)

       WRITE (Iout, *) 'READ MEAN VOID DIA AND LOWER & UPPER CRIT REYN
     & NO. FOR CONDUIT LAYER ', Cl(i)
	 WRITE (Iout, *) Void(i), Lcritrey(i), Tcritrey(i)
        ENDDO
      ENDIF
celk**endif for reading data for mode equal 2 or 3 

cbarc**jump to here if mode=1,3
      IF ( Mode.NE.2 ) THEN
        IF ( Incfpoc.GT.0 ) CALL CFPM1OCAR(Incfpoc)
        CALL CFP1PC
      ENDIF

      IF ( Mode.EQ.2 ) THEN
       IF ( Incfprch.GT.0 ) THEN
         PRINT *, 'CRCH PACKAGE NOT NEEDED WHEN CFP MODE 2 IS ACTIVE'
         PRINT *, 'REMOVE OR COMMENT OUT CRCH IN NAME FILE'
         PRINT *, '                     '
       ENDIF

       IF( Incfpoc.GT.0 ) THEN
         PRINT *, 'COC PACKAGE NOT NEEDED WHEN CFP MODE 2 IS ACTIVE'
         PRINT *, 'REMOVE OR COMMENT OUT COC IN NAME FILE'
       ENDIF
      ENDIF
c 
 9001 FORMAT (4X, 'NUMBER OF NODES IS', I8, ' NUMBER OF TUBES IS', I8)
 9002 FORMAT (4X, ' NUMBER OF LAYERS IS', I5)
 9003 FORMAT (4X, I6, 1X, 3I6, 1X, 6I6, 1X, 6I6)
c 
      END SUBROUTINE GWF2CFP1AR
c
! ======================================================================
Cbarc**consider making this work with degrees F also
c---------------------------------------------------------------c
c---CALCULATION OF DYNAMIC VISCOSITY
c jan1999
c
c  tc      temperature in degree Celsius     
c  dynvisc    dynamic viscosity in Pa s  
c      
      DOUBLE PRECISION FUNCTION DYNVISC(Tc)
      IMPLICIT NONE
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Tc
c
!     ------------------------------------------------------------------
Cvis--dynamic viscosity [Pa s]of water according to
C      HANDBOOK OF CHEMISTRY AND PHYSICS (1979)
      IF ( Tc.GE.0.0 .AND. Tc.LT.20.0 ) THEN
        DYNVISC = 10.0D0**                                              &
     &            (1301.0D0/(998.33D0+8.1855D0*(Tc-20.0D0)+0.00585D0*   &
     &            (Tc-20.0D0)**2.0D0)-1.30233D0)/1000.0D0
      ELSEIF ( Tc.GE.20.0 .AND. Tc.LE.100.0 ) THEN
        DYNVISC = 10.0D0**                                              &
     &            ((1.3272D0*(20.0D0-Tc)-0.001053D0*(Tc-20.0D0)**2.0D0) &
     &            /(Tc+105.0D0))*1.002D0/1000.0D0
      ELSE
        WRITE (*, *) 'Bad temperature input!'
        STOP
      ENDIF
c     WRITE (*, *) 'dynvisc', DYNVISC
C
      END FUNCTION DYNVISC

! ======================================================================
 
c-------------------------------------------      
c---CALCULATION OF WATER DENSITY AND KINEMATIC VISCOSITY
c jan1999      
c
c  kinvisc kinematic viscosity in m**2/s
c  tc      temperature in degree Celsius     
c  visc    dynamic viscosity in Pa s
c  wadens  density of water in kg/m**3        

      DOUBLE PRECISION FUNCTION KINVISC(Tc, Visc)
      IMPLICIT NONE
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Tc, Visc
! Local Variables
      DOUBLE PRECISION wadens
c
!     ------------------------------------------------------------------
Croh--density [kg/m**3] of water according to
C   HANDBOOK OF CHEMISTRY AND PHYSICS (1979)
      wadens = (999.83952D0+16.945176D0*Tc-7.9870401D-3*Tc**2.0D0-      &
     &         46.170461D-6*Tc**3.0D0+105.56302D-9*Tc**4.0D0-           &
     &         280.54253D-12*Tc**5.0D0)/(1.0D0+16.879850D-3*Tc)
 
Cnu--kinematic viscosity [m**2/s]
      KINVISC = Visc/wadens
 
      END FUNCTION KINVISC
c------------------------------------------
! ======================================================================
      SUBROUTINE CALC_DENS_VISC
C     ******************************************************************
CBARC**CALCULATES WATER DENSITY AND VISCOSITY FOR CFPM2
C     ******************************************************************
      USE CFPMODULE, ONLY:Twater, Denswa, Viscwa, TWO, CM2INCH
      USE GLOBAL, only:Iout, Itmuni, Lenuni
      IMPLICIT NONE
!     ------------------------------------------------------------------
croh--density [kg/m**3] of water according to
C   HANDBOOK OF CHEMISTRY AND PHYSICS (1979)
      Denswa = (999.83952D0+16.945176D0*Twater-                         &
     &         7.9870401D-3*Twater**TWO-46.170461D-6*Twater**3.0D0+     &
     &         105.56302D-9*Twater**4.0D0-280.54253D-12*Twater**5.0D0)  &
     &         /(1.0D0+16.879850D-3*Twater)
c 
C--CALCULATE DYNAMIC VISCOSITY
Cvis--dynamic viscosity [Pa s]of water according to
C      HANDBOOK OF CHEMISTRY AND PHYSICS (1979)
      IF ( Twater.GE.0.0 .AND. Twater.LT.20.0 ) THEN
        Viscwa = 10.0D0**                                               &
     &           (1301.0D0/(998.33D0+8.1855D0*(Twater-20.0D0)+0.00585D0*&
     &           (Twater-20.0D0)**TWO)-1.30233D0)/1000.0D0
      ELSEIF ( Twater.GE.20.0 .AND. Twater.LE.100.0 ) THEN
        Viscwa = 10.0D0**                                               &
     &           ((1.3272D0*(20.0D0-Twater)-0.001053D0*(Twater-20.0D0)  &
     &           **TWO)/(Twater+105.0D0))*1.002D0/1000.0D0
      ELSE
        WRITE (*, *) 'Bad temperature input!'
        STOP
      ENDIF
c 
Cnu--kinematic viscosity [m**2/s]
      Viscwa = Viscwa/Denswa
c 
cbarc**correct density units
cbarc**units are FT
      IF ( Lenuni.EQ.1 ) Denswa = Denswa*(1.0D0/(CM2INCH**3.0D0))
cbarc**units are CM
      IF ( Lenuni.EQ.3 ) Denswa = Denswa*(1.0D0/(100.0D0**3.0D0))
c 
cbarc**correct viscosity units
cbarc**units are m2/s
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.2 ) Viscwa = Viscwa*1.0D0
cbarc**units are M2 / MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.2 ) Viscwa = Viscwa*60.0D0
cbarc**units are M2/HOUR
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.2 ) Viscwa = Viscwa*60.0D0**TWO
cbarc**units are M2/DAY
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.2 )                              &
     &     Viscwa = Viscwa*60.0D0**TWO*24.0D0
cbarc**units are M2/YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.2 )                              &
     &     Viscwa = Viscwa*60.0D0**TWO*24.0D0*365.0D0
c 
cbarc**units are FT2 /SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.1 ) Viscwa = Viscwa*CM2INCH**TWO
cbarc**units are FT2/MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.1 )                              &
     &     Viscwa = Viscwa*CM2INCH**TWO*60.0D0
cbarc**units are FT2/HR
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.1 )                              &
     &     Viscwa = Viscwa*CM2INCH**TWO*60.0D0**TWO
cbarc**units are FT2/DAY
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.1 )                              &
     &     Viscwa = Viscwa*CM2INCH**TWO*60.0D0**TWO*24.0D0
cbarc**units are FT2/YR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.1 )                              &
     &     Viscwa = Viscwa*CM2INCH**TWO*60.0D0**TWO*24.0D0*365.0D0
c 
cbarc**units are CM2/SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.3 ) Viscwa = Viscwa*100.D0**TWO
cbarc**units are CM2/MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.3 )                              &
     &     Viscwa = Viscwa*100.0D0**TWO*60.0D0
cbarc**units are CM2/HR
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.3 )                              &
     &     Viscwa = Viscwa*100.0D0**TWO*60.0D0**TWO
cbarc**units are CM2/DAY
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.3 )                              &
     &     Viscwa = Viscwa*100.0D0**TWO*60.0D0**TWO*24.0D0
cbarc**units are CM2/YR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.3 )                              &
     &     Viscwa = Viscwa*100.0D0**TWO*60.0D0**TWO*24.0D0*365.0D0
 
CB    WRITE (Iout, *) ' kinematic viscosity [L^2/T]=', Viscwa
      WRITE (Iout, *) ' DENSITY OF WATER IS [Kg/L^3]=', Denswa
c 
      END SUBROUTINE CALC_DENS_VISC
c======================================================================= 
c=======================================================================
! ======================================================================
c 
      SUBROUTINE CFP1PC
c
Cseba--SUBROUTINE FOR DETERMINATION OF TUBE/NODE GEOMETRY:
C      CALLS LENGTH_CALC AND DETERM TUBE FROM CON2RP
C     14DEZ1998
C     ******************************************************
C     PROCESS AND CHECK CONDUIT DATA AND GEOMETRY
C     ******************************************************
c
      USE GLOBAL, ONLY:Ncol, Nrow, Nlay, Iout, Botm
      USE CFPMODULE, ONLY:Top
c
cbarc-------------------------------------------------------
      IMPLICIT NONE
      EXTERNAL DETERM_TUB, GEOCALC, LENGTH_CAL
      EXTERNAL ROUGH_CAL, TEST_CONDUIT_NETWORK
! Local Variables
      INTEGER i, j, k
!     ------------------------------------------------------------------
      WRITE (Iout, *) 'PROCESSING AND CHECKING CONDUIT-NETWORK'
c 
cbarc**set top
      DO k = 1, Nlay
        DO i = 1, Nrow
          DO j = 1, Ncol
            Top(j, i, k) = Botm(j, i, k-1)
          ENDDO
        ENDDO
      ENDDO
C
C--CHECK CONDUIT NETWORK FOR ERRORS IN INPUT FILE
      CALL TEST_CONDUIT_NETWORK
c 
C--ASSIGN TUBENR. WITH NODENUMBERS
      CALL DETERM_TUB
C
C--DETERMINE GEOMETRY OF THE CONDUIT NETWORK
      CALL GEOCALC
C
C--CALCULATE REAL TUBE LENGTH
      CALL LENGTH_CAL
 
C--CALCULATE ROUGHNESS LENGTH OF TUBE WALLS:
      CALL ROUGH_CAL
c 
      END SUBROUTINE CFP1PC
c======================================================================= 
! ======================================================================
c======================================================================= 
Cseba
      SUBROUTINE TEST_CONDUIT_NETWORK
C
C  VERSION 1      9/1998
C****************************************************************
C   TEST_CONDUIT_NETWORK - TESTING OF TUBES BEFORE CALCULATION
C****************************************************************
C
C  INPUT:
C  Nbr(mxnodes,(4+2*nnod)) - contains arry from conduit_mod with columns
C                    NR  NB1 NB2 NB3 NB4 TB1 TB2 TB3 TB4 MC MR ML
C                    for each node NR
C  mxnode - Number of nodes,
C  mxtube - Number of tubes (pipes)
C  nbr_lay - Number of layers.
C  ibound - IBOUND array from MODFLOW
C            < 0, CONSTANT-HEAD CELL
C            = 0, INACTIVE CELL
C            > 0, VARIABLE-HEAD CELL
C
      USE CFPMODULE, ONLY:NNOD, Mxnode, Mxtube, Nbr, Beghead, NEARZERO
      USE GLOBAL, ONLY:Iout, Ibound
      IMPLICIT NONE
      INTRINSIC DABS
C INTERNAL VARIABLES:      
C more than 4 tubes each node: reset nnod
! Local Variables
      INTEGER tube1(Mxtube, 5), tube2(Mxtube, 5)
      INTEGER node_count(Mxnode), tube_count(Mxtube)
      INTEGER nbr_nodes(Mxnode, NNOD), nbr_tubes(Mxnode, NNOD)
      INTEGER i_node, node_help, tube_help, j, k, l1, l2
      INTEGER test, test_t, help_node, test_h, tn, tt
      INTEGER counter, i, test_tube, nebrnode, error, warning
!     ------------------------------------------------------------------
C
      error = 0
      warning = 0
C     WRITE (Iout, *)
      WRITE (Iout, *) 'TESTING THE CONDUIT NETWORK:'
C
      DO i_node = 1, Mxnode
C--read neighbour nodes of node i_node in nbr_nodes(,)
        DO j = 1, NNOD
          nbr_nodes(i_node, j) = Nbr(i_node, (j+4))

          nbr_tubes(i_node, j) = Nbr(i_node, (j+4+NNOD))
        ENDDO
      ENDDO
c
c
c
C--TEST, IF NODENUMBER OR TUBENUIMBER IS HIGHER THAN MXNODE OR MXTUBE:
      DO i_node = 1, Mxnode
        DO j = 1, NNOD
          IF ( nbr_nodes(i_node,j).GT.Mxnode ) THEN
            WRITE (Iout, *) '    NODE WITH NODENUMEBR HIGHER THAN',     &
     &                      ' MXNODE NEIGHBOUR OF NODE ', i_node
            STOP
          ENDIF
          IF ( nbr_tubes(i_node,j).GT.Mxtube ) THEN
            WRITE (Iout, *) '    TUBE WITH TUBENUMBER HIGHER THAN',     &
     &                      ' MXTUBE AT NODE ', i_node
            STOP
          ENDIF
        ENDDO
      ENDDO
c 
C--test, if node number appears more than once or not at all:
      DO i = 1, Mxnode
        node_count(i) = 0
      ENDDO
      DO i_node = 1, Mxnode
        node_count(Nbr(i_node,1)) = node_count(Nbr(i_node,1)) + 1
      ENDDO
      DO i_node = 1, Mxnode
        IF ( node_count(i_node).EQ.0 ) THEN
          WRITE (Iout, *) '   NO NODE NR. ', i_node
          error = error + 1
        ENDIF
        IF ( node_count(i_node).GT.1 ) THEN
          WRITE (Iout, *) '   MORE THAN ONE NODE NR.', i_node
          error = error + 1
        ENDIF
      ENDDO
C--test, if tube number appears more than once:
      DO i = 1, Mxtube
        tube_count(i) = 0
      ENDDO
      DO i = 1, Mxnode
        DO j = 1, NNOD
          IF ( Nbr(i,j+4+NNOD).NE.0 ) tube_count(Nbr(i,(j+4+NNOD)))     &
     &         = tube_count(Nbr(i,(j+4+NNOD))) + 1
        ENDDO
      ENDDO
      DO i = 1, Mxtube
        IF ( tube_count(i).NE.2 ) THEN
          WRITE (Iout, *) '   TUBE NR: ', i, ' APPEARS ', tube_count(i),&
     &                    ' TIMES'
          error = error + 1
        ENDIF
      ENDDO
C
C--CHECK, IF EVERY NODE HAS A CONNECTING TUBE:
      DO i = 1, Mxnode
        DO j = 1, NNOD
          IF ( (Nbr(i,j+4).NE.0) .AND. (Nbr(i,j+4+NNOD).EQ.0) )         &
     &         WRITE (Iout, 9001) Nbr(i, j+4), j, i
          IF ( (Nbr(i,j+4).EQ.0) .AND. (Nbr(i,j+4+NNOD).NE.0) )         &
     &         WRITE (Iout, 9002) Nbr(i, j+4+NNOD), j, i
        ENDDO
      ENDDO
C
C--check for correct connection of nodes:
      DO i_node = 1, Mxnode
 
C--check if neighbour of i_node has i_node as neighbour
        DO j = 1, NNOD
          node_help = nbr_nodes(i_node, j)
C         WRITE (Iout, *) 'node_help: ', node_help
          IF ( node_help.NE.0 ) THEN
            test = 0
C--&&6
            DO k = 1, NNOD
              IF ( Nbr(node_help,k+4).EQ.i_node ) test = 1
C             WRITE (Iout, *) node_help, ' ', k, ' ',Nbr(node_help,k+4),&
C    &                        ' test: ', test
            ENDDO
            IF ( test.EQ.0 ) WRITE (Iout, *) '   NODE ', node_help,     &
     &                              ' MISSING NEIGHBOUR NODE ', i_node
          ENDIF
        ENDDO
C--check, if Itube at i_node is Itube at one Neighbour of i_node as well
C  j counts tubes at node i_node, l1 counts neighbours of node i_node,
C  l2 counts tubes at node l1
        DO j = 1, NNOD
          tube_help = nbr_tubes(i_node, j)
          IF ( tube_help.NE.0 ) THEN
            test_t = 0
            DO l1 = 1, NNOD
              help_node = nbr_nodes(i_node, l1)
              IF ( help_node.NE.0 ) THEN
                DO l2 = 1, NNOD
                  IF ( nbr_tubes(help_node,l2).EQ.tube_help ) test_t = 1
                ENDDO
              ENDIF
            ENDDO
            IF ( test_t.EQ.0 ) THEN
              WRITE (Iout, *) '   TUBE ', tube_help, ' AT NODE ',       &
     &                        i_node, ' MISSING SECOND NEIGHBOUR NODE'
              error = error + 1
            ENDIF
          ENDIF
        ENDDO
C--If node i_node is const. head, check if corresponding MODFLOW cell is
C     constant head as well.
        test_h = Ibound(Nbr(i_node,2), Nbr(i_node,3), Nbr(i_node,4))
        IF ( test_h.EQ.0 ) THEN
          WRITE (Iout, *) '   NODE', i_node, ' IN INACTIVE MODFLOW CELL'
          warning = warning + 1
        ENDIF
!rsr    IF ( Beghead(i_node).NE.-1.D0 ) THEN
        IF ( DABS(Beghead(i_node)+1.D0).GT.NEARZERO ) THEN
          IF ( test_h.EQ.1 ) THEN
            WRITE (Iout, 9003) i_node
            warning = warning + 1
          ENDIF
          IF ( test_h.EQ.0 ) THEN
            WRITE (Iout, 9004) i_node
            warning = warning + 1
          ENDIF
        ENDIF
      ENDDO
C
Cseba--CHECK, IF TUBE NUMBERS ARE ASSIGNED CORRECTLY. DOUBLE CHECK FOR
C      CONNECTING TUBES. FOR EACH NODE, TAKE NEIGHBOUR NODE, GET
C      CONNECTING TUBE, AND CHECK IF THE NEIGHBOUR NODE IS CONNECTED TO
C      THE ACTUAL NODE BY THE SAME TUBE:
      DO i = 1, Mxnode
        DO j = 1, NNOD
          IF ( Nbr(i,j+4).NE.0 ) THEN
C--GET TESTNODE AND TESTTUBE
            tn = Nbr(i, j+4)
            tt = Nbr(i, j+4+NNOD)
C--CROSS CHECK
            DO k = 1, NNOD
              IF ( Nbr(tn,k+4).EQ.i ) THEN
                IF ( Nbr(tn,k+4+NNOD).NE.tt ) THEN
                  WRITE (*, 9005) i, tn, tt, tn, i, Nbr(tn, k+4+NNOD)
                  error = error + 1
                ENDIF
              ENDIF
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C
Cseba--check, wether tubes are in the right column:
C--This is, what is happening in DETERM_TUB(..) by T.Clemens
C  Determine tube1(..)
      counter = 0
C INITIALISATION OF TUBE (= 0)
      DO i = 1, Mxtube
        DO j = 1, 5
          tube1(i, j) = 0
          tube2(i, j) = 0
        ENDDO
      ENDDO
C BEGIN DETERMINATION LOOP
      DO i = 1, Mxnode
        DO j = 1, NNOD
C  EXCLUDE NEBR()=0
          IF ( Nbr(i,j+4+NNOD).NE.0 ) THEN
C IF THERE IS NO ENTRY IN TUBE THEN ASSIGN
            IF ( tube1(Nbr(i,j+4+NNOD),1).EQ.0 ) THEN
C THERE IS TUBE
              IF ( Nbr(i,j+4+NNOD).NE.0 ) THEN
                tube1(Nbr(i,j+4+NNOD), 1) = Nbr(i, j+4+NNOD)
                tube1(Nbr(i,j+4+NNOD), 2) = i
                tube1(Nbr(i,j+4+NNOD), 3) = Nbr(i, j+4)
C INCREASE NUMBER OF TUBE
                counter = counter + 1
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDDO
C
C--check this:
C--search for tubes begins:
C  Determine tube2(..)
      DO i_node = 1, Mxnode
C--read neighbour nodes of node i_node in nbr_nodes(,)
        DO j = 1, NNOD
          nbr_nodes(i_node, j) = Nbr(i_node, (j+4))
          nbr_tubes(i_node, j) = Nbr(i_node, (j+4+NNOD))
        ENDDO
      ENDDO
      DO i_node = 1, Mxnode
C--check if neighbour of i_node has i_node as neighbour
        DO j = 1, NNOD
          node_help = nbr_nodes(i_node, j)
          IF ( node_help.NE.0 ) THEN
            test = 0
            DO k = 1, NNOD
              IF ( Nbr(node_help,k+4).EQ.i_node ) THEN
C--Found two neighbouring nodes, search for connecting tube:
                nebrnode = node_help
                test = test + 1
C               WRITE (Iout, *) 'i: ', i_node, ' nebr ', nebrnode,      &
C    &                          ' test: ', test
                test_tube = 0
                DO l1 = 1, NNOD
                  tube_help = nbr_tubes(i_node, l1)
                  IF ( tube_help.NE.0 ) THEN
                    DO l2 = 1, NNOD
C--Found connecting tube:
C                     WRITE (Iout, *) 'Tube: ', test_tube
                      IF ( tube_help.EQ.nbr_tubes(nebrnode,l2) )        &
     &                     test_tube = tube_help
                    ENDDO
                  ENDIF
                ENDDO
                IF ( test_tube.NE.0 ) THEN
C--write tube_help-line of tube2:
                  tube2(test_tube, 1) = test_tube
                  tube2(test_tube, 2) = nebrnode
                  tube2(test_tube, 3) = i_node
                ENDIF
              ENDIF
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C  compare tube1 and tube2:
      DO i = 1, Mxtube
        DO j = 1, 5
          IF ( tube1(i,j).NE.tube2(i,j) ) THEN
            WRITE (Iout, *) '   MISTAKE AT TUBE: ', tube1(i, j)
            error = error + 1
          ENDIF
        ENDDO
      ENDDO
C
      IF ( error.EQ.0 ) THEN
        WRITE (Iout, *) '   NO ERRORS DETECTED           `:) '
      ELSE
        WRITE (Iout, *) error, ' ERROR(S) DETECTED   :('
        WRITE (Iout, *) '   CHECK CONDUIT-GEOMETRY INPUT'
        STOP
      ENDIF
      IF ( warning.EQ.0 ) THEN
        WRITE (Iout, *) '   NO WARNINGS             `:)'
      ELSE
        WRITE (Iout, *) warning, ' WARNING(S) DETECTED `:|',            &
     &                  '    CHECK CONDUIT-GEOMETRY INPUT '
      ENDIF
C
 9001 FORMAT (4X, 'NODE', I5, ' (NEIBR. NODE NR.', I5, ') IN LINE', I5, &
     &        ' HAS NO CONNECTING TUBE')
 9002 FORMAT (4X, 'TUBE', I5, ' (NEIBR-TUBE NR', I5, ') IN LINE', I5,   &
     &        ' HAS NO NODE')
 9003 FORMAT (4X, 'CONSTANT HEAD NODE', I5,                             &
     &        ' OF CONDUIT NETWORK IS NOT CONSTANT-HEAD MODFLOW CELL')
 9004 FORMAT (4X, 'CONSTANT HEAD NODE', I5,                             &
     &        ' OF CONDUIT NETWORK IN INACTIVE MODFLOW CELL')
 9005 FORMAT (4X, 'NODE', I5, ' CONNECTED TO NODE', I5, ' BY TUBE', I5, &
     &        ' BUT NODE', I5, ' CONNECTED TO NODE', I5, ' BY TUBE', I5)

      END SUBROUTINE TEST_CONDUIT_NETWORK
C-------------------------------------------------------------------
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
! ======================================================================
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
      SUBROUTINE DETERM_TUB
C
C
C ------ VERSION 1 12APR1995 DETERM_TUB
C     *****************************************************************
C     ASSIGN TUBE (PIPE) NUMBERS WITH NODE NUMBERS
C     WITH SUPPORT OF NEIBR
C     *****************************************************************
C
C ------ INPUT
C MXNODE      NUMBER OF NODES
C MXTUBE      NUMBER OF TUBES
C NEIBR       ARRAY CONTAINING THE CONDUITSTRUCTUR:
C             NODE, NEIGHBOUR NODE  1, 2, 3, 4, TUBE NR. 1, 2, 3, 4, 
C             MODFLOWROW, -COLUMN
C more than 4 tubes each node: reset nnod
      USE GLOBAL, ONLY:Iout
      USE CFPMODULE, ONLY:NNOD, Mxnode, Mxtube, Nbr, Itube, Dtube, ZERO
      IMPLICIT NONE
C
C ------ OUTPUT
C TUBE        MATRIX WITH TUBENR., NODE_BEGIN, NODE_END 
C             Q m/s (BEGIN_NODE_PRESSUR > END_NODE_PRESSUR => Q >= 0),
C             CHEMIE: 0 NOT CALCULATED, 1 CALCULATED

! Local Variables
      INTEGER counter, i, j
!     ------------------------------------------------------------------
C
      WRITE (Iout, *) 'BEGINNING CFPM1 SUBROUTINE DETERM_TUB'
      counter = 0
C INITIALISATION OF TUBE (= 0)
      DO i = 1, Mxtube
        DO j = 1, 3
          Itube(i, j) = 0
        ENDDO
        DO j = 1, 2
          Dtube(i, j) = ZERO
        ENDDO
      ENDDO
c 
C BEGIN DETERMINATION LOOP
      DO i = 1, Mxnode
        DO j = 1, NNOD
C IF THERE IS NO ENTRY IN TUBE THEN ASSIGN
Cseba--EXCLUDE CASE NEIBR(,)=0
          IF ( Nbr(i,j+4+NNOD).NE.0 ) THEN
            IF ( Itube(Nbr(i,j+4+NNOD),1).EQ.0 ) THEN
C THERE IS TUBE
              IF ( Nbr(i,j+4+NNOD).NE.0 ) THEN
                Itube(Nbr(i,j+4+NNOD), 1) = Nbr(i, j+4+NNOD)
                Itube(Nbr(i,j+4+NNOD), 2) = i
                Itube(Nbr(i,j+4+NNOD), 3) = Nbr(i, j+4)
C INCREASE NUMBER OF TUBE
                counter = counter + 1
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDDO
c 
C VERIFY DETERMINATION OF TUBES
      IF ( counter.NE.Mxtube ) WRITE (*, *)                             &
     &                              '    Mistake by tube determination!'
      END SUBROUTINE DETERM_TUB
c-----------------------------------------------------------------------c
c      
! ======================================================================
C 
      SUBROUTINE GEOCALC
C
C  VERSION 1  13.12.1998
C*****************************************************************
C     3D - GEOMETRY  DETERMINED
C*****************************************************************
C
      USE GLOBAL, ONLY:Botm, Iout, Delr, Delc, Nlay
      USE CFPMODULE, ONLY:NNOD, Mxnode, Mxtube, Geohight, Node_loca,    &
     &    Nodetop, Nodebot, Con_data, Top, Nbr, TWO, ZERO
      IMPLICIT NONE
c
! Local Variables
      INTEGER i, j, topflag, errors, itest
      INTEGER i_node, nk_col, nk_row, nk_lay
      DOUBLE PRECISION xcol, xrow, xlay
cbarc**for computing average height of nodetop and nodebot
      DOUBLE PRECISION nodetopavg, nodebotavg, avgcount
!     ------------------------------------------------------------------
c
C    Geometry of nodes and tubes are determined
c 
      WRITE (Iout, *) 'BEGINNING CFPM1 SUBROUTINE GEOCALC THAT',        &
     &                ' CALCULATES XYZ COORDINATES OF NODES'
C
      WRITE (Iout, *) 'TOP-ARRAY / BOT-ARRAY:'
      DO i = 1, Nlay
        WRITE (Iout, *) Top(1, 1, i), '    ', Botm(1, 1, i)
      ENDDO
c 
      topflag = 0
      errors = 0
C
C--WRITE HEADER FOR NODE HEIGHTS:
      WRITE (Iout, *) ' NODE   COLUMN    ROW    LAY      X         Y   '&
     &                , '         Z      '
c 
C--FOR EVERY NODE
      DO i_node = 1, Mxnode
C--GET MODFLOW CELL COORDINATES
        nk_col = Nbr(i_node, 2)
        nk_row = Nbr(i_node, 3)
        nk_lay = Nbr(i_node, 4)
        xcol = ZERO
        xrow = ZERO
        xlay = ZERO
c 
        DO j = 1, nk_col
Cseba--Achtung: delc(nrow) und delr(ncol), anders als gedacht:
          IF ( j.EQ.1 ) THEN
            xcol = Delr(1)/TWO
          ELSE
            xcol = xcol + (Delr(j)+Delr(j-1))/TWO
          ENDIF
        ENDDO
        DO j = 1, nk_row
          IF ( j.EQ.1 ) THEN
            xrow = Delc(1)/TWO
          ELSE
            xrow = xrow + (Delc(j)+Delc(j-1))/TWO
          ENDIF
        ENDDO
C--DETERMINE GEOMETRICAL HIGHT OF CONDUIT NODES BY USING GEOHIGHT FROM
C  CONDUIT GEOMETRY INPUT FILE
        xlay = Geohight(i_node)
C
C-SAVE GEOMETRY DATA IN Node_loca
        Node_loca(i_node, 1) = i_node
        Node_loca(i_node, 2) = xcol
        Node_loca(i_node, 3) = xrow
        Node_loca(i_node, 4) = xlay
        WRITE (Iout, 9001) i_node, nk_col, nk_row, nk_lay, xcol, xrow,  &
     &                     xlay
c 
        IF ( Node_loca(i_node,4).LT.Botm(nk_col,nk_row,nk_lay) ) THEN
          errors = errors + 1
          WRITE (*, 9002) i_node, Node_loca(i_node, 4),                 &
     &                    Botm(nk_col, nk_row, nk_lay)
        ENDIF
cbarc***check to see if geohight of conduit is above top of layer 1.
        IF ( Geohight(i_node).GT.Top(nk_col,nk_row,nk_lay) ) THEN
          WRITE (Iout, *) 'error, geohight of node ', i_node,           &
     &                    ' is greater than the elevation of the top',  &
     &                    ' of the surrounding model cell ', nk_col,    &
     &                    nk_row, nk_lay
c 
          PRINT *, 'error, geohight of node ', i_node,                  &
     &          ' is greater than the elevation of the top of the',     &
     &          ' surrounding model cell ', nk_col, nk_row, nk_lay
          STOP
        ENDIF
c 
      ENDDO
C
      IF ( topflag.NE.0 ) WRITE (Iout, *)                               &
     &                            'NO TOP-ARRAY, USING LAY_THICK*alpha'
C
      IF ( errors.NE.0 ) THEN
        WRITE (Iout, *) ' ERRORS IN CONDUIT INPUT FILE. PROGRAM STOPS'
        STOP
      ENDIF
C
cbarc**compute nodetop and nodebot using average of heights of intersecting
cbarc**tube tops and bottoms.
c 
      DO i = 1, Mxnode
        nodetopavg = ZERO
        nodebotavg = ZERO
        avgcount = ZERO
        DO j = 1, NNOD
          itest = Nbr(i, j+4+NNOD)
          IF ( itest.NE.0 ) THEN
            nodetopavg = nodetopavg + Geohight(i)                       &
     &                   + (Con_data(itest,2)/TWO)
            nodebotavg = nodebotavg + Geohight(i)                       &
     &                   - (Con_data(itest,2)/TWO)
            avgcount = avgcount + 1
C         PRINT *, nodetopavg, nodebotavg, avgcount
          ENDIF
cbarc**enddo for nnod loop
        ENDDO
        Nodetop(i) = nodetopavg/avgcount
        Nodebot(i) = nodebotavg/avgcount
C       PRINT *, Nodetop(i), Nodebot(i)
c 
cbarc**enddo for mxnode loop
      ENDDO
c 
 9001 FORMAT (4I7, 4X, 3G12.6)
 9002 FORMAT ('!!ERROR. GEOMETRIC HIGHT OF CONDUIT NODE', I5, ' OF',    &
     &        G13.6, ' BELOW BOTTOM OF MODFLOW LAYER AT', G13.6)
c 
!     WRITE (Iout, 9003)
!9003 FORMAT ('   NODE', ' COL   ROW   LAY', 4X, 'X', 13X, 'Y', 11X,    &
!    &        'HEIGHT')
!9004 FORMAT (4I6, 3G14.6)
c 
      END SUBROUTINE GEOCALC
c 
! ======================================================================
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
      SUBROUTINE LENGTH_CAL
C
C -------- VERSION 1  22AUGUST1995  LENGTH_CAL
C       *******************************************************************
C       CALCULATE TUBE LENGTH WITH X-, Y-, and Z-VALUE  &&3d1
C       *******************************************************************
c
c
      USE CFPMODULE, ONLY:Con_data, Mxtube, Tortuos, Nbr, Node_loca,    &
     &    Itube, NEARZERO, TWO, ZERO
      USE GLOBAL, ONLY:Delr, Delc, Iout
C
      IMPLICIT NONE
C ------ INPUT:
C DELR          IS THE CELL WIDTH ALONG ROWS
C DELC          IS THE CELL WIDTH ALONG COLUMNS
C NCOL          IS THE NUMBER OF COLUMNS
C NROW          IS THE NUMBER OF ROWS
C TUBE          TUBENR., NODE_BEGIN, NODE_END
C               Q m/s (BEGIN_NODE_PRESSUR > END_NODE_PRESSUR => Q >= 0),
C               CHEMIE: 0 NOT CALCULATED, 1 CALCULATED
C NEIBR         NODENR., NEIGHBOURNODE  1, 2, 3, 4, TUBENR. 1, 2, 3, 4,
C               MODFLOWROW, -COLUMN
C               0 - THERE IS NO LINK TO THE NODE
C TORTUOS       CALCULATE A VALUE FOR THE TORTUOSITY OF EVERY TUBE
C ------ OUTPUT:
C CON_DATA      CONDUIT DATA WITH:
C               TUBENUMBER, DIAMETER, LENGTH, ROUGHNESS
c Nbr_LAY       number of layers
c LAY_THICK     thickness of layers
c
C
      INTRINSIC DSQRT
! Local Variables
      INTEGER i, j, x1, x2, y1, y2
!     INTEGER z1, z2
      DOUBLE PRECISION length, x, y, z, height1, height2
!     ------------------------------------------------------------------
      WRITE (Iout, *)
      WRITE (Iout, *) 'BEGINNING CFPM1 LENGTH_CAL SUBROUTINE'
 
      DO j = 1, Mxtube
        x = ZERO
        y = ZERO
        z = ZERO
        height1 = ZERO
        height2 = ZERO
C DETERMINE COORDINATE
Cseba--x=colum, y=row, z=lay
        x1 = Nbr(Itube(j,2), 2)
        y1 = Nbr(Itube(j,2), 3)
        x2 = Nbr(Itube(j,3), 2)
        y2 = Nbr(Itube(j,3), 3)
!       z1 = Nbr(Itube(j,2), 4)
!       z2 = Nbr(Itube(j,3), 4)
C ADD LENGTH IN X-DIRECTION
c
c
        IF ( x1.NE.x2 ) THEN
          x = (Delr(x1)+Delr(x2))/TWO
          IF ( x1-1.GT.x2 ) THEN
            DO i = x2 + 1, x1 - 1
              x = x + Delr(i)
            ENDDO
          ENDIF
          IF ( x2-1.GT.x1 ) THEN
            DO i = x1 + 1, x2 - 1
              x = x + Delr(i)
            ENDDO
          ENDIF
        ENDIF
C ADD LENGTH IN Y-DIRECTION
Cseba--Fehler: in y-Richtung muss er delc(row) nehmen:
        IF ( y1.NE.y2 ) THEN
          y = (Delc(y1)+Delc(y2))/TWO
          IF ( y1-1.GT.y2 ) THEN
            DO i = y2 + 1, y1 - 1
              y = y + Delc(i)
            ENDDO
          ENDIF
          IF ( y2-1.GT.y1 ) THEN
            DO i = y1 + 1, y2 - 1
              y = y + Delc(i)
            ENDDO
          ENDIF
        ENDIF
Cseba--ADD LENGTH IN Z-DIRECTION USING node_loca
        height1 = Node_loca(Itube(j,2), 4)
        height2 = Node_loca(Itube(j,3), 4)
c 
        IF ( height1.GT.height2 ) THEN
          z = height1 - height2
        ELSE
          z = height2 - height1
        ENDIF
C
C CALCULATE TOTAL LENGTH AFTER PYTHAGORAS
c
c
        length = DSQRT(x**TWO+y**TWO+z**TWO)
        Con_data(j, 3) = Tortuos(j)*length
c 
c
        IF ( Con_data(j,3).LT.NEARZERO ) WRITE (Iout, *)                &
     &        'WARNING!! TUBE ', j, ' HAS LENGTH ZERO !!'
!       WRITE (Iout, *) ('Length tube ', j, ' ', Con_data(j,3))
      ENDDO
      END SUBROUTINE LENGTH_CAL
C ---------------------------------------------------------------------
C----------------------------------------------------------------------- 
! ======================================================================
c----------------------------------------------------------------------- 
      SUBROUTINE ROUGH_CAL
C
C--THIS SUBROUTINE DETERMINES THE ROUGHNESS OF THE TUBE WALLS FROM THE
C  TUBE DIAMETER AND THE ROUGHNESS FACTOR, IF THAT IS < 0. ROUGHNESS
C  LENGTH IS THE TUBE_DIAMETER*(-1)*ROUGHNESS FACTOR.
C  ROUGHNESS FACTOR IS UPDATAD EVERY TIMESTEP
C
      USE GLOBAL, ONLY:Iout
      USE CFPMODULE, ONLY:Mxtube, Roughness, Con_data
c
      IMPLICIT NONE
      INTRINSIC DABS
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------
C
c
      WRITE (Iout, *) 'BEGINNING CFPM1 ROUGH_CAL SUBROUTINE'
 
      DO i = 1, Mxtube
        IF ( Roughness(i).LT.0.0D0 ) Con_data(i, 4) = Con_data(i, 2)    &
     &       *DABS(Roughness(i))
C       WRITE (*, *) ':: ', Roughness(i), Con_data(i,2), Con_data(i,4)
      ENDDO
C
      END SUBROUTINE ROUGH_CAL
C ---------------------------------------------------------------------
 
! ======================================================================
 
      SUBROUTINE CFPM1OCAR(Inunit)
C--------------------------------------------
cbarc**read and prepare for mode 1 (pipes) output control
C     NOTSNO  FREQUENCY OF TIME SERIES OUTPUT OF NODE DATA
C     NOTSTU  FREQUENCY OF TIME SERIES OUTPUT OF TUBE DATA
C     NNODES  NUMBER OF NODES TO WRITE TIME SERIES OUTPUT
C     NTUBES  NUMBER OF TUBES TO WRITE TIME SERIES OUTPUT
C     TSNO    NODE NUMBER FOR WHICH TSO IS REQUESTED
C     TSNODE  ARRAY DETERMING IF TSO IS WRITTEN FOR A NODE (NOT 0)
C             OR NOT (0), DIMENSION(MXNODE)
C     TSTU    TUBE NUMBER FOR WHICH TSO IS REQUESTED
C     TSTUBE  ARRAY DETERMING IF TSO IS WRITTEN FOR A TUBE (NOT 0)
C             OR NOT (0), DIMENSION(MXTUBE)
c
      USE GLOBAL, ONLY:Iout
c
      USE CFPMODULE, ONLY:Notsno, Notstu, Nnodes, Ntubes, Tsno, Tsnode, &
     &    Tstu, Tstube, Mxtube, Mxnode
      IMPLICIT NONE
      EXTERNAL EINTRD
c
! Arguments
      INTEGER, INTENT(IN) :: Inunit
! Local Variables
      INTEGER i, n, t
      CHARACTER*8 name
C--------------------------------------------

cbarc**allocate
      ALLOCATE (Notsno, Notstu, Nnodes, Ntubes, Tsno, Tstu)
      ALLOCATE (Tsnode(Mxnode), Tstube(Mxtube))
 

cbarc**read and write
C--WRITE MESSAGE
      WRITE (Iout, *) 'READING CONDUIT OUTPUT CONTROL FROM UNIT', Inunit
C--INITIALIZE TSNODE AND TSTUBE
      DO i = 1, Mxnode
        Tsnode(i) = 0
      ENDDO
      DO i = 1, Mxtube
        Tstube(i) = 0
      ENDDO
C--READ NNODES
      name = 'NNODES  '
      CALL EINTRD(Nnodes, Inunit, Iout, name)
C
C--READ TSNO
      DO n = 1, Nnodes
        name = 'TSNO    '
        CALL EINTRD(Tsno, Inunit, Iout, name)
        Tsnode(Tsno) = 1
      ENDDO
C
C--READ NOTSNO
      name = 'NOTSNO  '
      CALL EINTRD(Notsno, Inunit, Iout, name)
C
C--READ NTUBES
      name = 'NTUBES  '
      CALL EINTRD(Ntubes, Inunit, Iout, name)
C
C--READ TSTU
      DO t = 1, Ntubes
        name = 'TSTU    '
        CALL EINTRD(Tstu, Inunit, Iout, name)
        Tstube(Tstu) = 1
      ENDDO
C
C--READ NOTSTU
      name = 'NOTSTU  '
      CALL EINTRD(Notstu, Inunit, Iout, name)
C
c 
      END SUBROUTINE CFPM1OCAR
c======================================================================= 
! ======================================================================
c=======================================================================
C-----SUBROUTINE EINTRD
C
      SUBROUTINE EINTRD(Intno, In, Iout, Name)
C
C  VERSION1                    03FEB1999                          EINTRD
C***********************************************************************
C     READ LINE AND CONVERT TO A INTEGER NUMBER
C***********************************************************************
C
C INTNO    INTEGER NUMBER
C IN       UNIT NUMBER FROM WHICH INPUT FOR THIS PACKAGE WILL BE READ
C IOUT     UNIT NUMBER FOR ALL PRINTED OUTPUT
C ISTART   LOCATION FOR THE START OF THE NUMBER
C IEND     LOCATION FOR THE END OF THE NUMBER
C LINE     LINE FROM INPUT FILE
C NAME     NAME OF THE VARIABLE
C
      IMPLICIT NONE
c
! Arguments
      CHARACTER(LEN=8), INTENT(IN) :: Name
      INTEGER, INTENT(IN) :: In, Iout
      INTEGER, INTENT(OUT) :: Intno
! Local Variables
      CHARACTER(LEN=80) line
      INTEGER i, istart, iend
!     ------------------------------------------------------------------
      DO
C
C--READ A LINE; IGNORE BLANK LINES AND COMMENT LINES
        READ (In, '(A)', ERR=100) line
        IF ( line.NE.' ' ) THEN
          IF ( line(1:1).NE.'#' ) THEN
C--FIND START AND END OF NUMBER: CHARACTER THAT IS NOT A BLANK OR A COMMA
            istart = 0
            iend = 80
            DO i = 1, 80
              IF ( line(i:i).NE.' ' .AND. line(i:i).NE.',' .AND.        &
     &             istart.EQ.0 ) istart = i
              IF ( (line(i:i).EQ.' ' .OR. line(i:i).EQ.',') .AND.       &
     &             istart.NE.0 ) THEN
                iend = i
                EXIT
              ENDIF
            ENDDO
C--CONVERT LINE TO A INTEGER NUMBER
            READ (line(istart:iend), '(I5)', ERR=100) Intno
            WRITE (Iout, *) Name, Intno
            RETURN
          ENDIF
        ENDIF
      ENDDO
C
C--IF AN ERROR OCCURED
C
 100  WRITE (Iout, *) 'READ ERROR UNIT', In
      WRITE (Iout, *) 'PARAMETER ', Name
C
      END SUBROUTINE EINTRD
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE GWF2CFPM2_OC(Kkper)
C--------------------------------------------
      USE CFPMODULE, only:Mode, Turb_fr, Turb_ff, Tl_out, Ncl, Cl
      USE GLOBAL, only:Ncol, Nrow, Nlay
      IMPLICIT NONE
! Arguments
      INTEGER, INTENT(IN) :: Kkper
! Local Variables
      INTEGER i, ic, j
C--------------------------------------------
      IF ( Mode.EQ.1 ) RETURN
c 
cbarc**endif for work done only at end of first stress period.
      IF ( Kkper.EQ.1 ) OPEN (UNIT=999, FILE='turblam.txt',             &
     &                        STATUS='unknown')
c 
cbarc**initialize**
      Tl_out = 0
c 
cbarc**flow all laminar, tl_out=0
cbarc**only flow to right turbulent, tl_out=1
cbarc**only flow to front turbulent, tl_out=2
cbarc**flow to right and front turbulent, tl_out=3
c 
      DO ic = 1, Ncl
        DO i = 1, Nrow
          DO j = 1, Ncol
c 
cbarc**read**
            IF ( Turb_fr(j,i,Cl(ic)).EQ.0 .AND. Turb_ff(j,i,Cl(ic))     &
     &           .EQ.0 ) Tl_out(j, i, Cl(ic)) = 0
            IF ( Turb_fr(j,i,Cl(ic)).EQ.1 .AND. Turb_ff(j,i,Cl(ic))     &
     &           .EQ.0 ) Tl_out(j, i, Cl(ic)) = 1
            IF ( Turb_fr(j,i,Cl(ic)).EQ.0 .AND. Turb_ff(j,i,Cl(ic))     &
     &           .EQ.1 ) Tl_out(j, i, Cl(ic)) = 2
            IF ( Turb_fr(j,i,Cl(ic)).EQ.1 .AND. Turb_ff(j,i,Cl(ic))     &
     &           .EQ.1 ) Tl_out(j, i, Cl(ic)) = 3
          ENDDO
        ENDDO
      ENDDO
c 
cbarc**write out iturb codes
c 
      DO ic = 1, Ncl
        WRITE (999, '(a13,i3,1x,a5,i3,1x,a14)') 'stress period', Kkper, &
     &         'layer', Cl(ic), 'turbulent code'
        DO i = 1, Nrow
          WRITE (999, '(5000i3)') (Tl_out(j,i,Cl(ic)), j=1, Ncol)
        ENDDO
      ENDDO
cbarc2**
      END SUBROUTINE GWF2CFPM2_OC
c====================================================================== 
! ======================================================================
C--TIME SERIES OUTPUT------------------------------------------
c
      SUBROUTINE TS1OUT
CB**HCON IS B_MAT
CB**TUBREY IS TUB_REYNOLD
      USE CFPMODULE, ONLY:NNOD, Qbdir, Qtub, Tsnode, Tstube, B_mat,     &
     &    Qmat, Qfix, Con_data, Tub_reynold, Mxnode, Mxtube, Notsno,    &
     &    Notstu, Nstor, Nodebot, Dtube, Ktsno, Ktstu
c
      USE GLOBAL, ONLY:Iout
      USE GWFBASMODULE, ONLY:Totim

      IMPLICIT NONE
      INTRINSIC DABS
C
C     HCON    HEAD IN THE CONDUIT SYSTEM, DIMENSION(MXNODE)
C     KTSNO   COUNTER FOR TIME SERIES OUTPUT OF NODE DATA
C     KTSTU   COUNTER FOR TIME SERIES OUTPUT OF TUBE DATA
C     MRESNO  NUMBER OF PARAMETERS WRITTEN IN ARRAY RESNOD
C     MRESTU  NUMBER OF PARAMETERS WRITTEN IN ARRAY RESTUB
C     NAMNOD  NAMES OF PARAMETERS WRITTEN IN ARRAY RESNOD,
C                DIMENSION(MRESNO)
C     NAMTUB  NAMES OF PARAMETERS WRITTEN IN ARRAY RESTUB,
C                DIMENSION(MRESTU)
C     NOTSNO  FREQUENCY OF TIME SERIES OUTPUT OF NODE DATA
C     NOTSTU  FREQUENCY OF TIME SERIES OUTPUT OF TUBE DATA
C     QDIR    FLOW FROM DIRECT RECHARGE INTO NODE, DIMENSION(MXNODE)
C     QFIX    FLOW FROM FIXED HEAD INTO NODE, DIMENSION(MXNODE)
C     QMAT    FLOW FROM NODE INTO FISSURED SYSTEM, DIMENSION(MXNODE)
C     QTUB    FLOW FROM TUBES INTO NODE, DIMENSION(MXNODE,NNOD)
C     QTUBIN  SUM OF INFLOW FROM TUBES INTO NODE, DIMENSION(MXNODE)
C     QTUBOUT SUM OF OUTFLOW FROM NODES INTO TUBES, DIMENSION(MXNODE)
C     RESNOD  ARRAY CONTAINING RESULTS OF CHEMISTRY AND TRANSPORT
C                CALCULATION FOR THE NODES, DIMENSION(MXNODE,MRESNO)
C     RESTUB  ARRAY CONTAINING RESULTS OF CHEMISTRY AND TRANSPORT
C                CALCULATION FOR THE TUBES, DIMENSION(MXTUBE,MRESTU)
C     TOTIM   TOTAL TIME OF SIMULATION IN SEC
C     TSNODE  ARRAY DETERMING IF TSO IS WRITTEN FOR A NODE (NOT 0)
C             OR NOT (0), DIMENSION(MXNODE)
C     TSTUBE  ARRAY DETERMING IF TSO IS WRITTEN FOR A TUBE (NOT 0)
C             OR NOT (0), DIMENSION(MXTUBE)
C     TUBREY  REYNOLDS NUMBER OF TUBE, DIMENSION(MXTUBE)
C

! Local Variables

cbarc***here is where you can make output if #nodes and tubes > 9999

      INTEGER ncount, funit, tcount, t, n
      CHARACTER(LEN=12) fname
      CHARACTER(LEN=4) fno
!     ------------------------------------------------------------------
C
      IF ( Notsno.EQ.Ktsno ) THEN
        Ktsno = 0
        ncount = 0
        DO n = 1, Mxnode
          IF ( Tsnode(n).NE.0 ) THEN
            ncount = ncount + 1
            WRITE (fno, FMT='(I4.4)') n
            fname = 'NODE'//fno//'.OUT'
            funit = 200 + ncount
            IF ( Tsnode(n).GT.0 ) THEN
              Tsnode(n) = -1
              OPEN (funit, FILE=fname, STATUS='UNKNOWN', ERR=100)
              WRITE (Iout, *) 'TIME SERIES OUTPUT IN FILE ', fname
              WRITE (funit, 9001)
            ENDIF
cbarc**dry
c 
            IF ( B_mat(n).LE.Nodebot(n) ) THEN
              WRITE (funit, 9002) Totim, Nodebot(n), Qbdir(n), -Qmat(n),   &
     &                            (Qtub(n,t), t=1, NNOD), Nstor(n),     &
     &                            Qfix(n)
            ELSE
 
              WRITE (funit, 9002) Totim, B_mat(n), Qbdir(n), -Qmat(n),  &
     &                            (Qtub(n,t), t=1, NNOD), Nstor(n),     &
     &                            Qfix(n)
            ENDIF
c 
          ENDIF
        ENDDO
      ENDIF
      IF ( Notstu.EQ.Ktstu ) THEN
        Ktstu = 0
        tcount = 0
        DO t = 1, Mxtube
          IF ( Tstube(t).NE.0 ) THEN
            tcount = tcount + 1
            WRITE (fno, FMT='(I4.4)') t
            fname = 'TUBE'//fno//'.OUT'
            funit = 200 + ncount + tcount
            IF ( Tstube(t).GT.0 ) THEN
              Tstube(t) = -1
              OPEN (funit, FILE=fname, STATUS='UNKNOWN', ERR=100)
              WRITE (Iout, *) 'TIME SERIES OUTPUT IN FILE ', fname
              WRITE (funit, 9003)
            ENDIF

            WRITE (funit, 9004) Totim, DABS(Dtube(t,1)), Con_data(t, 2),&
     &                          Tub_reynold(t)
          ENDIF
        ENDDO
      ENDIF
      RETURN
 
 100  WRITE (Iout, *) 'ERROR WHILE OPENING UNIT', funit, ' (TS1OUT)!'
 
 9001 FORMAT ('   TOTIM (T)       HCON', 10X, 'QDIR', 10X, 'QMAT', 9X,  &
     &        'QTUB1', 9X, 'QTUB2', 9X, 'QTUB3', 9X, 'QTUB4', 9X,       &
     &        'QTUB5', 9X, 'QTUB6', 9X, 'NSTOR', 10X, 'QFIX', 20(A14))
 9002 FORMAT (F14.0, F14.8, 20(G14.6))
 9003 FORMAT ('   TOTIM (T)     FLOWRATE     DIAM.         RE', 21X,    &
     &        20(A14))
 9004 FORMAT (F14.0, 1X, 3G13.5, 20(G14.6))
 
      END SUBROUTINE TS1OUT
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE FLOW_OUTPUT(Kper, Kstp)
C ------ VERSION 1  6 DEZ 1998
C     *********************************************************
C     OUTPUT IN FILE RESULT
C     *********************************************************
C
CB** X0 IS B_MAT
CB**GEOTIMES IS DELT
CB**TOT_TIME IS TOTIM
      USE CFPMODULE, ONLY:NNOD, PII, Nbr, Con_data, Mxnode, Mxtube,     &
     &    Beghead, Epsilon, Itera_max, Turb, B_mat, Dtube, Itube, Konv, &
     &    Matflow, Tub_reynold, Qbdir, Node_loca, Geohight, Nodebot,    &
     &    Tortuos, Iters, NEARZERO, TWO, ZERO
c
      USE GLOBAL, ONLY:Hnew, Ncol, Nrow, Nlay, Iunit, Iout, Lenuni,     &
     &    Itmuni
      USE GWFBASMODULE, ONLY:Delt, Totim
c
      IMPLICIT NONE
      INTRINSIC DABS, DSQRT
C ------ INPUT:
C EPSILON CRITERION OF CONVERGENCE
C MXNODE  NUMBER OF NODES
C MXTUBE  NUMBER OF TUBES
C TURB  CONTAINS THE TYPE OF FLOW
C       0 - LAMINAR
C       1 - TURBULENT
C BEG_HEAD  CONTAINING THE HEADS READ FROM FILE
C NEIBR     ARRAY CONTAINING THE CONDUITSTRUCTUR:
C               NODE, NEIGHBOUR NODE  1, 2, 3, 4, TUBE NR. 1, 2, 3, 4,
C               MODFLOWROW, -COLUMN
C CON_DATA  CONDUIT DATA WITH:
C           TUBENUMBER, DIAMETER, LENGTH, ROUGHNESS
C MOD      EXCHANGE COEFFICIENT USED FOR EXCHANGE WITH MODFLOW
C X0       CALCULATED HEADPRESSURES
C KONV     FLAG: 1 - ITERATION CONVERGE
C                0 - NO CONVERGENCE
C ITERA_MAX  MAXIMUM OF ITERATIONSTEPS TO SOLVE THE EQUATIONSYSTEM
C S          NUMBER OF ITERATIONS FOR CALCULATION OF HEADS
C TUBE       TUBENR., NODE_BEGIN, NODE_END
C            Q m^3/s (BEGIN_NODE_PRESSUR > END_NODE_PRESSUR => Q >= 0),
C            CHEMIE: 0 NOT CALCULATED, 1 CALCULATED
C LSURFACEDEP  FLAG:  0 - CONSTANT EXCHANGE
C                     1 - SURFACE DEPENDENT EXCHANGE
C LOUTSTEP     INTERVAL OF OUTPUT STEP
C
C rep_cycle    NUMBER OF rep_cycle FOR THIS OUTPUT
C GEOTIMES     DURATION OF THE 'GEOMETRIC TIMESTEP' IN SECOND
C              OR A FLAG (= 0 THEN SET EQUAL DURATION OF TIMESTEP)
C IFOUT        UNIT NUMBER FOR FLOW OUTPUT
C KPER         CONTAINS THE NUMBER OF STRESSPERIOD FOR THE ACTUAL OUTPUT
C KSTP         CONTAINS THE NUMBER OF TIMESTEP FOT THE ACTUAL OUTPUT
C HNEW         MODFLOW NEW CALCULATED PRESSURE HEAD
C NCOL         IS THE NUMBER OF COLUMNS
C NROW         IS THE NUMBER OF ROWS
C NLAY         IS THE NUMBER OF LAYS
C MAT_DIR      STORE EXCHANGE COMING IN (> 0) OR OUT (< 0)
C              OF THE MATRIX
C
C ------ FLAGS READ BY CON1RP FROM FILE 'conduit_mod':
C HEAD_FLAG     - OUTPUT OF HEADS => kann entfernt werden (birk0799)
C FLOW_FLAG     - OUTPUT OF FLOW  => kann entfernt werden (birk0799)
C IUNIT           INPUT IUNITS (see MODFLOW instruction and README FILE)
C  JAN    IF JAN.EQ.0 FIRST CALL AND PRINT CONSTANT VALUES

! Arguments
      INTEGER, INTENT(IN) :: Kper, Kstp
! Local Variables
      INTEGER i, ic, il, ir, itest, j
      DOUBLE PRECISION taui, x, y, z, length
!     ------------------------------------------------------------------
C--SET VALUES
!     maxi = 0
!     tauimax = 0.D0
!     taucounter = 0
C--WRITE CONSTANT PAPRAMETERS JUST ONCE AT BEGINNING OF OUTPUT
c 
      WRITE (Iout, *)
      WRITE (Iout, *)
      WRITE (Iout, 9001) Epsilon
      WRITE (Iout, 9002) Itera_max
c
      WRITE (Iout, *)
      WRITE (Iout, *)
      WRITE (Iout, *) 'CFPM1 RESULTS ',                                 &
     &         '+++++++++++++++++++++++++++++++++++++++++++++++++++++++'
      WRITE (Iout, *)
      WRITE (Iout, *) 'STRESS PERIOD/TIME STEP', Kper, Kstp
c
      WRITE (Iout, *)
      WRITE (Iout, 9003) Iters
      IF ( Konv.EQ.0 ) WRITE (Iout, *) ' !! NO CONVERGENCE !'
      WRITE (Iout, *)
C
C OUTPUT OF HEADS IF HEAD_FLAG NOT EQUAL ZERO
      WRITE (Iout, *) '------- RESULTS OF FLOW CALCULATION -------'
      WRITE (Iout, *)
c
cbarc***change this based on lenuni and itmuni
c
cbarc**units are m SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9004)
cbarc**units are m MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9005)
cbarc**units are m HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9006)
cbarc**units are m DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9007)
cbarc**units are m YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9008)
c 
cbarc**feet**
cbarc**units are FT SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9009)
cbarc**units are FT MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9010)
cbarc**units are FT HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9011)
cbarc**units are FT DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9012)
cbarc**units are FT YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9013)
c 
cbarc**cm
cbarc**units are CM SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9014)
cbarc**units are CM MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9015)
cbarc**units are CM HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9016)
cbarc**units are CM DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9017)
cbarc**units are CM YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9018)
c 
      DO i = 1, Mxnode
        ic = Nbr(i, 2)
        ir = Nbr(i, 3)
        il = Nbr(i, 4)
C--DIFFERENT OUTPUT IF NODE IS DRY
        DO j = 1, NNOD
          itest = Nbr(i, j+4+NNOD)
cbarc**itest is a tube number !!!
          IF ( itest.NE.0 ) Nodebot = Geohight(i) - Con_data(itest, 2)  &
     &                                /TWO
        ENDDO
c 
cbarc**dry case
        IF ( B_mat(i).LE.Nodebot(i) ) THEN
c
!rsr      IF ( Beghead(i).EQ.-1.D0 ) THEN
          IF ( DABS(Beghead(i)+1.0D0).LT.NEARZERO ) THEN
            WRITE (Iout, 9019) i, Nodebot(i), Hnew(ic, ir, il),         &
     &                         Matflow(i), Qbdir(i)
          ELSE
            WRITE (Iout, 9020) i, Nodebot(i), Hnew(ic, ir, il),         &
     &                         Matflow(i), Qbdir(i)
          ENDIF
c 
cbarc**elseif to end dry case
!rsr    ELSEIF ( Beghead(i).EQ.-1.D0 ) THEN
        ELSEIF ( DABS(Beghead(i)+1.0D0).LT.NEARZERO ) THEN
          WRITE (Iout, 9019) i, B_mat(i), Hnew(ic, ir, il), Matflow(i), &
     &                       Qbdir(i)
        ELSE
          WRITE (Iout, 9020) i, B_mat(i), Hnew(ic, ir, il), Matflow(i), &
     &                       Qbdir(i)
        ENDIF
 
cbarc**enddo for mxnode
      ENDDO
 

      WRITE (Iout, *)
C
C--OUTPUT OF FLOW IF FLOW_FLAG NOT EQUAL ZERO
Cbirk0799     IF (flow_flag .NE. 0) THEN
 
cbarc**units are m SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9021)
cbarc**units are m MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9022)
cbarc**units are m HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9023)
cbarc**units are m DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9024)
cbarc**units are m YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.2 ) WRITE (Iout, 9025)
 
cbarc**ft units
cbarc**units are FT SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9026)
cbarc**units are FT MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9027)
cbarc**units are FT HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9028)
cbarc**units are FT DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9029)
cbarc**units are FT YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.1 ) WRITE (Iout, 9030)
 
cbarc**cm units
cbarc**units are CM SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9031)
cbarc**units are CM MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9032)
cbarc**units are CM HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9033)
cbarc**units are CM DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9034)
cbarc**units are CM YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.3 ) WRITE (Iout, 9035)
C
C--CALCULATE RESIDENCE TIME taui IN TUBE i: Pi*(d**2/4)*L in seconds
cbarc**need to modify for free surface cases ?
 
      DO i = 1, Mxtube
        IF ( Dtube(i,1).NE.0.0D0 ) THEN
cbarc
          x = DABS(Node_loca(Itube(i,2),2)-Node_loca(Itube(i,3),2))
          y = DABS(Node_loca(Itube(i,2),3)-Node_loca(Itube(i,3),3))
          z = DABS(Node_loca(Itube(i,2),4)-Node_loca(Itube(i,3),4))
          length = 1.0D0
cbarc**for cases of z=0
          IF ( z.LT.NEARZERO ) THEN
            IF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
              length = y
            ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
              length = x
            ELSE
              length = DSQRT(x**TWO+y**TWO)
            ENDIF
cbarc**for cases of z>0
          ELSEIF ( x.LT.NEARZERO .AND. y.GT.0.0D0 ) THEN
            length = DSQRT(y**TWO+z**TWO)
          ELSEIF ( x.GT.0.0D0 .AND. y.LT.NEARZERO ) THEN
            length = DSQRT(x**TWO+z**TWO)
          ELSE
            length = z
          ENDIF
c 
          taui = DABS((length*Tortuos(i))                               &
     &           /(Dtube(i,1)/(PII*(Con_data(i,2)/TWO)**TWO)))
  
        ELSE
          taui = ZERO
        ENDIF
c
C--CHECK WITH TIMESTEP-LENGTH
c
        IF ( taui.EQ.ZERO ) WRITE (Iout, 9036) i
c 
C
C--FLOW IS LAMINAR IN TUBE i
        IF ( Turb(i).EQ.0 ) THEN
C--SEBA FOR OUT
          WRITE (Iout, 9037) i, Itube(i, 2), Itube(i, 3), Dtube(i, 1),  &
     &                       (Con_data(i,j), j=2, 3), Tub_reynold(i),   &
     &                       taui
c 
        ELSE
c 
C--FLOW IS TURBULENT IN TUBE i
          WRITE (Iout, 9038) i, Itube(i, 2), Itube(i, 3), Dtube(i, 1),  &
     &                       (Con_data(i,j), j=2, 3), Tub_reynold(i),   &
     &                       taui
c 
        ENDIF
C

      ENDDO
C
c
C OUTPUT IF A FAILURE OCCURS
!     WRITE (Iout, *) 'ERROR WRITING FLOW RESULT TO OUTPUT FILE '
 
 9001 FORMAT (' CFPM1 CRITERION OF CONVERGENCE:', E18.7)
 9002 FORMAT (' CFPM1 MAXIMUM NUMBER OF ITERATIONS:', I6)
 9003 FORMAT ('NUMBER OF NEWTON RHAPSON ITERATIONS:', I6)
 9004 FORMAT ('NODE #    NODE HEAD[M]      POROUS MEDIA HEAD [M]',      &
     &        '  EXCHANGE FLOW [M^3/S]  DIRECT RECHARGE')
 9005 FORMAT ('NODE #    NODE HEAD[M]      POROUS MEDIA HEAD [M]',      &
     &        '  EXCHANGE FLOW[M^3/MIN] DIRECT RECHARGE')
 9006 FORMAT ('NODE #    NODE HEAD[M]      POROUS MEDIA HEAD [M]',      &
     &        '  EXCHANGE FLOW[M^3/HR]  DIRECT RECHARGE')
 9007 FORMAT ('NODE #    NODE HEAD[M]      POROUS MEDIA HEAD [M]',      &
     &        '  EXCHANGE FLOW [M^3/D]  DIRECT RECHARGE')
 9008 FORMAT ('NODE #    NODE HEAD[M]      POROUS MEDIA HEAD [M]',      &
     &        '  EXCHANGE FLOW [M^3/YR] DIRECT RECHARGE')
 9009 FORMAT ('NODE #    NODE HEAD[FT]      POROUS MEDIA HEAD [FT]',    &
     &        '  EXCHANGE FLOW [FT^3/SEC] DIRECT RECHARGE')
 9010 FORMAT ('NODE #    NODE HEAD[FT]      POROUS MEDIA HEAD [FT]',    &
     &        '  EXCHANGE FLOW [FT^3/MIN] DIRECT RECHARGE')
 9011 FORMAT ('NODE #    NODE HEAD[FT]      POROUS MEDIA HEAD [FT]',    &
     &        '  EXCHANGE FLOW [FT^3/HR] DIRECT RECHARGE')
 9012 FORMAT ('NODE #    NODE HEAD[FT]      POROUS MEDIA HEAD [FT]',    &
     &        '  EXCHANGE FLOW [FT^3/D] DIRECT RECHARGE')
 9013 FORMAT ('NODE #    NODE HEAD[FT]      POROUS MEDIA HEAD [FT]',    &
     &        '  EXCHANGE FLOW [FT^3/YR] DIRECT RECHARGE')
 9014 FORMAT ('NODE #    NODE HEAD[CM]      POROUS MEDIA HEAD [CM]',    &
     &        '  EXCHANGE FLOW [CM^3/SEC] DIRECT RECHARGE')
 9015 FORMAT ('NODE #    NODE HEAD[CM]      POROUS MEDIA HEAD [CM]',    &
     &        '  EXCHANGE FLOW [CM^3/MIN] DIRECT RECHARGE')
 9016 FORMAT ('NODE #    NODE HEAD[CM]      POROUS MEDIA HEAD [CM]',    &
     &        '  EXCHANGE FLOW [CM^3/HR] DIRECT RECHARGE')
 9017 FORMAT ('NODE #    NODE HEAD[CM]      POROUS MEDIA HEAD [CM]',    &
     &        '  EXCHANGE FLOW [CM^3/D] DIRECT RECHARGE')
 9018 FORMAT ('NODE #    NODE HEAD[CM]      POROUS MEDIA HEAD [CM]',    &
     &        '  EXCHANGE FLOW [CM^3/YR] DIRECT RECHARGE')
 9019 FORMAT (I6, G18.7, 8X, G16.7, 5X, G16.7, 3X, G16.7)
 9020 FORMAT (I6, G18.7, '(fixed) ', G16.7, 5X, G16.5, 3X, G16.7)
 9021 FORMAT ('TUBE  B  E  FLOW          Q [M^3/SEC]     DIAM.[M]', 8X, &
     &        'LEN.[M]        Re         RESIDENCE TIME [S]')
 9022 FORMAT ('TUBE  B  E  FLOW          Q [M^3/MIN]     DIAM.[M]', 8X, &
     &        'LEN.[M]        Re         RESIDENCE TIME [MIN]')
 9023 FORMAT ('TUBE  B  E  FLOW          Q [M^3/HR]      DIAM.[M]', 8X, &
     &        'LEN.[M]        Re         RESIDENCE TIME [HR]')
 9024 FORMAT ('TUBE  B  E  FLOW          Q [M^3/D]       DIAM.[M]', 8X, &
     &        'LEN.[M]        Re         RESIDENCE TIME [D]')
 9025 FORMAT ('TUBE  B  E  FLOW          Q [M^3/YR]      DIAM.[M]', 8X, &
     &        'LEN.[M]        Re         RESIDENCE TIME [YR]')
 9026 FORMAT ('TUBE  B  E  FLOW          Q [FT^3/SEC]     DIAM.[FT]',   &
     &        7X, 'LEN.[FT]       Re         RESIDENCE TIME [S]')
 9027 FORMAT ('TUBE  B  E  FLOW          Q [FT^3/MIN]     DIAM.[FT]',   &
     &        7X, 'LEN.[FT]       Re         RESIDENCE TIME [MIN]')
 9028 FORMAT ('TUBE  B  E  FLOW          Q [FT^3/HR]      DIAM.[FT]',   &
     &        7X, 'LEN.[FT]       Re         RESIDENCE TIME [HR]')
 9029 FORMAT ('TUBE  B  E  FLOW          Q [FT^3/D]       DIAM.[FT]',   &
     &        7X, 'LEN.[FT]       Re         RESIDENCE TIME [D]')
 9030 FORMAT ('TUBE  B  E  FLOW          Q [FT^3/YR]      DIAM.[FT]',   &
     &        7X, 'LEN.[FT]       Re         RESIDENCE TIME [YR]')
 9031 FORMAT ('TUBE  B  E  FLOW          Q [CM^3/SEC]     DIAM.[CM]',   &
     &        7X, 'LEN.[CM]       Re         RESIDENCE TIME [SEC]')
 9032 FORMAT ('TUBE  B  E  FLOW          Q [CM^3/MIN]     DIAM.[CM]',   &
     &        7X, 'LEN.[CM]       Re         RESIDENCE TIME [MIN]')
 9033 FORMAT ('TUBE  B  E  FLOW          Q [CM^3/HR]      DIAM.[CM]',   &
     &        7X, 'LEN.[CM]       Re         RESIDENCE TIME [HR]')
 9034 FORMAT ('TUBE  B  E  FLOW          Q [CM^3/D]       DIAM.[CM]',   &
     &        7X, 'LEN.[CM]       Re         RESIDENCE TIME [D]')
 9035 FORMAT ('TUBE  B  E  FLOW          Q [CM^3/YR]      DIAM.[CM]',   &
     &        7X, 'LEN.[CM]       Re         RESIDENCE TIME [YR]')
 9036 FORMAT (4X, 'WARNING! TUBE', I5, ' ACTIVE BUT NO FLOW')
 9037 FORMAT (I3, I4, I4, '   lami. ', 5F15.5)
 9038 FORMAT (I3, I4, I4, '   turb. ', 5F15.5)
c 
      END SUBROUTINE FLOW_OUTPUT
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE BUDGET_OUTPUT(Kper, Kstp)
C
C ------ VERSION 1 22MAR1996   BUDGET_OUTPUT
C     ********************************************************
C       OUTPUT OF CONDUIT BUDGET
C     ********************************************************
      USE CFPMODULE, ONLY:Ku_in_mat, Ku_out_mat, Ku_qbdir, Bud_source,  &
     &    Bud_sink, Mxnode, Bud_matin, Bud_matout, Bud_qbdir,           &
     &    Total_budget, Bud_total_step, Ts_in_mat, Ts_out_mat,          &
     &    Ts_bud_sink, Ts_bud_source, Ts_qbdir, Ts_in, Ts_out, Diff_tot,&
     &    Diff_ts, Tot_flow, Ts_tot_flow, Bud_storage_in,               &
     &    Ts_bud_storage_in, Bud_storage_out, Ts_bud_storage_out
c
cbarc***could replace iout with different unit number**
      USE GLOBAL, ONLY:Iout
      USE GWFBASMODULE, ONLY:Vbvl, Vbnm, Totim
c
      IMPLICIT NONE
C
C
C ------ INPUT
C MXNODE        NUMBER OF NODES
C KU_IN_MAT     CUMULATIVE FLOW IN THE MATRIX
C KU_OUT_MAT    CUMULATIVE FLOW OUT OF THE MATRIX
C KU_QBDIR      CUMULATIVE FLOW RATE DIRECTLY IN CONDUIT
C BUD_SOURCE    FLOW OF SOURCE
C BUD_SINK      FLOW OF SINK = FLOW OUT OF THE CONDUIT SYSTEM
C IOUT          UNIT NUMBER FOR OUTPUT TO LISTING FILE
C BUD_MATIN     TOTAL FLOW IN CONDUIT SYSTEM COMING FROM MATRIX
C BUD_MATOU     TOTAL FLOW IN MATRIX
C BUD_QBDIR     TOTAL DIRECT INFLOW IN CONDUIT SYSTEM
C VOL_CONDUIT_BEGIN   VOLUME OF THE CONDUIT SYSTEM BEFOR DISSOLUTION
C VOL_CONDUIT_END     VOLUME OF THE CONDUIT SYSTEM AFTER DISSOLUTION
C BUDGET_FLAG   OUTPUT FLAG OF BUDGET
c
C
C ------ INTERNALE VARIABLE:
C I             INDEX
C TOTAL_BUDGET   TOTAL FLOW DIFFERENCE
C PERCENT_BUDGET PERCENT OF TOTAL FLOW DIFFERENCE
! Arguments
      INTEGER, INTENT(IN) :: Kper, Kstp
!     ------------------------------------------------------------------
c
Cseba--WRITE CONDUIT BUDGET
c 
      WRITE (Iout, *)
      WRITE (Iout, 9001) Kstp, Kper
      WRITE (Iout, *) ' TOTAL SIMULATION TIME', Totim, 's'
      WRITE (Iout, *)
C
      WRITE (Iout, *)                                                   &
     &             '      CUMULATIVE VALUES (L**3)           RATES THIS'&
     &             , ' TIME STEP (L**3/T)'
c 
CBARC-------------------IN
      WRITE (Iout, 9002) 
      WRITE (Iout, 9003) Bud_source, Ts_bud_source 
      WRITE (Iout, 9004) Bud_qbdir, Ts_qbdir 
      WRITE (Iout, 9005) DABS(Bud_matin), DABS(Ts_in_mat)
c 
cbarc**need to add storage
      WRITE (Iout, 9006) DABS(Bud_storage_in), DABS(Ts_bud_storage_in)
C
      WRITE (Iout, 9007) Ts_in
c
CBARC-------------------OUT
c 
      WRITE (Iout, 9008) 
      WRITE (Iout, 9009) DABS(Bud_sink), DABS(Ts_bud_sink)
      WRITE (Iout, 9010) DABS(Bud_matout), DABS(Ts_out_mat)
c 
cbarc**need to add storage
      WRITE (Iout, 9011) DABS(Bud_storage_out), DABS(Ts_bud_storage_out)
C
      WRITE (Iout, 9012) Ts_out
C
C
      WRITE (Iout, 9013) Diff_tot, Diff_ts
      WRITE (Iout, 9014) (Diff_tot/Tot_flow*100.D0),                    &
     &                   (Diff_ts/Ts_tot_flow*100.D0)
C--PRINT WARNING IF BUDGET IS WRONG
      IF ( (Diff_ts/Ts_tot_flow).GE.0.0001 ) WRITE (Iout, *)            &
     &      ' WARNING! ', 'PIPE  BUDGET WRONG BY MORE THAN 0.0001 !'
C
C
cb    WRITE (Iout, *) 'Fehler1 beim Schreiben der Datei "result"!'
      RETURN
c 
 9001 FORMAT (/, 4X, 'BUDGET OF THE PIPE SYSTEM OF TIMESTEP', I5,       &
     &        ' IN STRESS PERIOD', I5, /, 72('-'), /)
 9002 FORMAT (/, 11X, ' IN:', 31X, 'IN:')
 9003 FORMAT (5X, 'CONSTANT HEAD =', G16.8, 6X, 'CONSTANT HEAD =',      &
     &        G16.8)
 9004 FORMAT (5X, 'PIPE RECHARGE =', G16.8, 6X, 'PIPE RECHARGE =',      &
     &        G16.8)
 9005 FORMAT (3X, 'MATRIX EXCHANGE =', G16.8, 4X, 'MATRIX EXCHANGE =',  &
     &        G16.8)
 9006 FORMAT (11X, 'STORAGE =', G16.8, 12X, 'STORAGE =', G16.8)
 9007 FORMAT (47X, 'TOTAL IN =', G16.8)
 9008 FORMAT (/, 11X, 'OUT:', 31X, 'OUT:')
 9009 FORMAT (5X, 'CONSTANT HEAD =', G16.8, 6X, 'CONSTANT HEAD =',      &
     &        G16.8)
 9010 FORMAT (3X, 'MATRIX EXCHANGE =', G16.8, 4X, 'MATRIX EXCHANGE =',  &
     &        G16.8)
 9011 FORMAT (11X, 'STORAGE =', G16.8, 12X, 'STORAGE =', G16.8)
 9012 FORMAT (46X, 'TOTAL OUT =', G16.8)
 9013 FORMAT (/, 10X, 'IN - OUT =', G16.8, 11X, 'IN - OUT =', G16.8)
 9014 FORMAT (5X, 'PERCENT ERROR =', G16.8, 6X, 'PERCENT ERROR =',      &
     &        G16.8, //)
c 
      END SUBROUTINE BUDGET_OUTPUT
C
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE NWBOUT(Kper, Kstp)
C--OUTPUT OF NODE WATER BUDGET------------------------------------
C
      USE CFPMODULE, ONLY:Mxnode, Qmat, Qtubin, Qtubout, Qfix, Qbdir,   &
     &    Nodin, Nodout, Nstor
c
      USE GLOBAL, ONLY:Iout, Lenuni, Itmuni
      USE GWFBASMODULE, ONLY:Totim
c
      IMPLICIT NONE
! Arguments
      INTEGER, INTENT(IN) :: Kper, Kstp
! Local Variables
      INTEGER n
cb-----------------------------------------------------------------
c
C--WRITE HEADING AND TIME INFORMATION
      WRITE (Iout, *)
      WRITE (Iout, *)                                                   &
     &'------------------------NODE WATER BUDGET-----------------------'
c
      WRITE (Iout, *) ' STRESS PERIOD', Kper, ' TIME STEP', Kstp
c 
cbarc**some changes here for units conversions
      WRITE (Iout, *) 'TOTAL SIMULATION TIME', Totim
      WRITE (Iout, *)
c 
cbarc**units are m SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.2 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN M^3/S'
cbarc**units are m MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.2 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN M^3/min'
cbarc**units are m HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.2 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN M^3/hr'
cbarc**units are m DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.2 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN M^3/d'
c
cbarc**units are m YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.2 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN M^3/yr'
c 
cbarc**units are FT SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.1 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN ft^3/s'
cbarc**units are FT MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.1 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN ft^3/min'
cbarc**units are FT HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.1 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN ft^3/hr'
c 
cbarc**units are FT DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.1 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN ft^3/d'
cbarc**units are FT YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.1 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN ft^3/yr'
c
c 
cbarc**units are CM SEC
      IF ( Itmuni.EQ.1 .AND. Lenuni.EQ.3 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN cm^3/s'
cbarc**units are CM MIN
      IF ( Itmuni.EQ.2 .AND. Lenuni.EQ.3 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN cm^3/min'
cbarc**units are CM HOURS
      IF ( Itmuni.EQ.3 .AND. Lenuni.EQ.3 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN cm^3/hr'
cbarc**units are CM DAYS
      IF ( Itmuni.EQ.4 .AND. Lenuni.EQ.3 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN cm^3/d'
cbarc**units are CM YEAR
      IF ( Itmuni.EQ.5 .AND. Lenuni.EQ.3 ) WRITE (Iout, *)              &
     &      'FLOW TO THE NODE IN cm^3/yr'
c 
      WRITE (Iout, *)
C--WRITE NODE WATER BUGDGET
cbarc**need to add storage here
      WRITE (Iout, 9001)
c
cbarc**need to add storage here
      DO n = 1, Mxnode
c 
c
        WRITE (Iout, 9002) n, Qfix(n), Qbdir(n), -Qmat(n), Nstor(n),    &
     &                     Qtubin(n), Qtubout(n), (Nodin(n)-Nodout(n))
      ENDDO
 
 9001 FORMAT (' NODE  FIXED H.         RECHARGE        MATRIX', 9X,     &
     &        'STORAGE        TUBE_IN         TUBE_OUT        IN - OUT')
 9002 FORMAT (I3, 2X, 7G16.8)
C
      END SUBROUTINE NWBOUT
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE GWF2CFP1RP(Inrch)
c      
! ----------------------------------------------------------------------
!     CONDUIT RP PROCEDURE
! ----------------------------------------------------------------------
      USE CFPMODULE, ONLY:Mode, Ktsno, Ktstu
      IMPLICIT NONE
      EXTERNAL CFP1RCH1RP
! Arguments
      INTEGER, INTENT(IN) :: Inrch
!***********************************************************************
      IF ( Mode.NE.2 ) THEN
        Ktsno = 0
        Ktstu = 0
      ENDIF
      IF ( Inrch.GT.0 ) CALL CFP1RCH1RP(Inrch)
      END SUBROUTINE GWF2CFP1RP
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE CFP1RCH1RP(Inunit)
C
C--VERSION 3 30JAN1999   RCHCONRD
C*********************************************************************
C  READ FACTOR FOR RECHARGE INPUT IN CONDUIT
C*********************************************************************
      USE CFPMODULE, ONLY:Mxnode, Qcondir, Iflag_rech
      USE GLOBAL, ONLY:Iout
c
      IMPLICIT NONE
C ------ INPUT:
C MXNODE     NUMBER OF NODES
C IN         PRIMARY UNIT NUMBER FROM WHICH INPUT FOR THIS PACKAGE
C            WILL BE READ
C IOUT       PRIMARY UNIT NUMBER FOR ALL OUTPUT
c
C
C ------ OUTPUT:
C RECH_FACT  FACTOR FOR TOTALRECHARGE GOING IN CONDUITSYSTEM
C QCONDIR    ARRAY OF MXNODE ELEMENTS CONTAINING THE FACTOR FOR FLOW
C            COMING FROM RECHARGE IN THE CONDUIT SYSTEM
c
! Arguments
      INTEGER, INTENT(IN) :: Inunit
! Local Variables
      INTEGER i, id
      CHARACTER(LEN=80) cdummy
!     ------------------------------------------------------------------
      WRITE (Iout, *)
      WRITE (Iout, *) 'CFP1RCH1RP SUBROUTINE READING FROM UNIT ', Inunit
 
C--OMIT ONE LINE OF TEXT
      READ (Inunit, '(a)', ERR=200, END=100) cdummy
C--READ STRESS PERIOD NUMBER
      READ (Inunit, *, END=100, ERR=300) Iflag_rech
C
C--READ WEIGHTING FOR DIRECT INFLOW IN THE NODES
      IF ( Iflag_rech.EQ.-1 ) THEN
C--REUSE DATA FROM LAST STRESS PERIOD (DO NOTHING)
        WRITE (Iout, *) '    REUSING DATA FROM LAST STRESS PERIOD'
      ELSE
        WRITE (Iout, *) '    READING INPUT USED TO PARTICIAN RECHARGE'
        DO i = 1, Mxnode
          READ (Inunit, *, END=100, ERR=300) id, Qcondir(i)
          IF ( id.NE.i ) WRITE (*, *) 'ERROR,WRONG NODE IN CRCH PACKAGE'
        ENDDO
      ENDIF
C--CHECK qcondir
      WRITE (Iout, 9001) (Qcondir(i), i=1, Mxnode)
      RETURN
C
 100  WRITE (Iout, *) '    File type "CRCH" not found or protected!'
      RETURN
 200  WRITE (Iout, *) ' READ ERROR CONDUIT INPUT FILE. WRONG DATA TYPE',&
     &                'COMMENT LINE EXPECTED, INSTEAD READ: ', cdummy
      STOP
 300  WRITE (Iout, *) ' READ ERROR CONDUIT INPUT FILE. WRONG DATA TYPE',&
     &                'DATA LINE EXPECTED. LAST COMMENT LINE: ', cdummy
      STOP
 9001 FORMAT (15G7.2E1)
C
      END SUBROUTINE CFP1RCH1RP
C ------------------------------------------------------------
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE GWF2CFP1AD(Kkper, Kkstp)
C ----------------------------------------------------------------------
C--VERSION 4 30JAN1999    RECHCOND1
C     CONDUIT AD PROCEDURE
C ----------------------------------------------------------------------
      USE CFPMODULE, ONLY:Mode, Ktsno, Ktstu
!     USE CFPMODULE, ONLY:Kcwb, Kflow
      IMPLICIT NONE
      EXTERNAL CFP1DCRCH, EXCHANG_CAL
! Arguments
      INTEGER, INTENT(IN) :: Kkper, Kkstp
!***********************************************************************
C Advance counters
      IF ( Mode.NE.2 ) THEN
!      related to CFP output control
        Ktsno = Ktsno + 1
        Ktstu = Ktstu + 1
      ENDIF
 
C DISTRIBUTE RECHARGE IN CONDUIT AND MATRIX SYSTEM
      !rsr?? need to make this work with UZF
cb      IF ( Incfprch.GT.0 .AND. Mode.NE.2 )                              &
cb     &     CALL CFP1DCRCH(Kkper, Kkstp)
c 
C Compute exchange between porous media and pipe conduits
      IF ( Mode.NE.2 ) CALL EXCHANG_CAL(Kkper, Kkstp)
c 
      END SUBROUTINE GWF2CFP1AD
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE CFP1DCRCH(Kkper, Kkstp,iurch)
C
C--VERSION 4 30JAN1999    RECHCOND1
C     ********************************************************************
C     DISTRIBUTE RECHARGE IN CONDUIT AND FISSURED SYSTEM
C     ********************************************************************
      USE GLOBAL, ONLY:Ibound, Ncol, Nrow, Nlay, Iout
      USE CFPMODULE, ONLY:Mxnode, Mxtube, Nbr, Beghead, Qcondir, Qbdir, &
     &    Qcondirold, Iflag_rech, Qbdirold, Qbdirsave, ZERO
      !rsr?? need to make this work with UZF
      USE GWFRCHMODULE, ONLY:Rech, Inrech

      IMPLICIT NONE
! Arguments
      INTEGER, INTENT(IN) :: Kkper, Kkstp
! Local Variables
      INTEGER i, ic, il, ir, iurch
C ------ INPUT:
C MXNODE      NUMBER OF NODES
C QCONDIR     ARRAY OF MXNODE ELEMENTS CONTAINING THE FACTOR FOR WEIGHTING
C             OF THE RECHARGE FLOW INTO THE CONDUITSYSTEM
 
C IFLAG_RECH  FLAG IF THERE AREN'T NEW RECHARGE DATA: -1
C INRECH      FLAG FOR NEW MODFLOW DATA
C RECH_FACT   FACTOR OF DIRECT FLOW IN CONDUITSYSTEM:
C             RECH_CON = RECH_FACT * RECHARGE
c 
C ------ INTERNALE VARIABLES:
C TOTAL_RECHARGE  TOTAL RECHARGE OVER THE WHOLE AREA
c 
C ------ OUTPUT:
C RECH          RECHARGE FLOW RATE. (FLOW RATE INJECTED DIRECTLY INTO THE
C               CONDUITS MUST BE REMOVED HERE!)
C QBDIR         FLOW RATE INJECTED DIRECTLY INTO CONDUIT
C RECH_CON      TOTAL FLOW OF RECHARGE IN CONDUIT SYSTEM
C RECH_MAT      TOTAL RECHARGE IN MATRIX
C BUDGET_RECH   TOTAL RECHARGE AFTER DISTRIBUTION
C
C--IF THERE ARE NEW RECHARGE DATA IN EITHER MODFLOW (INRECH > 0) OR
C  CONDUIT (iflag_rech > 0) AND IT IS THE FIRST TIMESTEP OF THE
C  STRESS PERIOD AND THE FIRST WD-ITERATION:
c 
cbarc**if RCH inactive, set these
      if(iurch.eq.0) then        
       Qbdirold=0                
       do i=1,Mxnode             
        Qbdir(i)= 0.0            
        Qbdirsave(i)= 0.0        
       enddo                     
       return                    
      endif                      

      IF ( (Iflag_rech.NE.-1 .OR. Inrech.NE.-1) .AND. Kkstp.EQ.1 ) THEN
C--CALCULATE  RECHARGE TO MODFLOW CELLS WITH CONDUIT NODES
        DO i = 1, Mxnode
          ic = Nbr(i, 2)
          ir = Nbr(i, 3)
          il = Nbr(i, 4)
          Qbdirold = Qbdir(i)
C--RESET rech TO VALUE BEFORE QBDIR OF LAST TIMESTEP WAS SUBSTRACTED, IF
C  THERE ARE NEW QCONDIR DATA
C--MAKE qcondir(i) = 1.0 POSSIBLE BY CONSIDERING IT.
          IF ( (Inrech.EQ.-1) .AND. (Qcondirold(i).LT.1.0D0) ) THEN
            Rech(ic, ir) = Rech(ic, ir)/(1.0D0-Qcondirold(i))
          ELSEIF ( (Inrech.EQ.-1) .AND. (Qcondirold(i).EQ.1.0D0) ) THEN
            Rech(ic, ir) = Qbdir(i)
CBARC2**NEED THIS ENDIF
          ENDIF
CBARC2**
          Qbdir(i) = ZERO
c
C--IF MODFLOW CELL IS NOT CONSTANT HEAD
          IF ( Ibound(ic,ir,il).GE.0 ) THEN
C--NO RECHARGE IS GIVEN TO CONST. HEAD NODE OF CONDUIT
C--GIVE RECHARGE TO NODE i
            Qbdir(i) = Qcondir(i)*Rech(ic, ir)
            Qbdirsave(i) = Qbdir(i)
C--SUBSTRACT DIRECT RECHARGE TO CONDUIT SYSTEM FROM RECHARGE IN MATRIX
            Rech(ic, ir) = (1.0D0-Qcondir(i))*Rech(ic, ir)
          ENDIF
        ENDDO
C
        DO i = 1, Mxnode
          Qcondirold(i) = Qcondir(i)
        ENDDO
C
      ENDIF
C
      END SUBROUTINE CFP1DCRCH
C----------------------------------------------------------------------
c======================================================================= 
! ======================================================================
c==========MODE 2 HERE GWF2CFPM2FM====================================== 
c==========Version 1.0 November 2007====================================
      SUBROUTINE GWF2CFPM2FM(Kkiter, Kkstp, Kkper)
cbarc*************************************************************************
      USE GLOBAL, ONLY:Iout, Ncol, Nrow, Nlay, Hold, Botm, Cr, Cc, Hnew,&
     &    Delr, Delc
c
      USE CFPMODULE, Only:Mode, Ncl, Cl, Twater, Denswa, Viscwa,        &
     &    Lcritrey, Tcritrey, Void, Turb_fr, Turb_ff, Klam_Cr, Klam_Cc,
     &   Crt, Cct
c
cbarc*************************************************************************
      IMPLICIT NONE
      INTRINSIC DSQRT, DABS
c
! Arguments
      !rsr, Kkiter, Kkstp, Kkper not used
      INTEGER, INTENT(IN) :: Kkiter, Kkstp, Kkper
! Local Variables
celk  leave Fadj in code 
      DOUBLE PRECISION hdiff, length, dhcrit_lt, dhcrit_tl, thk, Klam, 
     &                 area, Fadj

      INTEGER i, ic, j, k
!     ------------------------------------------------------------------
      IF ( Mode.EQ.1 ) RETURN
c 
cbarc**set laminar conductances and initial turb conductance in Cct and Crt
c
      if(Kkstp.eq.1.and.Kkiter.eq.1.and.Kkper.eq.1) then
       do j=1,ncol
	  do i=1,nrow
	   do k=1,nlay
	      klam_Cr(j,i,k) = Cr(j,i,k)
	       Crt(j,i,k) = klam_Cr(j,i,k)
	      klam_Cc(j,i,k) = Cc(j,i,k)
	       Cct(j,i,k) = klam_Cc(j,i,k)
         enddo
	  enddo
	 enddo
      endif
c
cbaarc**set turbulence flags to zero
      DO j = 1, Ncol
        DO i = 1, Nrow
          DO k = 1, Nlay
            Turb_fr(j, i, k) = 0
            Turb_ff(j, i, k) = 0
          ENDDO
        ENDDO
      ENDDO
 
cbarc**here**
cbarc&elk**modify CC and CR if flow is turbulent and store in Cct and Crt
CBARC**remember upper and lower critical head differences control transition between 
cbarc**laminar and turbulent flow
celk  Even though dhcrit is a constant we are recalculating rather than storing.
celk  Users have had memory issues for some problems (stack overflow).
celk  May optimize later after more users test code and see if slow runs are a bigger
celk  problem than memory allocation.
      DO ic = 1, Ncl
        DO i = 1, Nrow
          DO j = 1, Ncol
c
cbarc**Flow to right*****************************************************
cbarc**don't do this for last column 
            IF ( j.EQ.Ncol ) EXIT
cbarc**set length
            length = (Delr(j)+Delr(j+1))/2
            thk = Botm(j, i, Cl(ic)-1) - Botm(j, i, Cl(ic))
            area = thk*Delc(i)
c
            Klam=(Klam_Cr(j,i,Cl(ic))*length)/area
c            
cbarc**compute upper and lower critical head differences
celk dhcrit is correct along row 1 from benchmark computation             
            dhcrit_lt = (Tcritrey(ic)*Viscwa*length)/
     &                  (Void(ic)*Klam)

            dhcrit_tl = (Lcritrey(ic)*Viscwa*length)/
     &                  (Void(ic)*Klam)
c
cbarc**compute hdiff for flow to right
            hdiff = Hold(j, i, Cl(ic)) - Hold(j+1, i, Cl(ic))
cbarc**force hdiff positive
            hdiff = DABS(hdiff)
c            
cbarc**Qlam to Qturb-----------------------------------------------
            IF(Turb_fr(j, i, Cl(ic)).eq.0) THEN
               IF ( hdiff.ge.dhcrit_lt ) THEN
cbarc**set turbulence flag
                Turb_fr(j, i, Cl(ic)) = 1
cbarc**compute turbulent CR
	Fadj=DSQRT((Klam_Cr(j,i,Cl(ic))*dhcrit_lt)/
     &(Crt(j,i,Cl(ic))*hdiff))
       Cr(j, i, Cl(ic)) = Fadj*Klam_Cr(j, i, Cl(ic))
	 Crt(j,i,Cl(ic)) = Cr(j, i, Cl(ic))
celk crt array added to store turbulent conductance to use on next iteration
CBARC**ENDIF FOR IF ( hdiff.gt.dhcrit_lt ) 
              ENDIF 
CBARC**ENDIF FOR IF(Turb_fr(j, i, cl(ic)).eq.0)
            ENDIF 
cbarc**Qturb to Qlam------------------------------------------------
            IF(Turb_fr(j, i, cl(ic)).eq.1) THEN

             IF ( hdiff.LT.dhcrit_tl ) THEN
                Cr(j, i, Cl(ic)) = Klam_Cr(j, i, Cl(ic))
                Turb_fr(j, i, Cl(ic)) = 0
             ENDIF
cbarc2**endif for IF(Turb_fr(j, i, k).eq.1) statement
            ENDIF 

cbarc**enddo for j loop
          ENDDO
cbarc**jump to here if j.eq.ncol
cbarc**enddo for i loop

        ENDDO
c 
cbarc**Flow to front**
cbarc**Flow to front****************************************************
c 
        DO i = 1, Nrow
          DO j = 1, Ncol
cbarc**exit if last row
            IF ( i.EQ.Nrow ) EXIT
c 
cbarc**set length
            length = (Delc(i)+Delc(i+1))/2
            thk = Botm(j, i, Cl(ic)-1) - Botm(j, i, Cl(ic))
            area = thk*Delr(j)
celk calc Klam [L/T] for dhcrit calculations
            Klam=(Klam_Cc(j,i,Cl(ic))*length)/area

            dhcrit_lt = (Tcritrey(ic)*Viscwa*length)/ 
     &                  (Void(ic)*Klam)

            dhcrit_tl = (Lcritrey(ic)*Viscwa*length)/
     &                  (Void(ic)*Klam)

            hdiff = Hold(j, i, Cl(ic)) - Hold(j, i+1, Cl(ic))
c 
cbarc**force hdiff positive
            hdiff = DABS(hdiff)
cbarc**Qlam to Qturb--------------------------------------------------
            IF(Turb_ff(j, i, cl(ic)).eq.0) THEN

              IF ( hdiff.ge.dhcrit_lt ) THEN
CBARC**SET TURBULENCE FLAG
               Turb_ff(j, i, Cl(ic)) = 1
cbarc&elk**make modification to CC
      Fadj=DSQRT((Klam_Cc(j,i,Cl(ic))*dhcrit_lt)/
     &(Cct(j,i,Cl(ic))*hdiff))
       Cc(j, i, Cl(ic)) = Fadj*Klam_Cc(j, i, Cl(ic))
	 Cct(j,i,Cl(ic)) = Cc(j,i,Cl(ic))
CBARC**ENDIF STATEMENT FOR IF ( hdiff.gt.dhcrit_lt )
celk  cct array used to store turbulent conductance for next iteration
             ENDIF
CBARC**ENDIF STATEMENT FOR IF IF(Turb_ff(j, i, cl(ic)).eq.0)
            ENDIF
c
cbarc**Qturb to Qlam--------------------------------------------------
            IF ( Turb_ff(j,i,Cl(ic)).EQ.1 ) THEN
c
              IF ( hdiff.LT.dhcrit_tl ) THEN
                Cc(j, i, Cl(ic)) = Klam_Cc(j, i, Cl(ic))
                Turb_ff(j, i, Cl(ic)) = 0
              ENDIF
cbarc**endif for if(Turb_ff(j, i, k).eq.1) statement
            ENDIF            
c 
cbarc**enddo for j loop
          ENDDO
cbarc**enddo for i loop
        ENDDO
cbarc**goto here if i.eq.nrow
c 
cbarc***enddo for ic loop
      ENDDO
c 
      END SUBROUTINE GWF2CFPM2FM
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE EXCHANG_CAL(Kper, Kstp)
c
C ------ VERSION 1 3AUG1995   EXCHANG_CAL     &&epikarst
C     **********************************************************
C     CALCULATE THE EXCHANGE BETWEEN CONDUIT AND FISSURED-SYSTEM
C     DEPENDING ON TUBE DIAMETER AND LENGTH:2*pi * d/2 * L  
C     **********************************************************
C
      USE CFPMODULE, ONLY:Nodetop, Geohight, Nodebot, B_mat, B, Hc,     &
     &    B_mat_o, Nbr, Con_data, Mxnode, Lsurfacedep, Activenode, PII, &
     &    NNOD, Mod2, Modd, Node_loca, Tortuos, NEARZERO, TWOPII, TWO,  &
     &    ONE8TH, ZERO

      USE GLOBAL, ONLY:Iout, Hnew

      IMPLICIT NONE
      INTRINSIC DABS, DSQRT, SIN, ASIN
C ------ INPUT:
C MXNODE      NUMBER OF NODES
C MXTUBE      NUMBER OF TUBES
C LSURFACEDEP         FLAG:  0 - CONSTANT EXCHANGE
C                    1 - SURFACE DEPENDENT EXCHANGE

C CON_DATA    CONDUIT DATA WITH:
C                     TUBENUMBER, DIAMETER, LENGTH, ROUGHNESS
C MODD        EXCHANGE COEFFICIENT 
C PI          MATHEMATICAL CONSTANT  
c alpha   depends on conduit geometry
c Af      surface of exchange between conduits and porous media
c
c
C ------ INTERNALE VARIABLE:
! Arguments
      INTEGER, INTENT(IN) :: Kper, Kstp
! Local Variables
      INTEGER i, itest, j
      DOUBLE PRECISION alpha, x, y, z, length, af, at, dknot, theta
      DOUBLE PRECISION nodewettd
c
!     ------------------------------------------------------------------
C--INITIALIZE
      alpha = ZERO
      af = ZERO
      at = ZERO
c 
      DO i = 1, Mxnode
        Mod2(i) = ZERO
        IF ( Kper.EQ.1 .AND. Kstp.EQ.1 ) THEN
          Hc(i) = B_mat(i)
        ELSE
          Hc(i) = B(i)
        ENDIF
cbarc**enddo for mxnode loop
      ENDDO
c 
C
C--CALCULATE FOR EVERY NODE THE EXCHANGE COEFFICIENT
      DO i = 1, Mxnode
cbarc**no surface-area dependance for matrix exchange
cb-------------------------------------------------------
        IF ( Lsurfacedep.EQ.0 ) THEN
          WRITE (Iout, *)                                               &
     &                   'SURFACE-AREA DEPENDENT EXCHANGE IS NOT ACTIVE'

cbarc**set the partially full scaler to 1.0 
          af = 1.0D0

          DO j = 1, NNOD
            itest = Nbr(i, j+4+NNOD)
            IF ( itest.NE.0 ) THEN
              alpha = 1.0D0

              Nodebot(i) = Geohight(i) - Con_data(itest, 2)/TWO
c 
              IF ( Hc(i).LE.Nodebot(i) ) THEN
cbarc**if modflow head is <= nodebot then exchange is zero
                IF ( Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)).LE.Nodebot(i) )   &
     &               THEN
                  af = 0.0D0
                  alpha = 0.0D0
c 
                ENDIF
cbarc**endif for dry condition
              ENDIF
cbarc**endif for itest statement
            ENDIF
cbarc**enddo for nnod loop
          ENDDO
c 
cbarc**else surface-area dependent exchange is active
        ELSE
c 
C--alpha SURFACEDEPENDENT:-------------------------------------------------
          WRITE (Iout, *) 'SURFACE-AREA DEPENDENT EXCHANGE IS ACTIVE'
          alpha = ZERO
          af = ZERO
          DO j = 1, NNOD
            itest = Nbr(i, j+4+NNOD)
cbarc**NEIGHBOR CHECK
            IF ( itest.EQ.0 ) CYCLE
            Nodetop(i) = Geohight(i) + Con_data(itest, 2)/TWO
            Nodebot(i) = Geohight(i) - Con_data(itest, 2)/TWO
cbarc**determine length (L)
            x = DABS(Node_loca(i,2)-Node_loca(Nbr(i,j+4),2))
            y = DABS(Node_loca(i,3)-Node_loca(Nbr(i,j+4),3))
            z = DABS(Node_loca(i,4)-Node_loca(Nbr(i,j+4),4))
            length = 1.0D0
cbarc**for cases of z=0
            IF ( z.LT.NEARZERO ) THEN
              IF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
                length = y/TWO
              ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
                length = x/TWO
              ELSE
                length = DSQRT(x**TWO+y**TWO)/TWO
              ENDIF
cbarc**for cases of z>0
            ELSEIF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
              length = DSQRT(y**TWO+z**TWO)/TWO
            ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
              length = DSQRT(x**TWO+z**TWO)/TWO
            ELSE
              length = z
            ENDIF
c 
cbarc**fully-submerged cases**
cb------------------------------------------------------------
cb------------------------------------------------------------
            IF ( Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)).GE.Nodetop(i) ) THEN
cbarc**fully, partially, and dry conduits get full exchange because conduit
cbarc**is fully submerged in modflow cell.
              af = 1.0D0
              alpha = PII*length*Tortuos(itest) + alpha
            ENDIF
c 
cbarc**partially-submerged cases**
cb------------------------------------------------------------
cb------------------------------------------------------------
            IF ( Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)).LT.Nodetop(i) .AND.   &
     &           Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)).GT.Nodebot(i) ) THEN
c 
cbarc**fully-saturated conduit
              IF ( Hc(i).GE.Nodetop(i) ) THEN
                af = 1.0D0
                alpha = PII*length*Tortuos(itest) + alpha
              ENDIF
cbarc**partially saturated conduit
              IF ( Hc(i).LT.Nodetop(i) .AND. Hc(i).GT.Nodebot(i) ) THEN
                IF ( Hc(i).GE.Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)) ) THEN
                  nodewettd = Hc(i) - Nodebot(i)
                  dknot = Con_data(itest, 2)
                  theta = TWO*ASIN                                      &
     &                    (TWO*DSQRT((dknot/TWO)**TWO-(nodewettd-       &
     &                    dknot/TWO)**TWO)/dknot)
                  IF ( Hc(i).GE.Geohight(i) ) theta = TWOPII - theta
                  at = PII*Con_data(itest, 2)*
     &                 0.5*(length*Tortuos(itest))
                  af = ((ONE8TH*(theta-SIN(theta))*dknot**TWO*
     &                   0.5*(length*Tortuos(itest)))/at)
 
                  alpha = PII*length*Tortuos(itest)+ alpha
cbarc**else modflow head>hc
                ELSE
                  nodewettd = Hnew(Nbr(i,2), Nbr(i,3), Nbr(i,4))        &
     &                        - Nodebot(i)
                  dknot = Con_data(itest, 2)
                  theta = TWO*ASIN                                      &
     &                    (TWO*DSQRT((dknot/TWO)**TWO-(nodewettd-       &
     &                    dknot/TWO)**TWO)/dknot)
                  IF ( Hc(i).GE.Geohight(i) ) theta = TWOPII - theta
                  at = PII*Con_data(itest, 2)*
     &                 0.5*(length*Tortuos(itest))
                  af = ((ONE8TH*(theta-SIN(theta))*dknot**TWO*
     &                   0.5*(length*Tortuos(itest)))/at)
 
                  alpha = PII*length*Tortuos(itest) + alpha
c 
cbarc**endif for if(hc(i).ge.hnew(nbr(i,2),nbr(i,3),nbr(i,4)) statement
                ENDIF
c 
cbarc**endif for partially-saturated conduit**
              ENDIF
cbarc**endif for partially-sumberged cases
            ENDIF
cbarc**perched-conduit cases**
cb------------------------------------------------------------
cb------------------------------------------------------------
            IF ( Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)).LT.Nodebot(i) ) THEN
cbarc**fully-saturated conduit**
              IF ( Hc(i).GE.Nodetop(i) ) THEN
                af = 1.0D0
                alpha = PII*length*Tortuos(itest) + alpha
              ENDIF
cbarc**partially-saturated conduit**
              IF ( Hc(i).LT.Nodetop(i) .AND. Hc(i).GT.Nodebot(i) ) THEN
                nodewettd = Hc(i) - Nodebot(i)
                dknot = Con_data(itest, 2)
                theta = TWO*ASIN                                        &
     &                  (TWO*DSQRT((dknot/TWO)**TWO-(nodewettd-         &
     &                  dknot/TWO)**TWO)/dknot)
                IF ( Hc(i).GE.Geohight(i) ) theta = TWOPII - theta
                at = PII*Con_data(itest, 2)*
     &               0.5*(length*Tortuos(itest))
                af = ((ONE8TH*(theta-SIN(theta))*dknot**TWO*
     &                 0.5*(length*Tortuos(itest)))/at)
 
                alpha = PII*length*Tortuos(itest) + alpha
c 
cb              PRINT *, nodewettd, theta, at, af, alpha
c 
              ENDIF
c 
            ENDIF
c 
CBARC**ENDDO FOR NEIGHBOR CHECK
          ENDDO
CBARC**ENDIF FOR SURFACE AREA-DEPENDENT MATRIX EXCHANGE
        ENDIF
c 
        Mod2(i) = af*alpha*Modd(i)
c
cb       PRINT *, af, alpha, Mod2(i)
c 
CBARC**ENNDO FOR MXNODE LOOP
      ENDDO
c 
      END SUBROUTINE EXCHANG_CAL
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE GWF2CFP1M1FM(Kkiter, Kkper, Kkstp, Iflg)
c
C --------------------------------------------------------------C
C--COMMENT ON CONDUIT()
C       CONDUIT CALCULATES CONDUIT FLOW IN CONDUIT-NETWORK.
C       SUBROUTINE EXCHANG_CAL() CALCULATES THE EXCHANGE TERM FOR EXCHANGE
C       WITH MODFLOW. THIS IS EITHER THE INPUT VALUE, OR A DIAMETER-DEPENDENT
C       VALUE DETERMINED IN THE SUBROUTINE.
C       IF THERE ARE ONLY LAMINAR TUBES, A LAMINAR PRECALCULATION IS DONE, AND
C       THE HEADS CALCULATED THERE ARE TAKEN AS STARTING VALUES FOR SUBROUTINE
C       ITERA_NEW. THSI LAMIAR CALCULATION INVOLVES SETTING UP OF THE LINEAR
C       EQUATION SYSTEM WITH GLLAM() AND SOLVING IT BY THE ROUTINES LUDCMP() 
C       AND LUBSB(). HEADS FROM THE LAMINAR PRECALCULATION ARE RETURNED IN 
C       VECTOR B_MAT. 
C       IF THERE ARE TURBULENT TUBES, THE HEADS FROM THE LAST TIMESTEP,
C       WICH ARE SAVED IN VECTOR HEAD_SAVE, ARE USED AS STARTING HEADS.
C       NEXT TURB_RE2() IS CALLED, WICH DETERMINES FROM THE HEADS IF THE TUBES
C       ARE LAMINAR-FLOW OR TURBULENT-FLOW.
C       ITERA_NEW() BUILDS AND SOLVES THE EQUATION SYSTEM FOR TURBULENT AND/OR
C       LAMINAR FLOW CONDITIONS BY A NEWTON-RAPHSON ITERATION.
C       CON1FM() DETERMINES THE EXCHANGE FLUX WITH THE MODFLOW-MATRIX AND
C       RESETS HCOF AND RHS FOR THE MODFLOW ITERATION.
C       THE CALCULATED HEADS FROM ITERA_NEW ARE STORED IN HEAD_SAVE.
C-------------------------------------------------------------------------------
c
      USE CFPMODULE, ONLY:Mxtube, Turb, Nbr, B, B_mat, Nu, Mod2, Konv,  &
     &    Activenode, Modd, Index1, Head_save, G, PII, Epsilon, B_mat_o,&
     &    NEARZERO, Eq_mat, Mode
!     USE CFPMODULE, ONLY:Kflow, Noflow
c
      USE GLOBAL, ONLY:Iout
c
      IMPLICIT NONE
      INTRINSIC DABS
c
      EXTERNAL VECNORM, GLLAM, LUDCMP, LUBKSB, VEKTOR_CHANGE, TURB_RE2
      EXTERNAL ITERA_NEW, CON1FM
c
! Arguments
      INTEGER, INTENT(IN) :: Kkiter, Kkper, Kkstp, Iflg
      DOUBLE PRECISION tubelam, d
!     ------------------------------------------------------------------
c
      IF ( Mode.EQ.2 ) RETURN
c
C--IF ALL TUBES LAMINAR, MAKE A LAMINAR PRECALCULATION. IF A TUBE IS
C  ALREADY TURBULENT, SKIP THIS PRECALCULATION:
      CALL VECNORM(Turb, Mxtube, tubelam)
c 
      IF ( DABS(tubelam).LT.NEARZERO ) THEN
        WRITE (Iout, *) ' LAMINAR PRECALCULATION'
C--DETERMINE THE SYSTEM OF EQUATIONS FOR LAMINAR FLOW
c 
        CALL GLLAM
c 
C--SOLVE THE LINEAR EQUATION SYSTEM
C  FOR EXPLANATION SEE PRESS ET AL. CAMBRIDGE PRESS 1992
        CALL LUDCMP(Eq_mat, Activenode, Activenode, Index1, d)
        CALL LUBKSB(Eq_mat, Activenode, Activenode, Index1, B_mat)
C--HEADS FROM LAMINAR PRECALCULATION ARE THUS STORED IN B_MAT AND
C  GIVEN TO ITERA_NEW AS STARTING HEADS FOR ITERATION
      ELSE
c 
C--STORE HEADS FROM LAST TIMESTEP IN B_MAT AS STARTING HEADS FOR ITERA_NEW
        CALL VEKTOR_CHANGE(Head_save, B_mat, Activenode)
      ENDIF
c 
C--DETERMINE FOR EVERY TUBE IF FLOW IS TURBULENT
cbarc**modified for free surface and dry
      CALL TURB_RE2
c 
C--SOLVE SYSTEM OF NONLINEAR EQUTIONS BY NEWTON-RAPHSON ITERATION
cbarc**modified for free surface and dry
      CALL ITERA_NEW(Kkiter)
C
C--SUBSTRACT FLOW IN CONDUIT SYSTEM FROM MODFLOW IF ITERATION CONVERGED
      IF ( Konv.EQ.1 ) THEN
        CALL CON1FM
C
C--SAVE HEADS AS STARTING HEADS FOR NEXT ITERATION STEP
        CALL VEKTOR_CHANGE(B, Head_save, Activenode)
c 
      ENDIF
c 
      IF ( Kkper.EQ.1 .AND. Kkstp.EQ.1 ) B_mat_o = B_mat
c
      IF ( Iflg.EQ.2 ) THEN
        IF ( Konv.NE.1 ) THEN
          WRITE (Iout, *)
          WRITE (Iout, *) '!WARNING. NO CONVERGENCE IN CONDUIT IN STEP',&
     &                    Kkstp, ', PERIOD', Kkper
        ENDIF
cbarc**IF MODFLOW DID NOT CONVERGE:
!       IF ( ICNVG.EQ.0 .OR. KONV.NE.1 ) THEN
!         Kflow = Noflow
!         Kcwb  = Nocwb
!       ENDIF
      ENDIF
c
      END SUBROUTINE GWF2CFP1M1FM
c=======================================================================
! ======================================================================
c======================================================================= 
Cseba--------------------------------
      SUBROUTINE VECNORM(Vec, N, Norm)
C  calculates norm of a vector vec:
C  norm = SQRT( SUMM(i): vec[i]**2)
      IMPLICIT NONE
      INTRINSIC DSQRT
! Arguments
      INTEGER, INTENT(IN) :: N
      INTEGER, INTENT(IN) :: Vec(N)
      DOUBLE PRECISION, INTENT(OUT) :: Norm
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------
c
      Norm = 0.0D0
      DO i = 1, N
        Norm = Norm + Vec(i)**2.0D0
      ENDDO
      Norm = DSQRT(Norm)
C
      END SUBROUTINE VECNORM
c=======================================================================
! ======================================================================
c======================================================================= 
      SUBROUTINE GLLAM
C ---------- VERSION 2 19JULY1999 GLLAM
C **************************************************************
C SET UP THE SYSTEM OF EQUATIONS FOR LAMINAR FLOW
C **************************************************************
c
      USE CFPMODULE, ONLY:Nbr, Con_data, Beghead, B_mat, Nu, Eq_mat, G, &
     &    Activenode, PII, NNOD, Mod2, Nodetop, Modd, Qbdir, ZERO,      &
     &    NEARZERO
c
      USE GLOBAL, ONLY:Iout, Hnew, Ibound
c
      IMPLICIT NONE
      INTRINSIC DABS
! Local Variables
      DOUBLE PRECISION c
      INTEGER i, j, tub
!     ------------------------------------------------------------------
cbarc**mat is starting flow
cbarc**b_mat is starting head
c 
      DO i = 1, Activenode
        DO j = 1, Activenode
          Eq_mat(i, j) = ZERO
        ENDDO
cbarc**try setting initial head as elevation of top of node
cb      B_mat(i) = 0.0D0
        B_mat(i) = Nodetop(i)
      ENDDO
 
      c = PII*G/(128.D0*Nu)
C
      DO i = 1, Activenode
C--IF NODE HAS A VARIABLE PRESSURE HEAD
C--ASSIGN THE NODE ENTRIES
C--ADD FLOW OF ALL TUBES AT NODE I WHICH ARE ACTIVE
c
!rsr    IF ( Beghead(i).EQ.-1.D0 ) THEN
        IF ( DABS(Beghead(i)+1.D0).LT.NEARZERO ) THEN
          DO j = 1, NNOD
            IF ( Nbr(i,j+4).EQ.0 ) CYCLE
            tub = Nbr(i, j+4+NNOD)
            Eq_mat(i, Nbr(i,j+4)) = Eq_mat(i, Nbr(i,j+4))               &
     &                            - c*Con_data(tub, 2)                  &
     &                            **4.D0/Con_data(tub, 3)
            Eq_mat(i, i) = Eq_mat(i, i) - Eq_mat(i, Nbr(i,j+4))
cbarc**enddo for nnod loop
          ENDDO
c 
C--     EXCHANGE COMING FROM MODFLOW ONLY IF MODFLOW CELL IS ACTIVE
CBARC** AND MODFLOW HEAD >= CONDUIT BOTTOM
cbarc**free surface and dry cases already accounted for here by exchang_cal(iout)


          IF ( Ibound(Nbr(i,2),Nbr(i,3),Nbr(i,4)).NE.0 ) Eq_mat(i, i)   &
     &         = Eq_mat(i, i) + Mod2(i)
c 
C--DIRECT FLOW INTO CONDUIT SYSTEM COMING FROM RECHARGE
cbarc**else statement for IF ( Beghead(i).EQ.-1 ) THEN
        ELSE
C--NODE WITH CONSTANT HEADPRESSURE
          Eq_mat(i, i) = 1.0D0
          B_mat(i) = Beghead(i)
c 
cbarc**endif statement for IF ( Beghead(i).EQ.-1 ) THEN
        ENDIF
c 
cbarc**enddo for i=1,Activenode loop
      ENDDO
C
      END SUBROUTINE GLLAM
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE LUDCMP(A, N, Np, Indx, D)
! ----------------------------------------------------------------------
C     W. H. Press, S. A. Teukolsky, W. T. Vetterling
C     &  B. P. Flannery
C     Numerical Recipes in Fortran 1992
! ----------------------------------------------------------------------
      USE CFPMODULE, ONLY:NEARZERO, ZERO
      IMPLICIT NONE
      INTRINSIC DABS
! Arguments
      INTEGER, INTENT(IN) :: N, Np
      DOUBLE PRECISION, INTENT(INOUT) :: A(Np, Np)
      DOUBLE PRECISION, INTENT(OUT) :: Indx(N), D
! Local Variables
      INTEGER i, j, k, imax
      DOUBLE PRECISION dum, aamax, tot, vv(Np)
!     ------------------------------------------------------------------
c
      D = 1.D0
      DO i = 1, N
        aamax = ZERO
        DO j = 1, N
          IF ( DABS(A(i,j)).GT.aamax ) aamax = DABS(A(i,j))
        ENDDO
c 
        IF ( aamax.EQ.ZERO ) THEN
Cseba     PAUSE 'Singular matrix.'
          PRINT *, 'Singular Matrix', i
          STOP
        ENDIF
        vv(i) = 1.D0/aamax
      ENDDO
      DO j = 1, N
        IF ( j.GT.1 ) THEN
          DO i = 1, j - 1
            tot = A(i, j)
            IF ( i.GT.1 ) THEN
              DO k = 1, i - 1
                tot = tot - A(i, k)*A(k, j)
              ENDDO
              A(i, j) = tot
            ENDIF
          ENDDO
        ENDIF
        aamax = ZERO
        DO i = j, N
          tot = A(i, j)
          IF ( j.GT.1 ) THEN
            DO k = 1, j - 1
              tot = tot - A(i, k)*A(k, j)
            ENDDO
            A(i, j) = tot
          ENDIF
          dum = vv(i)*DABS(tot)
          IF ( dum.GE.aamax ) THEN
            imax = i
            aamax = dum
          ENDIF
        ENDDO
        IF ( j.NE.imax ) THEN
          DO k = 1, N
            dum = A(imax, k)
            A(imax, k) = A(j, k)
            A(j, k) = dum
          ENDDO
          D = -D
          vv(imax) = vv(j)
        ENDIF
        Indx(j) = imax
        IF ( j.NE.N ) THEN
          IF ( A(j,j).EQ.ZERO ) A(j, j) = NEARZERO
          dum = 1.D0/A(j, j)
          DO i = j + 1, N
            A(i, j) = A(i, j)*dum
          ENDDO
        ENDIF
      ENDDO
      IF ( A(N,N).EQ.ZERO ) A(N, N) = NEARZERO
      END SUBROUTINE LUDCMP
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE LUBKSB(A, N, Np, Indx, B)
! ----------------------------------------------------------------------
C     W. H. Press, S. A. Teukolsky, W. T. Vetterling
C     &  B. P. Flannery
C     Numerical Recipes in Fortran 1992
! ----------------------------------------------------------------------
      IMPLICIT NONE
! Arguments
      INTEGER, INTENT(IN) :: N, Np
      DOUBLE PRECISION, INTENT(IN) :: Indx(N), A(Np, Np)
      DOUBLE PRECISION, INTENT(INOUT) :: B(N)
! Local Variables
      INTEGER i, ii, j, ll
      DOUBLE PRECISION tot
!     ------------------------------------------------------------------
      ii = 0
      DO i = 1, N
        ll = Indx(i)
        tot = B(ll)
        B(ll) = B(i)
        IF ( ii.NE.0 ) THEN
          DO j = ii, i - 1
            tot = tot - A(i, j)*B(j)
          ENDDO
        ELSEIF ( tot.NE.0.D0 ) THEN
          ii = i
        ENDIF
        B(i) = tot
      ENDDO
      DO i = N, 1, -1
        tot = B(i)
        IF ( i.LT.N ) THEN
          DO j = i + 1, N
            tot = tot - A(i, j)*B(j)
          ENDDO
        ENDIF
        B(i) = tot/A(i, i)
      ENDDO
      END SUBROUTINE LUBKSB

c======================================================================= 
! ======================================================================
c======================================================================= 
Cseba
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE TURB_RE2
C
C ------VERSION 2 20DEZ98 TURB_RE2
C     ***********************************************************
C     DISTINGUISH LAMINAR FROM TURBULENT FLOW IN A TUBE
C     ***********************************************************
Cseba--HYSTERESIS INTRODUCED:
C     IN ORDER TO AVOID FLIPPING OF TUBES FROM LAMINAR TO TURBULENT
C       DURING ITERATION A HYSTERESIS IS INTRODUCED. FOR A GIVEN FLOW
C       VELOCITY LAM.REY IS BIGGER THAN TURB_RE, SO A TUBE JUST AT THE
C       LIMIT OF 2200 WOULD ALTERNATE EACH ITERATION BETWEEN LAMINAR AND
C       TURBULENT. THEREFORE A LAMINAR TUBE SWITCHES TO TURBULENT AT A
C       HIGHER (LAMINAR) REYNOLDS-NUMBER OF 3100, WHILE A TURBULENT TUBE
C       SWITCHES TO LAMINAR AT A (TURBULENT) REYNOLDSNUMBER OF 1400.
C       THIS IS 800 EACH WAY.
Celk   In newer CFP_MF2005 user specifies lower and upper critical Reynolds number
      USE CFPMODULE, ONLY:Mxtube, B_mat, Itube, Geohight, Con_data, PII,&
     &    TWOPII, ONE8TH, G, Nu, Turb, Dtube, Tub_reynold, Fturb, TWO,  &
     &    ZERO

      USE GLOBAL, ONLY:Iout
      IMPLICIT NONE
      INTRINSIC ASIN, DSQRT, SIN, DABS
      DOUBLE PRECISION, EXTERNAL :: LAMIN_PF, TURBI_PF, LAMIN, TURBI
C     
C ------ OUTPUT:
C TURB - CONTAINS THE TYPE OF FLOW
C            0 - LAMINAR
C            1 - TURBULENT
C TUB_REYNOLD - VECTOR CONTAINS THE REYNOLD NUMBER FOR EVERY TUBE
C FTURB - FLAG IF TURBULENT FLOW EXIST - 1
C               ELSE                   - 0
! Local Variables
      DOUBLE PRECISION apf
      DOUBLE PRECISION tubehmid, tubetop1, tubetop2, tubebot1, tubebot2
      DOUBLE PRECISION tubetopmid, tubebotmid, tubemidmid, tubewettd
      DOUBLE PRECISION dknot, theta, deqv, lamq, lam_re, turbq, turb_re
      INTEGER i, ic
C     ------------------------------------------------------------------
CB    WRITE (Iout, *) 'BEGINNING CFPM1 TURB_RE2 SUBROUTINE WHICH',      &
CB                    ' DETERMINES WHETHER PIPE FLOW IS LAMINAR OR',    &
CB                    ' TURBULENT DURING NR ITERATIONS'
c
C--CALCULATE FLOW IN ALL TUBES
      DO i = 1, Mxtube
cbarc**compute these for free surface case
cb-----------------------------------------
c 
        tubehmid = (B_mat(Itube(i,2))+B_mat(Itube(i,3)))/TWO
        tubetop1 = Geohight(Itube(i,2)) + Con_data(i, 2)/TWO
        tubetop2 = Geohight(Itube(i,3)) + Con_data(i, 2)/TWO
        tubebot1 = Geohight(Itube(i,2)) - Con_data(i, 2)/TWO
        tubebot2 = Geohight(Itube(i,3)) - Con_data(i, 2)/TWO
c
        tubetopmid = (tubetop1+tubetop2)/TWO
        tubebotmid = (tubebot1+tubebot2)/TWO
        tubemidmid = (Geohight(Itube(i,2))+Geohight(Itube(i,3)))/TWO
c 
cbarc**if free surface, you need effective diameter and partial area
cbarc**************************************************************
        IF ( tubehmid.LT.tubetopmid .AND. tubehmid.GT.tubebotmid ) THEN
          WRITE (Iout, *) i,                                            &
     &   'tube in turb_re2 corrected for partially saturated conditions'
c 
          tubewettd = tubehmid - tubebotmid
          dknot = Con_data(i, 2)
          theta = TWO*ASIN                                              &
     &            (TWO*DSQRT((dknot/TWO)**TWO-(tubewettd-dknot/TWO)     &
     &            **TWO)/dknot)
          IF ( tubehmid.GE.tubemidmid ) theta = TWOPII - theta
          deqv = dknot - dknot*(SIN(theta)/theta)
c 
cbarc**add this
          apf = ONE8TH*(theta-SIN(theta))*deqv**TWO
C
C--SORT RE-NUMBERS:
          IF ( Turb(i).EQ.0 ) THEN
C--If tube was laminar calculate laminar Reynoldsnumber and flow rate
            lamq = LAMIN_PF(B_mat(Itube(i,2)), B_mat(Itube(i,3)), deqv, &
     &             Con_data(i,3), Nu, G, PII, apf)
 
            lam_re = DABS(4.0D0*lamq/(PII*deqv*Nu))
            Tub_reynold(i) = lam_re
            Dtube(i, 1) = lamq
C--If lam. Re is > tcritrey take turb. Re and switch tube to turb
cbarc**make this user-defined
            IF ( lam_re.GE.Con_data(i,6) ) THEN
              turbq = TURBI_PF(B_mat(Itube(i,2)), B_mat(Itube(i,3)),    &
     &                deqv, Con_data(i,3), Con_data(i,4), Nu, G, PII,   &
     &                apf)
              turb_re = DABS(4.D0*turbq/(PII*deqv*Nu))
              Tub_reynold(i) = turb_re
              Turb(i) = 1
C--tube(i,4) switched to turbulent flow rate
              Dtube(i, 1) = turbq
              WRITE (Iout, 9001) i, lam_re, Con_data(i, 6)
            ENDIF
C
          ELSE
C--If flow was turbulent take turb. Re
            turbq = TURBI_PF(B_mat(Itube(i,2)), B_mat(Itube(i,3)), deqv,&
     &              Con_data(i,3), Con_data(i,4), Nu, G, PII, apf)
            turb_re = DABS(4.D0*turbq/(PII*deqv*Nu))
            Tub_reynold(i) = turb_re
            Dtube(i, 1) = turbq
C--If turb_Re < 1600 take lam_Re and switch flow
cb          IF ( turb_Re.LE.1400.D0 ) THEN
cbarc**use user-defined critical reynolds #
            IF ( turb_re.LE.Con_data(i,5) ) THEN
c 
              lamq = LAMIN_PF(B_mat(Itube(i,2)), B_mat(Itube(i,3)),     &
     &               deqv, Con_data(i,3), Nu, G, PII, apf)
              lam_re = DABS(4.D0*lamq/(PII*deqv*Nu))
              Tub_reynold(i) = lam_re
              Turb(i) = 0
C--tube(i,4) switched from turbulent to laminar flow rate
              Dtube(i, 1) = lamq
              WRITE (Iout, 9002) i, lam_re, Con_data(i, 5)
            ENDIF
          ENDIF
C
C DETERMINE IF TURBULENT FLOW EXIST
          Fturb = 0
          DO ic = 1, Mxtube
            Fturb = Turb(ic) + Fturb
          ENDDO
CBARC**End FOR FREE SURFACE CASES
        ENDIF
c 
cbarc************************
cbarc**FOR DRY CASE
cbarc************************
        IF ( tubehmid.LE.tubebotmid ) THEN
cb        PRINT *, 'dry', i, tubehmid, tubebotmid
          WRITE (Iout, *) i, 'tube in turb_re2 set dry '
c 
C--SORT RE-NUMBERS:
          IF ( Turb(i).EQ.0 ) THEN
C--If tube was laminar calculate laminar Reynoldsnumber and flow rate
            lamq = ZERO
            lam_re = ZERO
            Tub_reynold(i) = lam_re
            Dtube(i, 1) = lamq
          ELSE
C--If flow was turbulent take turb. Re
            turbq = ZERO
            turb_re = ZERO
            Tub_reynold(i) = turb_re
            Dtube(i, 1) = turbq
C--If turb_Re < 1600 take lam_Re and switch flow
cb          IF ( turb_re.LE.1400.D0 ) THEN
            IF ( turb_re.LE.Con_data(i,5) ) THEN
              lamq = ZERO
              lam_re = ZERO
              Tub_reynold(i) = lam_re
              Turb(i) = 0
C--tube(i,4) switched from turbulent to laminar flow rate
              Dtube(i, 1) = lamq
              WRITE (Iout, 9003) i
            ENDIF
          ENDIF
C
C DETERMINE IF TURBULENT FLOW EXIST
          Fturb = 0
          DO ic = 1, Mxtube
            Fturb = Turb(ic) + Fturb
          ENDDO

CBARC**else FOR DRY CASES
        ELSE
c 
cbarc************************
cbarc**for saturated case
cbarc************************ 
C
C--SORT RE-NUMBERS:
          IF ( Turb(i).EQ.0 ) THEN
C--If tube was laminar calculate laminar Reynoldsnumber and flow rate
            lamq = LAMIN(B_mat(Itube(i,2)), B_mat(Itube(i,3)),          &
     &             Con_data(i,2), Con_data(i,3), Nu, G, PII)
c 
            lam_re = DABS(4.D0*lamq/(PII*Con_data(i,2)*Nu))
            Tub_reynold(i) = lam_re
            Dtube(i, 1) = lamq
C--If lam. Re is > 3000 take turb. Re and switch tube to turb
cb          IF (lam_re.GE.3100.D0 ) THEN
cb          PRINT *, 'here', Con_data(i, 6)
            IF ( lam_re.GE.Con_data(i,6) ) THEN
              turbq = TURBI(B_mat(Itube(i,2)), B_mat(Itube(i,3)),       &
     &                Con_data(i,2), Con_data(i,3), Con_data(i,4), Nu,  &
     &                G, PII)
              turb_re = DABS(4.D0*turbq/(PII*Con_data(i,2)*Nu))
              Tub_reynold(i) = turb_re
              Turb(i) = 1
C--tube(i,4) switched to turbulent flow rate
              Dtube(i, 1) = turbq
              WRITE (Iout, 9004) i, lam_re, Con_data(i, 6)
            ENDIF
C
          ELSE
C--If flow was turbulent take turb. Re
            turbq = TURBI(B_mat(Itube(i,2)), B_mat(Itube(i,3)),         &
     &              Con_data(i,2), Con_data(i,3), Con_data(i,4), Nu, G, &
     &              PII)
            turb_re = DABS(4.D0*turbq/(PII*Con_data(i,2)*Nu))
            Tub_reynold(i) = turb_re
            Dtube(i, 1) = turbq
C--If turb_Re < 1600 take lam_Re and switch flow
cb          IF ( turb_re.LE.1400.D0 ) THEN
            IF ( turb_re.LE.Con_data(i,5) ) THEN
              lamq = LAMIN(B_mat(Itube(i,2)), B_mat(Itube(i,3)),        &
     &               Con_data(i,2), Con_data(i,3), Nu, G, PII)
              lam_re = DABS(4.D0*lamq/(PII*Con_data(i,2)*Nu))
              Tub_reynold(i) = lam_re
              Turb(i) = 0
C--tube(i,4) switched from turbulent to laminar flow rate
              Dtube(i, 1) = lamq
              WRITE (Iout, 9005) i, lam_re, Con_data(i, 5)
            ENDIF
cbarc**endif for IF (turb(i) .EQ. 0) statement
          ENDIF
C
C DETERMINE IF TURBULENT FLOW EXIST
          Fturb = 0
          DO ic = 1, Mxtube
            Fturb = Turb(ic) + Fturb
          ENDDO
C
cbarc**endif for saturated case
        ENDIF
c 
CBARC**ENDDO FOR ALL THREE CASES
      ENDDO
c 
 9001 FORMAT ('tube', I4, ' lamrey=>tcritrey. lam_Re:', G12.4,          &
     &        ' tcritrey', G12.4)
 9002 FORMAT ('tube', I4, ' turbrey<=lcritrey lam_Re:', G12.4,          &
     &        ' turb_Re:', G12.4)
 9003 FORMAT ('tube', I4, ' is dry')
 9004 FORMAT ('tube', I4, ' lam_re>=tcritrey lam_Re:', G12.4,           &
     &        ' tcritrey', G12.4)
 9005 FORMAT ('tube', I4, ' turbrey<=lcritrey:', G12.4, ' turb_Re:',    &
     &        G12.4)
c 
      END SUBROUTINE TURB_RE2
c---------------------------------------------------------------c
c======================================================================= 
! ======================================================================
c 
      DOUBLE PRECISION FUNCTION TURBI(Ha, He, D, L, K, Nu, G, Pi)
C ----- VERSION 1 13APR1995 TURBI
C       *******************************************************
C       CALCULATE TURBULENT FLOW IN A TUBE 
C             BY COLEBROOK-WHITE (SEE HORLACHER 1992)
C       OUTPUT: M^3/S
C       ***********************************************************
c
      IMPLICIT NONE
      INTRINSIC DABS, DSQRT, DLOG10
C ------ INPUT:
C HA                  PRESSUREHEAD AT THE BEGIN OF THE TUBE
C HE                  PRESSUREHEAD AT END 
C D                   DIAMETER OF THE TUBE
C L                   LENGTH OF THE TUBE
C NU                  KINEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C G                   GRAVITATION CONSTANT
C K                   ROUGHNESS OF THE TUBE
Cseba--IF K < 0 THEN ROUGHNESS = DIAMETER*K
C
C ----- INTERNALE VARIABLE:
C SIGNUM      STORE VALUE 1: ha > he
C                    0: ha < he
C H, Y                STORE INTERNAL VALUES FROM CALCULATION
C
C ----- OUTPUT:
C TURBI       FUNCTIONVARIABLE TAKING THE RESULT
c
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Ha, He, D, L, K, Nu, G, Pi
! Local Variables
      DOUBLE PRECISION signum, y, h, kk
!     ------------------------------------------------------------------
      IF ( Ha.GE.He ) THEN
        signum = 1.D0
      ELSE
        signum = -1.D0
      ENDIF
C--KK IS THE CALCULATED ROUGHNESS COEFFICIENT
      kk = K
Cseba--NEW ROUGHNESS COEFFICIENT:
      IF ( K.LT.0.0D0 ) kk = -1.D0*K*D
C
C AVOID DIVISION WITH ZERO
      h = DABS(Ha-He)
      IF ( h.NE.0.0D0 ) THEN
        y = DSQRT(h*G*D**5.D0*Pi**2.D0/(8.D0*L))
        TURBI = signum*(-2.D0)                                          &
     &          *y*DLOG10(2.51D0*Pi*Nu*D/(4.D0*y)+kk/(3.71D0*D))
C--CHECK FOR SIGN OF LOG, THAT CHANGES WITH SMALL DIAMETERS:
        IF ( DLOG10(2.51D0*Pi*Nu*D/(4.D0*y)+kk/(3.71D0*D)).GT.0.D0 )    &
     &       THEN
          WRITE (*, *) ' WARNING! TURBULENT FLOW HAS WRONG SIGN'
          WRITE (*, 9001) D, L, kk
        ENDIF
      ELSE
C THERE IS NO HEAD DIFFERENCE
        TURBI = 0.D0
      ENDIF
 9001 FORMAT ('diam: ', G16.8, ' length: ', G16.8, ' k: ', G16.8)
      END FUNCTION TURBI
c---------------------------------------------------------------c 
! ======================================================================
c======================================================================= 
      DOUBLE PRECISION FUNCTION TURBI_PF(Ha, He, D, L, K, Nu, G, Pi,    &
     &  Apf)
! ----------------------------------------------------------------------
cbarc**corrected d for free surface in conduit is passed in here.
cbarc**partial area, A, also passed in here
C ----- VERSION 1 13APR1995 TURBI
C       *******************************************************
C       CALCULATE TURBULENT FLOW IN A TUBE 
C             BY COLEBROOK-WHITE (SEE HORLACHER 1992)
C       OUTPUT: M^3/S
C     ***********************************************************
c
      IMPLICIT NONE
      INTRINSIC DABS, DSQRT, DLOG10
C ------ INPUT:
C HA                  PRESSUREHEAD AT THE BEGIN OF THE TUBE
C HE                  PRESSUREHEAD AT END 
C D                   DIAMETER OF THE TUBE
C L                   LENGTH OF THE TUBE
C NU                  KINEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C G                   GRAVITATION CONSTANT
C K                   ROUGHNESS OF THE TUBE
Cseba--IF K < 0 THEN ROUGHNESS = DIAMETER*K
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Ha, He, D, L, K, Nu, Apf, G, Pi
! Local Variables
      DOUBLE PRECISION signum, y, h, kk
C
C ----- INTERNALE VARIABLE:      
C SIGNUM  STORE VALUE 1: ha > he
C                     0: ha < he
C H, Y STORE INTERNAL VALUES FROM CALCULATION
C
C ----- OUTPUT:
C TURBI       FUNCTIONVARIABLE TAKING THE RESULT
!     ------------------------------------------------------------------

      IF ( Ha.GE.He ) THEN
        signum = 1.D0
      ELSE
        signum = -1.D0
      ENDIF
C--KK IS THE CALCULATED ROUGHNESS COEFFICIENT
      kk = K
Cseba--NEW ROUGHNESS COEFFICIENT:
      IF ( K.LT.0.D0 ) kk = -1.D0*K*D
c 
C AVOID DIVISION WITH ZERO
      h = DABS(Ha-He)
      IF ( h.NE.0.D0 ) THEN
c 
cbarc**for parially-filled conditons:
c 
        y = DSQRT((2.D0*h*G*D*Apf**2.D0)/L)
c 
        TURBI_PF = signum*(-2.D0)                                       &
     &             *y*DLOG10(2.51D0*Pi*Nu*D/(4.D0*y)+kk/(3.71D0*D))
C--CHECK FOR SIGN OF LOG, THAT CHANGES WITH SMALL DIAMETERS:
        IF ( DLOG10(2.51D0*Pi*Nu*D/(4.D0*y)+kk/(3.71D0*D)).GT.0.D0 )    &
     &       THEN
          WRITE (*, *) ' WARNING! TURBULENT FLOW HAS WRONG SIGN'
          WRITE (*, 9001) D, L, kk
        ENDIF
      ELSE
C THERE IS NO HEAD DIFFERENCE
        TURBI_PF = 0.D0
      ENDIF
 9001 FORMAT ('diam: ', G16.8, ' length: ', G16.8, ' k: ', G16.8)
      END FUNCTION TURBI_PF
c---------------------------------------------------------------c
c======================================================================= 
! ======================================================================
 
      DOUBLE PRECISION FUNCTION LAMIN(Ha, He, D, L, Nu, G, Pi)
c
C 
C ----- VERSION 1 13APR1995 LAMIN
C       *******************************************************
C       CALCULATE LAMINAR FLOW IN A TUBE
C             BY HAGEN-POISEUILLE
C             Q = H * G * D**4 * PI / (L * 128 * NU) m^3/s
C     ***********************************************************
C
      IMPLICIT NONE
C ----- INPUT:
C HA          PRESSUREHEAD AT THE BEGIN OF THE TUBE
C HE                  PRESSUREHEAD        END 
C D                   DIAMETER OF THE TUBE
C L                   LENGTH OF THE TUBE
C NU                  KINEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C G                   GRAVITATION CONSTANT
C PI                  MATHEMATIC CONSTANT PI
C ----- INTERNALE VARIABLE:
C C             STORE INTERNAL VALUES FROM CALCULATION
C
C ----- OUTPUT:
C LAMIN       CONTAINS VOLUME OF LAMINAR FLOW
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Ha, He, D, L, Nu, G, Pi
! Local Variables
      DOUBLE PRECISION c
!     ------------------------------------------------------------------
c
      c = Pi*G/(Nu*128.D0)
      LAMIN = c*D**4.D0*(Ha-He)/L
      END FUNCTION LAMIN
c---------------------------------------------------------------c
c======================================================================= 
! ======================================================================
c 
      DOUBLE PRECISION FUNCTION LAMIN_PF(Ha, He, D, L, Nu, G, Pi, Apf)
cbarc**corrected d for free surface in conduit is passed in here.
cbarc**partial area, A, also passed in here
C 
C ----- VERSION 1 13APR1995 LAMIN
C       *******************************************************
C       CALCULATE LAMINAR FLOW IN A TUBE
C             BY HAGEN-POISEUILLE
C             Q = H * G * D**4 * PI / (L * 128 * NU) m^3/s
C     ***********************************************************
C
      IMPLICIT NONE
C ----- INPUT:
C HA          PRESSUREHEAD AT THE BEGIN OF THE TUBE
C HE                  PRESSUREHEAD        END 
C D                   DIAMETER OF THE TUBE
C L                   LENGTH OF THE TUBE
C NU                  KINEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C G                   GRAVITATION CONSTANT
C PI                  MATHEMATIC CONSTANT PI
C ----- INTERNALE VARIABLE:
C C             STORE INTERNAL VALUES FROM CALCULATION
C
C ----- OUTPUT:
C LAMIN       CONTAINS VOLUME OF LAMINAR FLOW
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Ha, He, D, L, Nu, G, Pi, Apf
! Local Variables
c 
cb c = pi * g  / (nu * 128D0)
cb lamin = c * d**4.D0 * (ha - he) / l
c 
cbarc**right equation for partailly full conditions
      LAMIN_PF = (D**2.D0*G*(Ha-He)*Apf)/(32.D0*Nu*L)
c
      END FUNCTION LAMIN_PF
c---------------------------------------------------------------c
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE ITERA_NEW(Kkiter)
c=======================================================================
!rsr X0 changed to B_mat
cbarc**b_mat becomes x0 in here
C
C-------------        VERSION 2   20DEZ1998    ITERA_NEW
C     *********************************************************
C     NEWTON-RAPHSON ITERATION TO SOLVE NONLINEAR
C     SYSTEM OF EQUATIONS
C     -f(x_0) = f'(x_0) * (x - x_0)
C     *********************************************************
C ------ VARIABLE:
C     
C ------ INPUT:
c
      USE CFPMODULE, ONLY:Fturb, Konv, Epsilon, Activenode, Index1, B,  &
     &    Itera_max, Cfprelax, P_nr, Fx0, Eq_mat, B_mat, Iters
c
cbarc**add Rof for overland flow
      USE CFPMODULE, ONLY: Dtube,Mxtube,Nbr,Nnod,Mxnode,Zero,Qtubin,
     &    Itube,Qtub  !,Rof
c
      USE GLOBAL, ONLY:Iout
      IMPLICIT NONE
      EXTERNAL VEC_SET, VEKTOR_CHANGE, F_X0, FX0_ABL, VEC_SKAL
      EXTERNAL LUDCMP, LUBKSB, MPROVE, VEC_ADD, TURB_RE2
      DOUBLE PRECISION, EXTERNAL :: MAX_NORM
C MXNODE      NUMBER OF NODES
C MXTUBE      NUMBER OF TUBES
C TURB        CONTAINS THE TYPE OF FLOW                      
C             0 - LAMINAR
C             1 - TURBULENT
C BEG_HEAD    CONTAINING THE HEADS READ FROM FILE
C NEIBR       ARRAY CONTAINING THE CONDUITSTRUCTUR:
C             NODE, NEIGHBOUR NODE  1, 2, 3, 4, TUBE NR. 1, 2, 3, 4, 
C               MODFLOWROW, -COLUMN
C TUBE        TUBENR., NODE_BEGIN, NODE_END 
C             Q m/s (BEGIN_NODE_PRESSUR > END_NODE_PRESSUR => Q >= 0),
C             CHEMIE: 0 NOT CALCULATED, 1 CALCULATED 
C CON_DATA    CONDUIT DATA WITH:
C                     TUBENUMBER, DIAMETER, LENGTH, ROUGHNESS
C MODD                EXCHANGE COEFFICIENT USED FOR EXCHANGE WITH MODFLOW
C B_mat          HEADS CALCULATED BY THE NEWTON-RAPHSON ITERATION,
C             STARTING POINT FOR THE FIRST ITERATION STEP 
C             CALCULATED BY THE SUBROUTINE 'GLLMA'
Cseba--         CHANGED: USE PRESSURE HEADS FROM LAST TIMESTEP AS STARTING POINT!
C             STORE ALSO THE LAST HEADS IN THE ITERATION
C G           CONSTANT OF GRAVITATION
C PII                 THE MATHEMATICAL CONSTANT PI
C NU          DYNEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C VISC        DYNEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C EPSILON     CRITERION OF CONVERGENCE
C RELAX       RELAXATION PARAMETER WICH CHANGE THE
C             STEPLENGTH: x_i = x_i-1 + (relax *  z)
C QBDIR       FLOW RATE DIRECTLY IN CONDUIT BY DOLINES
C IBOUND      BOUNDARY ARRAY STATUS OF EACH CELL (see 'MODFLOW')
C                < 0, CONSTANT-HEAD CELL
C                = 0, INACTIVE CELL
C                > 0, VARIABLE-HEAD CELL
C HNEW                MODFLOW NEW CALCULATED PRESSURE HEAD
C             DUE FOR BUDGET AT EVERY NODE COMING FROM
C             EXCHANGE WITH THE 'FISSURED SYSTEM'
C more than 4 tubes each node: reset nnod
c
! Arguments
      INTEGER, INTENT(IN) :: Kkiter
! Local Variables
      DOUBLE PRECISION d
cbarc**add this for overland flow
      DOUBLE PRECISION qt
c
      DOUBLE PRECISION mat_a(Activenode, Activenode), vec_b(Activenode)
      INTEGER i
c
cbarc**add this for overland flow
      INTEGER n,t,bnod,enod
c
C
Cseba--Subroutine mprove included, wich should improve calculation
C      of x by ludcmp and lubksb. See Press et al. 1992, p 47ff
C      new variables for mprove, to save original A and b:
c
C
C ------ INTERNALE VARIABLES:
C HELP    STORE INTERNAL VALUE
C FX0     FLOW BUDGET FOR EVERY NODE USED IN THE
C         NEWTON-RAPHSON ITERATION (Fx0 - see head of
C         the subroutine)
C B       THE NEW HEAD VALUES AFTER THE LAST CALCULATION
C         NORM VARIABLE STORE RESULT OF FUNCTION 'norm'
C EQ_MAT  STORE THE MATRIX OF THE EQUATIONSYSTEM SOLVED
C         THE FUNCTIONS 'LUDCMP' AND 'LUBKSB'
C INDEX1  DUE FOR THE FUNCTIONS 'ludcmp' & 'lubksb'
C VARIABLE j
C FTURB - FLAG IF TURBULENT FLOW EXIST - 1
C                 ELSE                 - 0
C
C ------ OUTPUT:
C S           COUNTER OF ITERATIONSTEPS
C KONV        FLAG: 1 - ITERATION CONVERGE
C                   0 - NO CONVERGENCE 
C TUB_REYNOLD - VECTOR CONTAINS THE REYNOLD NUMBER FOR EVERY TUBE
C
!     ------------------------------------------------------------------
C     WRITE (Iout, *) 'ITERA_NEW'
C
      Konv = 0
c
CBARC**MAKE LABELS FOR NR CONVERGENCE TABLE
      IF ( P_nr.EQ.1 ) WRITE (Iout, '(A)')                              &
     &'MODFLOW ITER.#  NEWTON-RAPHSON ITER.#   MAXIMUM NODE HEAD CHANGE'
c 
CBARC**NR CONVERGENCE INFORMATION NOT DESIRED.
!rsr  IF ( P_nr.EQ.0 ) CONTINUE
C
      DO i = 1, Itera_max
        Iters = i
C
C--CALCULATE THE FLOW BUDGET OF EVERY NODE.
C  OUTPUT: 'Fx0' FOR NEWTON-RAPHSON
c 
        CALL F_X0
c 
C--DESIGNATE THE DERIVATION 'f'(x_0)
        CALL FX0_ABL
C
C--CALCULATE '(-1) * Fx0'
        CALL VEC_SKAL(Fx0, Activenode, -1.D0)
C
C--INITIALICE INDEX1 = 0
        CALL VEC_SET(Index1, Activenode, 0.D0)
 
C--SOLUTION OF THE LINEAR EQUATION SYSTEM (see PRESS 1992)
C--SAVE ORIGINAL eq_mat IN mat_a AND Fx0 IN vec_b FOR mprove:
        CALL MATRIX_CHANGE(Eq_mat, mat_a, Activenode, Activenode)
        CALL VEKTOR_CHANGE(Fx0, vec_b, Activenode)
c 
C--SOLVE BY LU-DECOMPOSITION:
        CALL LUDCMP(Eq_mat, Activenode, Activenode, Index1, d)
        CALL LUBKSB(Eq_mat, Activenode, Activenode, Index1, Fx0)
c 
C--CALL mprove TO IMPROVE CALCULATION:
        CALL MPROVE(mat_a, Eq_mat, Activenode, Activenode, Index1,      &
     &              vec_b, Fx0)
C
C--CALCULATE 'rlax * Fx0'
        CALL VEC_SKAL(Fx0, Activenode, Cfprelax)
C
C--CALCULATE 'b = x_n +
        CALL VEC_ADD(Fx0, B_mat, B, Activenode)
C
C--DETERMINE LAMINAR AND TURBULENT FLOW
        CALL TURB_RE2
c 
CBARC**NR CONVERGENCE INFORMATION DESIRED.
        IF ( P_nr.EQ.1 ) WRITE (Iout, '(I10,I20,F30.10)') Kkiter, Iters,&
     &                          MAX_NORM(B, B_mat, Activenode)
c 
CBARC**NR CONVERGENCE INFORMATION NOT DESIRED.
!rsr    IF ( P_nr.EQ.0 ) CONTINUE
C
C--IF ITERATION CONVERGES, THEN STOP ITERATION AND GOTO LABEL NR. 112
        IF ( MAX_NORM(B,B_mat,Activenode).LE.Epsilon .AND.              &
     &       (Iters.GT.2 .OR. Fturb.EQ.0) ) THEN
          Konv = 1
          EXIT
        ENDIF
C
C--STORE NEW CALCULATED HEADS IN VECTOR B_mat (X0)
        CALL VEKTOR_CHANGE(B, B_mat, Activenode)
      ENDDO
c
cbarc**compute overland flow for GSFLOW
C--GO THROUGH ALL NODES
      DO n = 1, Mxnode
cb       Rof(n) = Zero
	 Qtubin(n) = Zero
        DO t = 1, NNOD
          IF ( Nbr(n,t+4+NNOD).NE.0 ) THEN
            qt = Dtube(Nbr(n,t+4+NNOD), 1)
            bnod = Itube(Nbr(n,t+4+NNOD), 2)
            enod = Itube(Nbr(n,t+4+NNOD), 3)
            IF ( qt.LT.ZERO .AND. n.EQ.bnod ) THEN
              Qtub(n, t) = -qt
              Qtubin(n) = Qtubin(n) + Qtub(n, t)
            ELSEIF ( qt.GT.ZERO .AND. n.EQ.enod ) THEN
              Qtub(n, t) = qt
              Qtubin(n) = Qtubin(n) + Qtub(n, t)
            ENDIF
          ENDIF
        ENDDO
cbarc**set Rof
cb       Rof(n) = Qtubin(n)
cb       print*,n, Rof(n)
	ENDDO
c
C
      END SUBROUTINE ITERA_NEW
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE F_X0
C
C       ----- VERSION 2  20DEZ1998 F_X0            &&epikarst
C     ***********************************************************
C     CALCULATE F(X_0) FOR THE NEWTON-RAPHSON EQUATION:
C             -F(X_0) = F'(X_0)(X - X_0)
C
C     APPLICATION OF THE KIRCHHOFF RULE WITH 
C
C             Q_1 + Q_2 + Q_3 + Q_4 + MOD_EX + Q_DIR  = 0
C
C     WITH Q_i FLOW THROUGH THE i.-TUBE
C
C     IT WILL BE DISTINGUISHED IN TURBULENT AND LAMINAR
C     WITH 'turb'
C     ***********************************************************
c
      USE CFPMODULE, ONLY:NNOD, PII, G, Nu, Turb, Nbr, Con_data, B_mat, &
     &    Activenode, Beghead, Qbdir, Fx0, Mod2, NEARZERO
      USE GLOBAL, ONLY:Iout, Hnew, Ibound
c
      IMPLICIT NONE
      INTRINSIC DABS
      DOUBLE PRECISION, EXTERNAL :: TURBI, LAMIN
      EXTERNAL VEC_SET
c
C ------ INPUT:
C MXNODE      NUMBER OF NODES
C MXTUBE      NUMBER OF TUBES
C TURB - CONTAINS THE TYPE OF FLOW
C            0 - LAMINAR
C            1 - TURBULENT
C NEIBR       ARRAY CONTAINING THE CONDUITSTRUCTUR:
C             NODE, NEIGHBOUR NODE  1, 2, 3, 4, TUBE NR. 1, 2, 3, 4, 
C               MODFLOWROW, -COLUMN
C CON_DATA    CONDUIT DATA WITH:
C                     TUBENUMBER, DIAMETER, LENGTH, ROUGHNESS
C X0          INPUT VECTOR OF PRESSURE HEADS COMING FROM LAMINAR 
C             (START POINT OF ITERATION) OR ITERATIVE PROCESS
C PI          THE MATHEMATICAL CONSTANT PI
C NU                  KINEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C G           CONSTANT OF GRAVITATION
C MOD                 EXCHANGE COEFFICIENT USED FOR EXCHANGE WITH MODFLOW
C QBDIR       FLOW RATE DIRECTLY IN CONDUIT
C more than 4 tubes each node: reset nnod
c
C ------ INTERNALE VARIABLES:
C TURBI    VARIABLE AVAIL FOR FUNCTION TURBI
C LAMIN    VARIABLE AVAIL FOR FUNCTION LAMIN
C I, J     COUNTER
C tub      STORE ACTUAL TUBE = Nbr(i,j+5)
C
C ------ OUTPUT:
C FX0 - NEW HEADS OF THE CALCULATED FLOW
C 
C -------- DATA COMING FROM MAINPROGRAM MODFLOW:
C NCOL - IS THE NUMBER OF COLUMNS
C NROW - IS THE NUMBER OF ROWS
C NLAY - IS THE NUMBER OF LAYS
C IBOUND - BOUNDARY ARRAY STATUS OF EACH CELL
C            < 0, CONSTANT-HEAD CELL
C            = 0, INACTIVE CELL
C            > 0, VARIABLE-HEAD CELL
C LCHNEW - DIMENSION (NCOL,NROW,NLAY), MOST RECENT ESTIMATE OF
C        HEAD IN EACH CELL. HNEW CHANGES AT EACH ITERATION
! Local Variables
      INTEGER i, j, tub
      DOUBLE PRECISION help
!     ------------------------------------------------------------------
c
C--INITIALIZE FX0 (= 0)
      CALL VEC_SET(Fx0, Activenode, 0.D0)
C
      DO i = 1, Activenode
C
C--IF i.-NODE HAS VARIABLE HEAD
!rsr    IF ( Beghead(i).EQ.-1.D0 ) THEN
        IF ( DABS(Beghead(i)+1.D0).LT.NEARZERO ) THEN
C
C--IF i.-NODE HAS A NEIGHBOUR
          DO j = 1, NNOD
            IF ( Nbr(i,j+4).EQ.0 ) CYCLE
            tub = Nbr(i, j+4+NNOD)
c 
C--IF FLOW IS LAMINAR
C------------------------
            IF ( Turb(tub).EQ.0 ) THEN
              help = LAMIN(B_mat(Nbr(i,1)), B_mat(Nbr(i,j+4)),          &
     &               Con_data(tub,2), Con_data(tub,3), Nu, G, PII)
              Fx0(Nbr(i,1)) = Fx0(Nbr(i,1)) + help
c 
            ELSE
C--IF FLOW IS TURBULENT
C------------------------
              help = TURBI(B_mat(Nbr(i,1)), B_mat(Nbr(i,j+4)),          &
     &               Con_data(tub,2), Con_data(tub,3), Con_data(tub,4), &
     &               Nu, G, PII)
 
              Fx0(Nbr(i,1)) = Fx0(Nbr(i,1)) + help
c 
cbarc**endif for IF (turb(tub) .EQ. 0) statement
            ENDIF
cbarc**enddo for mxnode loop
          ENDDO
C
C--ADD EXCHANGE COMING FROM MODFLOW ONLY IF MODFLOW CELL IS ACTIVE
C
cb        Fx0(Nbr(i,1)) = Fx0(Nbr(i,1)) + amodd(Nbr(i,1)) *
cb   &             (B_mat(Nbr(i,1))- Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)))
c 
          IF ( Ibound(Nbr(i,2),Nbr(i,3),Nbr(i,4)).NE.0 ) Fx0(Nbr(i,1))  &
     &         = Fx0(Nbr(i,1)) + Mod2(Nbr(i,1))                         &
     &         *(B_mat(Nbr(i,1))-Hnew(Nbr(i,2),Nbr(i,3),Nbr(i,4)))
C
C--ADD INFLOW IN THE CONDUIT SYSTEM COMING FROM RECHARGE
C
          Fx0(Nbr(i,1)) = Fx0(Nbr(i,1)) - Qbdir(Nbr(i,1))
c
        ELSE
C
C--IF i.-NODE HAS CONSTANT HEAD
          Fx0(Nbr(i,1)) = B_mat(Nbr(i,1)) - Beghead(Nbr(i,1))
        ENDIF
c
      ENDDO
c 
!9001 FORMAT ('fx0 of the ', I3, '-tube and the ', I3, 'node is:',      &
!    &        E18.8, ' turbulent')
!9002 FORMAT ('fx0 of the ', I3, '-tube and the ', I3, 'node is:',      &
!    &        E18.8, ' laminar')
C
      END SUBROUTINE F_X0
c-----------------------------------------------------------------------c
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE VEC_SET(Vec, N, Wert)
C
C ------ VERSION 14APR1995   VEC_SET
C     *********************************************************
C     SET VECTOR 'vec' AT THE VALUE 'wert'
C     *********************************************************       
C
C ------ INPUT:
      IMPLICIT NONE
C N             SIZE OF THE VECTORS
C WERT                VALUE TO WICH THE VECTOR WILL BE SET
C
C ------ OUTPUT:
C VEC         VECTOR WHICH WILL SET AT ALL POSITION TO WERT
C
C ------ INTERNAL VARIABLE:
C I           INDEX
! Arguments
      INTEGER N
      DOUBLE PRECISION, INTENT(IN) :: Wert
      DOUBLE PRECISION, INTENT(OUT) :: Vec(N)
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------

      DO i = 1, N
        Vec(i) = Wert
      ENDDO
      END SUBROUTINE VEC_SET
c---------------------------------------------------------------c
 
! ======================================================================
 
      SUBROUTINE CON1FM
C
C ------ VERSION 1 18APR1995   CON1FM
C     ********************************************************
C     SUBSTRACT FLOW IN CONDUIT FROM MODFLOW HEADS (RHS)
C     ********************************************************
C
C ------ INPUT:
      USE CFPMODULE, ONLY:Nbr, Activenode, Mxnode, B, Mod2, Modd
      USE GLOBAL, ONLY:Iout, Ibound, Rhs, Hcof
      IMPLICIT NONE

C MXNODE      NUMBER OF NODES
C MODD        EXCHANGE COEFFICIENT USED FOR EXCHANGE WITH MODFLOW
C B           HEADPRESSURE OF CONDUIT
C more than 4 tubes each node: reset nnod
C ------ INTERNAL VARIABLES:
! Local Variables
      INTEGER ir, ic, il, i
C IR    INDEX FOR ROWS
C IC    INDEX FOR COLUMNS
C IL    INDEX OF LAYERS (SET EQUAL 1)
C I     INDEX FOR NODES
C
C -------- DATA COMING FROM THE MAIN PROGRAM MODFLOW:
C NCOL        IS THE NUMBER OF COLUMNS
C NROW        IS THE NUMBER OF ROWS
C NLAY        IS THE NUMBER OF LAYS
C MAT_DIR     STORE EXCHANGE COMING IN (> 0) OR OUT (< 0) 
C             OF THE MATRIX
C IBOUND      BOUNDARY ARRAY STATUS OF EACH CELL
C             < 0, CONSTANT-HEAD CELL
C             = 0, INACTIVE CELL
C             > 0, VARIABLE-HEAD CELL
C HNEW                MODFLOW NEW CALCULATED PRESSURE HEAD
C             DUE FOR BUDGET AT EVERY NODE COMING FROM
C             EXCHANGE WITH THE 'FISSURED SYSTEM'
c BOT           elevation of the aquifer bottom
C 
C -------- OUTPUT:
C RHS         RIGHT HAND SIDE OF THE FINITE
C             DIFFERENCE EQUATION OF MODFLOW. 
C             RHS IS AN ACCUMULATION OF TERMS
C             FROM SEVERAL DIFFERENT PACKAGES. POINTED ON THE FILD
C             RHS(NCOL,NROW,NLAY)
c
C
!     ------------------------------------------------------------------
C--IF THERE ARE NODES
      IF ( Mxnode.GT.0 ) THEN
C--PROCESS EACH NODE IN THE NODE LIST
        DO i = 1, Activenode
          ic = Nbr(i, 2)
          ir = Nbr(i, 3)
          il = Nbr(i, 4)
C--NODE IS DECLARED IN THE MODFLOW FIELD
          IF ( (ir.NE.0) .AND. (ic.NE.0) ) THEN
C
C--SUBSTRACT ONLY IF CELL IS NOT INACTIVE
            IF ( Ibound(ic,ir,il).NE.0 ) THEN
C--CALCULATE EXCHANGE FLOW
C--IF CELL IS NOT INACTIVE AND NOT CONSTANT HEAD THEN SUBSTACT FLOW INTO THE CONDUIT SYSTEM
              IF ( Ibound(ic,ir,il).GT.0 ) THEN
cb              Rhs(ic, ir, il) = Rhs(ic, ir, il) - Modd(i)*B(i)
cbarc**need to use corrected exchange here
                Rhs(ic, ir, il) = Rhs(ic, ir, il) - Mod2(i)*B(i)
Cseba--new term for hcof:
cb              Hcof(ic, ir, il) = Hcof(ic, ir, il) - Modd(i)
cbarc**need to use corrected exchange here
                Hcof(ic, ir, il) = Hcof(ic, ir, il) - Mod2(i)
c 
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDIF
C
C--MESSGAE TO IOUT
C     WRITE (Iout, 9001) i, B(i), Hnew(ic, ir, il)
!9001 FORMAT (I3, 2(G20.12, '  '))

      END SUBROUTINE CON1FM
C---------------------------------------------------------------
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE FX0_ABL
C
C ------ VERSION 2  20DEZ1998   FX0_ABL
C     *****************************************************************
C     CALCULATE THE DERIVATION OF f(x_0)
C     USED BY THE NEWTON-RAPHSON ITERATION
C     
C     -f(x_0) = f'(x_0)(x - x_0)
C     
C     THIS SUBROUTINE USES THE FUNCTIONS:
C             lami_abl & turb_abl
C     WHICH ARE ASSIGNED ABOVE
C     ****************************************************************
C
      USE CFPMODULE, ONLY:NNOD, PII, G, Nu, Turb, Nbr, Con_data, B_mat, &
     &    Activenode, Beghead, Eq_mat, Mod2, ZERO, NEARZERO

      USE GLOBAL, ONLY:Ibound

      IMPLICIT NONE
      INTRINSIC DABS
      DOUBLE PRECISION, EXTERNAL :: TURB_ABL, LAMI_ABL
C
C ------ INPUT:   
C MXNODE      NUMBER OF NODES
C MXTUBE      NUMBER OF TUBES
C BEG_HEAD    CONTAINING THE HEADS READ FROM FILE
C NEIBR       ARRAY CONTAINING THE CONDUITSTRUCTUR:
C             NODE, NEIGHBOUR NODE  1, 2, 3, 4, TUBE NR. 1, 2, 3, 4, 
C               MODFLOWROW, -COLUMN
C CON_DATA    CONDUIT DATA WITH:
C                     TUBENUMBER, DIAMETER, LENGTH, ROUGHNESS
C TURB        CONTAINS THE TYPE OF FLOW
C             0 - LAMINAR
C             1 - TURBULENT
C MOD                 EXCHANGE COEFFICIENT USED FOR EXCHANGE WITH MODFLOW
C X0          HEADS CALCULATED BY THE NEWTON-RAPHSON ITERATION,
C             BE STARTING POINT FOR THE FIRST ITERATION STEP 
C             CALCULATED BY THE SUBROUTINE 'GLLMA'
C G           CONSTANT OF GRAVITATION
C PI          THE MATHEMATICAL CONSTANT PI
C NU          DYNEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C VISC        DYNEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C more than 4 tubes each node: reset nnod
c
C
C ------ OUTPUT:
C EQ_MAT        STORE THE MATRIX OF THE EQUATIONSYSTEM SOLVED
C             THE FUNCTIONS 'LUDCMP' AND 'LUBKSB'
C
C ------ INERNALE VARIABLE:
C TURB_ABL   VARIABLE STORE RESULT OF FUNCTION 'turb_abl'
C LAMI_ABL   VARIABLE STORE RESULT OF FUNCTION 'lami_abl'
C HELP       INTERNAL VARIABLE
C I, J       INDEX
C tub        store active tube = Nbr(i,j+5)
c
! Local Variables
      INTEGER i, j, tub
      DOUBLE PRECISION help

cb    DOUBLE PRECISION  amodd(mxnode)
!     ------------------------------------------------------------------
C
C
C--INITIALICE MATRIX 'eq_mat'
      DO i = 1, Activenode
        DO j = 1, Activenode
          Eq_mat(j, i) = ZERO
        ENDDO
      ENDDO
      tub = 0
C
      DO i = 1, Activenode
C--IF i.-NODE HAS CONSTANT HEAD PRESSURE
!rsr    IF ( Beghead(i).NE.-1.D0 ) THEN
        IF ( DABS(Beghead(i)+1.D0).GT.NEARZERO ) THEN
          Eq_mat(i, i) = 1.D0
C
        ELSE
C--IF i.-NODE HAS VARIABLE HEAD PRESSURE THEN ASSIGN IN MATRIX 'eq_mat'
          DO j = 1, NNOD
            IF ( Nbr(i,j+4).NE.0 ) THEN
C--RECORD VALUES BELONG TO EVERY NEIGHBOURNODE
              tub = Nbr(i, j+4+NNOD)
 
              IF ( Turb(tub).EQ.0 ) THEN
C--IF FLOW IS LAMINAR
C-------------------------------------------------------
                help = LAMI_ABL(PII, G, Nu, Con_data(tub,2),            &
     &                 Con_data(tub,3))
                Eq_mat(i, i) = help + Eq_mat(i, i)
                Eq_mat(i, Nbr(i,j+4)) = -help
 
              ELSE
 
C--IF FLOW IS TURBULENT
                help = TURB_ABL(B_mat(i), B_mat(Nbr(i,j+4)), G, PII,    &
     &                 Con_data(tub,2), Con_data(tub,3), Con_data(tub,4)&
     &                 , Nu)
                Eq_mat(i, i) = help + Eq_mat(i, i)
                Eq_mat(i, Nbr(i,j+4)) = -help
 
cbarc**endif for     IF (turb(tub) .EQ. 0) THEN statement
              ENDIF
cbarc**endif for neighbor loop
            ENDIF
 
cbarc**enddo for mxnode loop
          ENDDO
C
C--ENTRY FOR EXCHANGE WITH MODFLOW
          IF ( Ibound(Nbr(i,2),Nbr(i,3),Nbr(i,4)).NE.0 ) Eq_mat(i, i)   &
     &         = Eq_mat(i, i) + Mod2(i)
cb     1      eq_mat(i,i) = eq_mat(i,i) + amodd(i)

cbarc**endif for beghead statement
        ENDIF
c 
cbarc**enddo for mxnode loop
      ENDDO
C
      END SUBROUTINE FX0_ABL
c======================================================================= 
! ======================================================================
c======================================================================= 
      DOUBLE PRECISION FUNCTION TURB_ABL(Ha, He, G, Pi, D, L, K, Nu)
cbarc**free surface deqv is passed in here
C
C ------ VERSION 1  14APR1995    TURB_ABL
C     ***********************************************************
C     FUNCTION TO CALCULATE THE DERIVATION OF f(x_0)
C     FOR TURBULENT FLOW
C     APPLICABLE FOR THE NEWTON-RAPHSON ITERATION 
C
C     CALLED BY SUBROUTINE: fx0_abl
C
C     -f(x_0) = f'(x_0)(x - x_0)
C     ***********************************************************
C
      IMPLICIT NONE
      INTRINSIC DABS, DSQRT, DLOG10
C ------ INPUT:
C HA          PRESSUREHEAD AT THE BEGIN OF THE TUBE
C HE          PRESSUREHEAD END 
C G           CONSTANT OF GRAVITATION
C PI          THE MATHEMATICAL CONSTANT PI
C D           DIAMETER OF THE TUBE
C L           LENGTH OF THE TUBE
C K           ROUGHNESS OF THE TUBE. IF K > 0 THEN K = -K*D
C NU          DYNEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
c
C
C ------ OUTPUT:
C TURB_ABL - FUNCTION VARIABLE TAKING THE RESULT
C
C ------ INTERNAL VARIABLE 
C X           STORE DIFFERENCE OF HEADPRESSURES
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: G, Pi, D, L, K, Nu, Ha, He
! Local Variables
      DOUBLE PRECISION beta, gamma, delta, test, kk, x
!     ------------------------------------------------------------------

Cseba--NEW ROUGHNESS COEFFICIENT
      kk = K
      IF ( K.LT.0.D0 ) kk = -1.D0*K*D
C
      x = DABS(Ha-He)
C AVOID DIVISION WITH ZERO
      IF ( x.NE.0.D0 ) THEN
C
Cseba--CORRECT NEW CALCULATION:
        beta = (G*Pi*Pi*D**5.D0)/(8.D0*L)
        gamma = (2.51D0*Pi*D*Nu)/4.D0
        delta = kk/(3.71D0*D)
        test = (-1.D0)*DSQRT(beta/x)*DLOG10(gamma/(DSQRT(beta*x))+delta)&
     &         + (gamma/x)*DLOG10(DEXP(1.D0))                           &
     &         *(gamma/(DSQRT(beta*x))+delta)**(-1.D0)
        TURB_ABL = test
C
      ELSE
C THERE IS NO HEAD DIFFERENCE
        TURB_ABL = 0.D0
      ENDIF
      END FUNCTION TURB_ABL
c-----------------------------------------------------------------------c
c======================================================================== 
! ======================================================================
c======================================================================= 
      DOUBLE PRECISION FUNCTION LAMI_ABL(Pi, G, Nu, D, L)
cbarc**free surface deqv is passed in here
C
C ------ VERSION 1  14APR1995    LAMI_ABL
C     ***********************************************************
C     FUNCTION TO CALCULATE THE DERIVATION OF f(x_0)
C     FOR LAMINAR FLOW
C     USED FOR THE NEWTON-RAPHSON ITERATION
C     CALLED BY SUBROUTINE: fx0_abl
C     ***********************************************************
C
      IMPLICIT NONE
C ----- INPUT:
C G     CONSTANT OF GRAVITATION
C PI    THE MATHEMATICAL CONSTANT PI
C D     DIAMETER OF THE TUBE
C L     LENGTH OF THE TUBE
C NU    DYNEMATIC VISCOSITY (DEPEND ON TEMPERATURE TC)
C
C
C ----- OUTPUT:
C LAMI_ABL - FUNCTION VARIABLE TAKING THE RESULT
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: Pi, G, Nu, D, L
!     ------------------------------------------------------------------
c
      LAMI_ABL = Pi*G*D**4.D0/(128.D0*L*Nu)
      END FUNCTION LAMI_ABL
c-----------------------------------------------------------------------c
c---------------------------------------------------------------c
c======================================================================== 
! ======================================================================
c======================================================================== 
      SUBROUTINE VEC_SKAL(Vector, N, Skalar)
C
C ------ VERSION 1    14APR1995   VEC_SKAL
C **************************************************************
C     SKALAR VECTOR MULTIPLICATION 
C
C ------ INPUT:
      IMPLICIT NONE
C N           DIMENSION OF THE VECTOR
C SKALAR      SKALAR TO MULTIPLY WITH VECTOR
C
C ------ OUTPUT:
C VECTOR      RESULT VECTOR AFTER MULTIPLICATION
C
C ------ INTERNAL VARIABLES:
C I           INDEX
! Arguments
      INTEGER, INTENT(IN) :: N
      DOUBLE PRECISION, INTENT(IN) :: Skalar
      DOUBLE PRECISION, INTENT(INOUT) :: Vector(N)
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------
      DO i = 1, N
        Vector(i) = Skalar*Vector(i)
      ENDDO
      END SUBROUTINE VEC_SKAL
c---------------------------------------------------------------c
c 
! ======================================================================
 
      SUBROUTINE MATRIX_CHANGE(Mat1, Mat2, N1, N2)
C     copy matrix mat1(n1,n2) into mat2(n1,n2)
C
      IMPLICIT NONE
C
! Arguments
      INTEGER, INTENT(IN) :: N1, N2
      DOUBLE PRECISION, INTENT(IN) :: Mat1(N1, N2)
      DOUBLE PRECISION, INTENT(OUT) :: Mat2(N1, N2)
! Local Variables
      INTEGER i, j
!     ------------------------------------------------------------------
C
      DO i = 1, N1
        DO j = 1, N2
          Mat2(i, j) = Mat1(i, j)
        ENDDO
      ENDDO
      END SUBROUTINE MATRIX_CHANGE
c---------------------------------------------------------------
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE VEKTOR_CHANGE(Vek1, Vek2, N)
C
C ------ VERSION 1   14APR1995    VEKTOR_CHANGE
C       *********************************************************
C     STORE 'vek1' in 'vek2' 
C       *********************************************************
C 
C ------ INPUT:
      IMPLICIT NONE
C N           DIMENSION OF THE VECTORS
C VEK1                VECTOR WICH WILL BE STORED IN VEK2
C
C ------ OUTPUT:
C VEK2  OUTPUT VECTOR
! Arguments
      INTEGER, INTENT(IN) :: N
      DOUBLE PRECISION, INTENT(IN) :: Vek1(N)
      DOUBLE PRECISION, INTENT(OUT) :: Vek2(N)
C 
C ------ INTERNAL VARIABLES:
C I           INDEX      
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------

      DO i = 1, N
        Vek2(i) = Vek1(i)
      ENDDO
      END SUBROUTINE VEKTOR_CHANGE
c---------------------------------------------------------------c
c====================================================================== 
! ======================================================================
c====================================================================== 
! ======================================================================
c======================================================================= 
Cseba--subroutine mprove
C
      SUBROUTINE MPROVE(A, Alud, N, Np, Indx, B, X)
C
C     W. H. Press et al. Numerical Recipes in Fortran 1992, p 47ff
C     INPUT:
      IMPLICIT NONE
      EXTERNAL LUBKSB
C     INTERNAL VARIABLES
! Arguments
      INTEGER, INTENT(IN) :: N, Np
      DOUBLE PRECISION, INTENT(IN) :: Indx(N), A(Np, Np), Alud(Np, Np)
      DOUBLE PRECISION, INTENT(IN) :: B(N)
      DOUBLE PRECISION, INTENT(INOUT) :: X(N)
! Local Variables
      INTEGER i, j
      DOUBLE PRECISION r(Np), sdp
!     ------------------------------------------------------------------
C     calculate right hand side:
      DO i = 1, N
        sdp = -B(i)
        DO j = 1, N
          sdp = sdp + A(i, j)*X(j)
        ENDDO
        r(i) = sdp
      ENDDO
C  solve for error term and substract from old solution:
      CALL LUBKSB(Alud, N, Np, Indx, r)
      DO i = 1, N
        X(i) = X(i) - r(i)
      ENDDO
      END SUBROUTINE MPROVE
c=======================================================================
c=======================================================================
! ======================================================================
c======================================================================= 
      SUBROUTINE VEC_ADD(Mat1, Mat2, Mat3, N)
C
C ------ VERSION 1   14APR1995    VEC_ADD
C     ********************************************************
C     ADD 'mat1' to 'mat2' AND STORE THE RESULT IN 'mat3'
C     ********************************************************
C
C ------ INPUT:
      IMPLICIT NONE
C N  SIZE OF THE VECTORS
C MAT1, MAT2 INPUT VECTORS WHICH WILL BE ADDED
C
C ----- OUTPUT:
C MAT3  RESULT OF VECTOR ADDITION
C ----- INTERNAL VARIABLES:
C I           INDEX
! ----------------------------------------------------------------------
! Arguments
      INTEGER, INTENT(IN) :: N
      DOUBLE PRECISION, INTENT(IN) :: Mat1(N), Mat2(N)
      DOUBLE PRECISION, INTENT(OUT) :: Mat3(N)
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------

      DO i = 1, N
        Mat3(i) = Mat1(i) + Mat2(i)
      ENDDO
      END SUBROUTINE VEC_ADD
c---------------------------------------------------------------c
c======================================================================= 
! ======================================================================
c======================================================================= 
      DOUBLE PRECISION FUNCTION MAX_NORM(Vec1, Vec2, N)
C 
C ------ VERSION 1   14APR1995    NORM
C       ********************************************************* 
C     MAXIMUMNORM OF TWO VECTORS
C     *********************************************************
C
C ------ INPUT:
      IMPLICIT NONE
C N          SIZE OF THE VECTORS
C VEC1, VEC2 VECTORS
C
C ------ OUTPUT:
C MAX_NORM RESULT OF THE NORM
cjena double precision max_norm
C
C ------ INTERNAL VARIABLES:
C I           INDEX      
      INTRINSIC DABS
! Arguments
      INTEGER, INTENT(IN) :: N
      DOUBLE PRECISION, INTENT(IN) :: Vec1(N), Vec2(N)
! Local Variables
      INTEGER i
!     ------------------------------------------------------------------
c
      MAX_NORM = 0.0D0
      DO i = 1, N
        IF ( MAX_NORM.LT.DABS(Vec1(i)-Vec2(i)) )                        &
     &       MAX_NORM = DABS(Vec1(i)-Vec2(i))
      ENDDO
      END FUNCTION MAX_NORM
c 
CBARC***END FM SUBROUTINE
c=======================================================================
! ======================================================================
c======================================================================= 
      SUBROUTINE CFPBCF7BDCH(Kstp, Kper, Igrid)
C     ******************************************************************
C     COMPUTE FLOW FROM CONSTANT-HEAD CELLS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE GLOBAL, ONLY:Ncol, Nrow, Nlay, Ibound, Hnew, Buff, Cr, Cc, Cv,&
     &    Botm, Lbotm, Iout
      USE GWFBASMODULE, ONLY:Msum, Vbvl, Vbnm, Delt, Pertim, Totim,     &
     &    Icbcfl, Ichflg
      USE GWFBCFMODULE, ONLY:Ibcfcb, Laycon
      USE CFPMODULE, ONLY:Mode, Mod2, Ncond, B, Nodebot, ZERO

      IMPLICIT NONE
! Arguments
      INTEGER, INTENT(IN) :: Kstp, Kper, Igrid
! Local Variables
      DOUBLE PRECISION chch1, chch2, chch3, chch4, chch5, chch6
      DOUBLE PRECISION cin, cout, hdiff, rate, tmp
      DOUBLE PRECISION x1, x2, x3, x4, x5, x6, x7, xx7
      DOUBLE PRECISION hd, chin, chout, xx1, xx2, xx3, xx4, xx5, xx6
CBARC**ADD XX7 FOR CONDUIT FLOW RATE
C
      INTEGER i, ibd, ibdlbl, j, k, lc, nch, nncond
      CHARACTER(LEN=16) text
      DATA text/'   CONSTANT HEAD'/
C     ------------------------------------------------------------------
      IF ( Mode.EQ.2 ) THEN 
	 CALL GWF2BCF7BDCH(KSTP,KPER,IGRID)
	 RETURN
	ENDIF
c
      CALL SGWF2BCF7PNT(Igrid)
C
C1------SET IBD TO INDICATE IF CELL-BY-CELL BUDGET VALUES WILL BE SAVED.
      ibd = 0
      IF ( Ibcfcb.LT.0 .AND. Icbcfl.NE.0 ) ibd = -1
      IF ( Ibcfcb.GT.0 ) ibd = Icbcfl
C
C2------CLEAR BUDGET ACCUMULATORS.
      chin = ZERO
      chout = ZERO
      ibdlbl = 0
C
C3------CLEAR BUFFER.
      DO k = 1, Nlay
        DO i = 1, Nrow
          DO j = 1, Ncol
            Buff(j, i, k) = ZERO
          ENDDO
        ENDDO
      ENDDO
C
C3A-----IF SAVING CELL-BY-CELL FLOW IN A LIST, COUNT CONSTANT-HEAD
C3A-----CELLS AND WRITE HEADER RECORDS.
      IF ( ibd.EQ.2 ) THEN
        nch = 0
        DO k = 1, Nlay
          DO i = 1, Nrow
            DO j = 1, Ncol
              IF ( Ibound(j,i,k).LT.0 ) nch = nch + 1
            ENDDO
          ENDDO
        ENDDO
        CALL UBDSV2(Kstp, Kper, text, Ibcfcb, Ncol, Nrow, Nlay, nch,    &
     &              Iout, Delt, Pertim, Totim, Ibound)
      ENDIF
C
C4------LOOP THROUGH EACH CELL AND CALCULATE FLOW INTO MODEL FROM EACH
C4------CONSTANT-HEAD CELL.
      DO k = 1, Nlay
        lc = Laycon(k)
        DO i = 1, Nrow
          DO j = 1, Ncol
C
C5------IF CELL IS NOT CONSTANT HEAD SKIP IT & GO ON TO NEXT CELL.
            IF ( Ibound(j,i,k).LT.0 ) THEN
C
C6------CLEAR VALUES FOR FLOW RATE THROUGH EACH FACE OF CELL.
              x1 = ZERO
              x2 = ZERO
              x3 = ZERO
              x4 = ZERO
              x5 = ZERO
              x6 = ZERO
CBARC**ADD X7 FOR CONDUIT
              x7 = ZERO
              xx7 = ZERO
 
              chch1 = ZERO
              chch2 = ZERO
              chch3 = ZERO
              chch4 = ZERO
              chch5 = ZERO
              chch6 = ZERO
CBARC**ADD X7 FOR CONDUIT
 
C
C7------CALCULATE FLOW THROUGH THE LEFT FACE.
C7------COMMENTS A-C APPEAR ONLY IN THE SECTION HEADED BY COMMENT 7,
C7------BUT THEY APPLY IN A SIMILAR MANNER TO SECTIONS 8-12.
C
C7A-----IF THERE IS NO FLOW TO CALCULATE THROUGH THIS FACE, THEN GO ON
C7A-----TO NEXT FACE.  NO FLOW OCCURS AT THE EDGE OF THE GRID, TO AN
C7A-----ADJACENT NO-FLOW CELL, OR TO AN ADJACENT CONSTANT-HEAD CELL.
              IF ( j.NE.1 ) THEN
                IF ( Ibound(j-1,i,k).NE.0 ) THEN
                  IF ( Ibound(j-1,i,k).GE.0 .OR. Ichflg.NE.0 ) THEN
C
C7B-----CALCULATE FLOW THROUGH THIS FACE INTO THE ADJACENT CELL.
                    hdiff = Hnew(j, i, k) - Hnew(j-1, i, k)
                    chch1 = hdiff*Cr(j-1, i, k)
                    IF ( Ibound(j-1,i,k).GE.0 ) THEN
                      x1 = chch1
                      xx1 = x1
C
C7C-----ACCUMULATE POSITIVE AND NEGATIVE FLOW.
                      IF ( x1.LT.ZERO ) THEN
                        chout = chout - xx1
                      ELSE
                        chin = chin + xx1
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C8------CALCULATE FLOW THROUGH THE RIGHT FACE.
              IF ( j.NE.Ncol ) THEN
                IF ( Ibound(j+1,i,k).NE.0 ) THEN
                  IF ( Ibound(j+1,i,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hdiff = Hnew(j, i, k) - Hnew(j+1, i, k)
                    chch2 = hdiff*Cr(j, i, k)
                    IF ( Ibound(j+1,i,k).GE.0 ) THEN
                      x2 = chch2
                      xx2 = x2
                      IF ( x2.LT.ZERO ) THEN
                        chout = chout - xx2
                      ELSE
                        chin = chin + xx2
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C9------CALCULATE FLOW THROUGH THE BACK FACE.
              IF ( i.NE.1 ) THEN
                IF ( Ibound(j,i-1,k).NE.0 ) THEN
                  IF ( Ibound(j,i-1,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hdiff = Hnew(j, i, k) - Hnew(j, i-1, k)
                    chch3 = hdiff*Cc(j, i-1, k)
                    IF ( Ibound(j,i-1,k).GE.0 ) THEN
                      x3 = chch3
                      xx3 = x3
                      IF ( x3.LT.ZERO ) THEN
                        chout = chout - xx3
                      ELSE
                        chin = chin + xx3
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C10-----CALCULATE FLOW THROUGH THE FRONT FACE.
              IF ( i.NE.Nrow ) THEN
                IF ( Ibound(j,i+1,k).NE.0 ) THEN
                  IF ( Ibound(j,i+1,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hdiff = Hnew(j, i, k) - Hnew(j, i+1, k)
                    chch4 = hdiff*Cc(j, i, k)
                    IF ( Ibound(j,i+1,k).GE.0 ) THEN
                      x4 = chch4
                      xx4 = x4
                      IF ( x4.LT.ZERO ) THEN
                        chout = chout - xx4
                      ELSE
                        chin = chin + xx4
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C11-----CALCULATE FLOW THROUGH THE UPPER FACE.
              IF ( k.NE.1 ) THEN
                IF ( Ibound(j,i,k-1).NE.0 ) THEN
                  IF ( Ibound(j,i,k-1).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hd = Hnew(j, i, k)
                    IF ( lc.EQ.3 .OR. lc.EQ.2 ) THEN
                      tmp = hd
                      IF ( tmp.LT.Botm(j,i,Lbotm(k)-1) )                &
     &                     hd = Botm(j, i, Lbotm(k)-1)
                    ENDIF
                    hdiff = hd - Hnew(j, i, k-1)
                    chch5 = hdiff*Cv(j, i, k-1)
                    IF ( Ibound(j,i,k-1).GE.0 ) THEN
                      x5 = chch5
                      xx5 = x5
                      IF ( x5.LT.ZERO ) THEN
                        chout = chout - xx5
                      ELSE
                        chin = chin + xx5
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C12-----CALCULATE FLOW THROUGH THE LOWER FACE.
              IF ( k.NE.Nlay ) THEN
                IF ( Ibound(j,i,k+1).NE.0 ) THEN
                  IF ( Ibound(j,i,k+1).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hd = Hnew(j, i, k+1)
                    IF ( Laycon(k+1).EQ.3 .OR. Laycon(k+1).EQ.2 ) THEN
                      tmp = hd
                      IF ( tmp.LT.Botm(j,i,Lbotm(k+1)-1) )              &
     &                     hd = Botm(j, i, Lbotm(k+1)-1)
                    ENDIF
                    hdiff = Hnew(j, i, k) - hd
                    chch6 = hdiff*Cv(j, i, k)
                    IF ( Ibound(j,i,k+1).GE.0 ) THEN
                      x6 = chch6
                      xx6 = x6
                      IF ( x6.LT.ZERO ) THEN
                        chout = chout - xx6
                      ELSE
                        chin = chin + xx6
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C13-----SUM THE FLOWS THROUGH SIX FACES OF CONSTANT HEAD CELL, AND
C13-----STORE SUM IN BUFFER.
              rate = chch1 + chch2 + chch3 + chch4 + chch5 + chch6
 
 
cbirk  calculate flow to or from conduit
              IF ( Ncond(j,i,k).NE.0 ) THEN
                nncond = Ncond(j, i, k)
                hdiff = B(nncond) - Hnew(j, i, k)
 
Cseba--INCLUDE DRY NODES. DON'T CALCULATE RATE IF NODE IS DRY
cb      PRINT *, B(nncond), Nodebot(nncond)
cb      IF(B(NNCOND).LT.NODEBOT(nncond)) GO TO 190
 
                x7 = -Mod2(nncond)*hdiff
                xx7 = x7
 
                IF ( xx7.LT.ZERO ) THEN
                  chout = chout - xx7
                ELSEIF ( xx7.GT.ZERO ) THEN
                  chin = chin + xx7
                ENDIF
              ENDIF
cbirk add conduit flow x7 to rate
              rate = rate + xx7
 
              Buff(j, i, k) = rate
C
C14-----PRINT THE FLOW FOR THE CELL IF REQUESTED.
              IF ( ibd.LT.0 ) THEN
                IF ( ibdlbl.EQ.0 ) WRITE (Iout, 9001) text, Kper, Kstp
                WRITE (Iout, 9002) k, i, j, rate
                ibdlbl = 1
              ENDIF
C
C15-----IF SAVING CELL-BY-CELL FLOW IN LIST, WRITE FLOW FOR CELL.
              IF ( ibd.EQ.2 ) CALL UBDSVA(Ibcfcb, Ncol, Nrow, j, i, k,  &
     &             rate, Ibound, Nlay)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C
C16-----IF SAVING CELL-BY-CELL FLOW IN 3-D ARRAY, WRITE THE ARRAY.
      IF ( ibd.EQ.1 ) CALL UBUDSV(Kstp, Kper, text, Ibcfcb, Buff, Ncol, &
     &                            Nrow, Nlay, Iout)
C
C17-----SAVE TOTAL CONSTANT HEAD FLOWS AND VOLUMES IN VBVL TABLE
C17-----FOR INCLUSION IN BUDGET. PUT LABELS IN VBNM TABLE.
      cin = chin
      cout = chout
      Vbvl(1, Msum) = Vbvl(1, Msum) + cin*Delt
      Vbvl(2, Msum) = Vbvl(2, Msum) + cout*Delt
      Vbvl(3, Msum) = cin
      Vbvl(4, Msum) = cout
      Vbnm(Msum) = text
      Msum = Msum + 1
c 
 9001 FORMAT (1X, /, 1X, A, '   PERIOD', I3, '   STEP', I3)
 9002 FORMAT (1X, 'LAYER', I3, '   ROW', I4, '   COL', I4, '   RATE',   &
     &        1PG15.6)
C
C18-----RETURN.
      END SUBROUTINE CFPBCF7BDCH
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE CFPLPF7BDCH(Kstp, Kper, Igrid)
C     ******************************************************************
C     COMPUTE FLOW FROM CONSTANT-HEAD CELLS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE GLOBAL, ONLY:Ncol, Nrow, Nlay, Ibound, Hnew, Buff, Cr, Cc, Cv,&
     &    Botm, Lbotm, Iout
      USE GWFBASMODULE, ONLY:Msum, Vbvl, Vbnm, Delt, Pertim, Totim,     &
     &    Icbcfl, Ichflg
      USE GWFLPFMODULE, ONLY:Ilpfcb, Laytyp

CBARC**USE CFP MODULE 
      USE CFPMODULE, ONLY:Mod2, Ncond, B, ZERO, Mode
c
      IMPLICIT NONE
c
! Arguments
      INTEGER, INTENT(IN) :: Kstp, Kper, Igrid
! Local Variables
      DOUBLE PRECISION chch1, chch2, chch3, chch4, chch5, chch6
      DOUBLE PRECISION cin, cout, hdiff, rate, tmp, top
      DOUBLE PRECISION x1, x2, x3, x4, x5, x6, x7, xx7
      DOUBLE PRECISION hd, chin, chout, xx1, xx2, xx3, xx4, xx5, xx6
      INTEGER i, ibd, ibdlbl, j, k, nch, nncond
c
CBARC**ADD XX7 FOR CONDUIT FLOW RATE      
c
      CHARACTER(LEN=16) text
C
      DATA text/'   CONSTANT HEAD'/
C     ------------------------------------------------------------------
      IF ( Mode.EQ.2 ) THEN 
	 CALL GWF2LPF7BDCH(KSTP,KPER,IGRID)
	 RETURN
      ENDIF

cbarc**
      CALL SGWF2LPF7PNT(Igrid)
cb    CALL GWF2LPF7PNT(IGRID)
C
C1------SET IBD TO INDICATE IF CELL-BY-CELL BUDGET VALUES WILL BE SAVED.
      ibd = 0
      IF ( Ilpfcb.LT.0 .AND. Icbcfl.NE.0 ) ibd = -1
      IF ( Ilpfcb.GT.0 ) ibd = Icbcfl
C
C2------CLEAR BUDGET ACCUMULATORS.
      chin = ZERO
      chout = ZERO
      ibdlbl = 0
C
C3------CLEAR BUFFER.
      DO k = 1, Nlay
        DO i = 1, Nrow
          DO j = 1, Ncol
            Buff(j, i, k) = ZERO
          ENDDO
        ENDDO
      ENDDO
C
C3A-----IF SAVING CELL-BY-CELL FLOW IN A LIST, COUNT CONSTANT-HEAD
C3A-----CELLS AND WRITE HEADER RECORDS.
      IF ( ibd.EQ.2 ) THEN
        nch = 0
        DO k = 1, Nlay
          DO i = 1, Nrow
            DO j = 1, Ncol
              IF ( Ibound(j,i,k).LT.0 ) nch = nch + 1
            ENDDO
          ENDDO
        ENDDO
        CALL UBDSV2(Kstp, Kper, text, Ilpfcb, Ncol, Nrow, Nlay, nch,    &
     &              Iout, Delt, Pertim, Totim, Ibound)
      ENDIF
C
C4------LOOP THROUGH EACH CELL AND CALCULATE FLOW INTO MODEL FROM EACH
C4------CONSTANT-HEAD CELL.
      DO k = 1, Nlay
        DO i = 1, Nrow
          DO j = 1, Ncol
C
C5------IF CELL IS NOT CONSTANT HEAD SKIP IT & GO ON TO NEXT CELL.
            IF ( Ibound(j,i,k).LT.0 ) THEN
C
C6------CLEAR VALUES FOR FLOW RATE THROUGH EACH FACE OF CELL.
              x1 = ZERO
              x2 = ZERO
              x3 = ZERO
              x4 = ZERO
              x5 = ZERO
              x6 = ZERO
CBARC**ADD X7 FOR CONDUIT
              x7 = ZERO
              xx7 = ZERO
c 
              chch1 = ZERO
              chch2 = ZERO
              chch3 = ZERO
              chch4 = ZERO
              chch5 = ZERO
              chch6 = ZERO
CBARC**ADD X7 FOR CONDUIT
!             chch7 = ZERO              
c
C
C7------CALCULATE FLOW THROUGH THE LEFT FACE.
C7------COMMENTS A-C APPEAR ONLY IN THE SECTION HEADED BY COMMENT 7,
C7------BUT THEY APPLY IN A SIMILAR MANNER TO SECTIONS 8-12.
C
C7A-----IF THERE IS NO FLOW TO CALCULATE THROUGH THIS FACE, THEN GO ON
C7A-----TO NEXT FACE.  NO FLOW OCCURS AT THE EDGE OF THE GRID, TO AN
C7A-----ADJACENT NO-FLOW CELL, OR TO AN ADJACENT CONSTANT-HEAD CELL.
              IF ( j.NE.1 ) THEN
                IF ( Ibound(j-1,i,k).NE.0 ) THEN
                  IF ( Ibound(j-1,i,k).GE.0 .OR. Ichflg.NE.0 ) THEN
C
C7B-----CALCULATE FLOW THROUGH THIS FACE INTO THE ADJACENT CELL.
                    hdiff = Hnew(j, i, k) - Hnew(j-1, i, k)
                    chch1 = hdiff*Cr(j-1, i, k)
                    IF ( Ibound(j-1,i,k).GE.0 ) THEN
                      x1 = chch1
                      xx1 = x1
C
C7C-----ACCUMULATE POSITIVE AND NEGATIVE FLOW.
                      IF ( x1.LT.ZERO ) THEN
                        chout = chout - xx1
                      ELSE
                        chin = chin + xx1
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C8------CALCULATE FLOW THROUGH THE RIGHT FACE.
              IF ( j.NE.Ncol ) THEN
                IF ( Ibound(j+1,i,k).NE.0 ) THEN
                  IF ( Ibound(j+1,i,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hdiff = Hnew(j, i, k) - Hnew(j+1, i, k)
                    chch2 = hdiff*Cr(j, i, k)
                    IF ( Ibound(j+1,i,k).GE.0 ) THEN
                      x2 = chch2
                      xx2 = x2
                      IF ( x2.LT.ZERO ) THEN
                        chout = chout - xx2
                      ELSE
                        chin = chin + xx2
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C9------CALCULATE FLOW THROUGH THE BACK FACE.
              IF ( i.NE.1 ) THEN
                IF ( Ibound(j,i-1,k).NE.0 ) THEN
                  IF ( Ibound(j,i-1,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hdiff = Hnew(j, i, k) - Hnew(j, i-1, k)
                    chch3 = hdiff*Cc(j, i-1, k)
                    IF ( Ibound(j,i-1,k).GE.0 ) THEN
                      x3 = chch3
                      xx3 = x3
                      IF ( x3.LT.ZERO ) THEN
                        chout = chout - xx3
                      ELSE
                        chin = chin + xx3
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C10-----CALCULATE FLOW THROUGH THE FRONT FACE.
              IF ( i.NE.Nrow ) THEN
                IF ( Ibound(j,i+1,k).NE.0 ) THEN
                  IF ( Ibound(j,i+1,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hdiff = Hnew(j, i, k) - Hnew(j, i+1, k)
                    chch4 = hdiff*Cc(j, i, k)
                    IF ( Ibound(j,i+1,k).GE.0 ) THEN
                      x4 = chch4
                      xx4 = x4
                      IF ( x4.LT.ZERO ) THEN
                        chout = chout - xx4
                      ELSE
                        chin = chin + xx4
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C11-----CALCULATE FLOW THROUGH THE UPPER FACE.
              IF ( k.NE.1 ) THEN
                IF ( Ibound(j,i,k-1).NE.0 ) THEN
                  IF ( Ibound(j,i,k-1).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hd = Hnew(j, i, k)
                    IF ( Laytyp(k).NE.0 ) THEN
                      tmp = hd
                      top = Botm(j, i, Lbotm(k)-1)
                      IF ( tmp.LT.top ) hd = top
                    ENDIF
                    hdiff = hd - Hnew(j, i, k-1)
                    chch5 = hdiff*Cv(j, i, k-1)
                    IF ( Ibound(j,i,k-1).GE.0 ) THEN
                      x5 = chch5
                      xx5 = x5
                      IF ( x5.LT.ZERO ) THEN
                        chout = chout - xx5
                      ELSE
                        chin = chin + xx5
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C12-----CALCULATE FLOW THROUGH THE LOWER FACE.
              IF ( k.NE.Nlay ) THEN
                IF ( Ibound(j,i,k+1).NE.0 ) THEN
                  IF ( Ibound(j,i,k+1).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hd = Hnew(j, i, k+1)
                    IF ( Laytyp(k+1).NE.0 ) THEN
                      tmp = hd
                      top = Botm(j, i, Lbotm(k+1)-1)
                      IF ( tmp.LT.top ) hd = top
                    ENDIF
                    hdiff = Hnew(j, i, k) - hd
                    chch6 = hdiff*Cv(j, i, k)
                    IF ( Ibound(j,i,k+1).GE.0 ) THEN
                      x6 = chch6
                      xx6 = x6
                      IF ( x6.LT.ZERO ) THEN
                        chout = chout - xx6
                      ELSE
                        chin = chin + xx6
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C13-----SUM THE FLOWS THROUGH SIX FACES OF CONSTANT HEAD CELL, AND
C13-----STORE SUM IN BUFFER.
              rate = chch1 + chch2 + chch3 + chch4 + chch5 + chch6
 
cbirk  calculate flow to or from conduit
              IF ( Ncond(j,i,k).NE.0 ) THEN
                nncond = Ncond(j, i, k)
                hdiff = B(nncond) - Hnew(j, i, k)
Cseba--INCLUDE DRY NODES. DON'T CALCULATE RATE IF NODE IS DRY
C      IF(nodewd(NNCOND).LT.0) GO TO 190
cb      IF(B(NNCOND).LT.NODEBOT(nncond)) GO TO 190
 
                x7 = -Mod2(nncond)*hdiff
                xx7 = x7
 
                IF ( xx7.LT.ZERO ) THEN
                  chout = chout - xx7
                ELSEIF ( xx7.GT.ZERO ) THEN
                  chin = chin + xx7
                ENDIF
              ENDIF
cbirk add conduit flow x7 to rate
              rate = rate + xx7
c 
              Buff(j, i, k) = rate
C
C14-----PRINT THE FLOW FOR THE CELL IF REQUESTED.
              IF ( ibd.LT.0 ) THEN
                IF ( ibdlbl.EQ.0 ) WRITE (Iout, 9001) text, Kper, Kstp
                WRITE (Iout, 9002) k, i, j, rate
                ibdlbl = 1
              ENDIF
C
C15-----IF SAVING CELL-BY-CELL FLOW IN LIST, WRITE FLOW FOR CELL.
              IF ( ibd.EQ.2 ) CALL UBDSVA(Ilpfcb, Ncol, Nrow, j, i, k,  &
     &             rate, Ibound, Nlay)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C
C16-----IF SAVING CELL-BY-CELL FLOW IN 3-D ARRAY, WRITE THE ARRAY.
      IF ( ibd.EQ.1 ) CALL UBUDSV(Kstp, Kper, text, Ilpfcb, Buff, Ncol, &
     &                            Nrow, Nlay, Iout)
C
C17-----SAVE TOTAL CONSTANT HEAD FLOWS AND VOLUMES IN VBVL TABLE
C17-----FOR INCLUSION IN BUDGET. PUT LABELS IN VBNM TABLE.
      cin = chin
      cout = chout
      Vbvl(1, Msum) = Vbvl(1, Msum) + cin*Delt
      Vbvl(2, Msum) = Vbvl(2, Msum) + cout*Delt
      Vbvl(3, Msum) = cin
      Vbvl(4, Msum) = cout
      Vbnm(Msum) = text
      Msum = Msum + 1
c 
 9001 FORMAT (1X, /, 1X, A, '   PERIOD', I5, '   STEP', I4)
 9002 FORMAT (' LAYER', I4, '   ROW', I6, '   COL', I6, '   RATE',      &
     &        1PG16.6)
C
C18-----RETURN.
      END SUBROUTINE CFPLPF7BDCH
c====================================================================== 
c======================================================================
      SUBROUTINE CFPHUF7BDCH(Kstp, Kper, Ilvda, Igrid)
cbarc**modified to work with CFP mode 1 pipes
C     ******************************************************************
C     COMPUTE FLOW FROM CONSTANT-HEAD CELLS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE GLOBAL, ONLY:Ncol, Nrow, Nlay, Ibound, Hnew, Buff, Cr, Cc, Cv,&
     &    Botm, Lbotm, Iout
      USE GWFBASMODULE, ONLY:Msum, Vbvl, Vbnm, Delt, Pertim, Totim,     &
     &    Icbcfl, Ichflg
      USE GWFHUFMODULE, ONLY:Lthuf, Ihufcb, Vdht
c
CBARC**USE CFP MODULE      
      USE CFPMODULE, ONLY:Mode, Mod2, Ncond, B, ZERO
c
      IMPLICIT NONE
c
! Arguments
      INTEGER, INTENT(IN) :: Igrid, Ilvda, Kper, Kstp
! Local Variables
      DOUBLE PRECISION chch1, chch2, chch3, chch4, chch5, chch6, cin
      DOUBLE PRECISION cout, hdiff, rate, tmp, top
      DOUBLE PRECISION x1, x2, x3, x4, x5, x6, x7
      INTEGER i, ibd, ibdlbl, j, k, nch, nncond
cbarc**modified to work with CFP mode 1 pipes
      DOUBLE PRECISION hd, chin, chout, xx1, xx2, xx3, xx4, xx5, xx6
      DOUBLE PRECISION dfl, dfr, dft, dfb, xx7
c
CBARC**ADD XX7 FOR CONDUIT FLOW RATE
c
      CHARACTER(LEN=16) text
C
      DATA text/'   CONSTANT HEAD'/
C     ------------------------------------------------------------------
      IF ( Mode.EQ.2 ) THEN 
       CALL GWF2HUF7BDCH(KSTP,KPER,ILVDA,IGRID)
	 RETURN
      ENDIF
c
c
      CALL SGWF2HUF7PNT(Igrid)
C
C1------SET IBD TO INDICATE IF CELL-BY-CELL BUDGET VALUES WILL BE SAVED.
      ibd = 0
      IF ( Ihufcb.LT.0 .AND. Icbcfl.NE.0 ) ibd = -1
      IF ( Ihufcb.GT.0 ) ibd = Icbcfl
C
C2------CLEAR BUDGET ACCUMULATORS.
      chin = ZERO
      chout = ZERO
      ibdlbl = 0
C
C3------CLEAR BUFFER.
      DO k = 1, Nlay
        DO i = 1, Nrow
          DO j = 1, Ncol
            Buff(j, i, k) = ZERO
          ENDDO
        ENDDO
      ENDDO
C
C3A-----IF SAVING CELL-BY-CELL FLOW IN A LIST, COUNT CONSTANT-HEAD
C3A-----CELLS AND WRITE HEADER RECORDS.
      IF ( ibd.EQ.2 ) THEN
        nch = 0
        DO k = 1, Nlay
          DO i = 1, Nrow
            DO j = 1, Ncol
              IF ( Ibound(j,i,k).LT.0 ) nch = nch + 1
            ENDDO
          ENDDO
        ENDDO
        CALL UBDSV2(Kstp, Kper, text, Ihufcb, Ncol, Nrow, Nlay, nch,    &
     &              Iout, Delt, Pertim, Totim, Ibound)
      ENDIF
C
C4------LOOP THROUGH EACH CELL AND CALCULATE FLOW INTO MODEL FROM EACH
C4------CONSTANT-HEAD CELL.
      DO k = 1, Nlay
        DO i = 1, Nrow
          DO j = 1, Ncol
C
C5------IF CELL IS NOT CONSTANT HEAD SKIP IT & GO ON TO NEXT CELL.
            IF ( Ibound(j,i,k).LT.0 ) THEN
C
C6------CLEAR VALUES FOR FLOW RATE THROUGH EACH FACE OF CELL.
              x1 = ZERO
              x2 = ZERO
              x3 = ZERO
              x4 = ZERO
              x5 = ZERO
              x6 = ZERO
CBARC**ADD X7 FOR CONDUIT
              x7 = ZERO
              xx7 = ZERO
 
              chch1 = ZERO
              chch2 = ZERO
              chch3 = ZERO
              chch4 = ZERO
              chch5 = ZERO
              chch6 = ZERO
c 
              IF ( Ilvda.GT.0 ) CALL SGWF2HUF7VDF9(i, j, k, Vdht, Hnew, &
     &             Ibound, Nlay, Nrow, Ncol, dfl, dfr, dft, dfb)
C7------CALCULATE FLOW THROUGH THE LEFT FACE.
C7------COMMENTS A-C APPEAR ONLY IN THE SECTION HEADED BY COMMENT 7,
C7------BUT THEY APPLY IN A SIMILAR MANNER TO SECTIONS 8-12.
C
C7A-----IF THERE IS NO FLOW TO CALCULATE THROUGH THIS FACE, THEN GO ON
C7A-----TO NEXT FACE.  NO FLOW OCCURS AT THE EDGE OF THE GRID, TO AN
C7A-----ADJACENT NO-FLOW CELL, OR TO AN ADJACENT CONSTANT-HEAD CELL.
              IF ( j.NE.1 ) THEN
                IF ( Ibound(j-1,i,k).NE.0 ) THEN
                  IF ( Ibound(j-1,i,k).GE.0 .OR. Ichflg.NE.0 ) THEN
C
C7B-----CALCULATE FLOW THROUGH THE LEFT FACE.
                    IF ( Ilvda.GT.0 ) THEN
                      chch1 = -dfl
                    ELSE
                      hdiff = Hnew(j, i, k) - Hnew(j-1, i, k)
                      chch1 = hdiff*Cr(j-1, i, k)
                    ENDIF
                    IF ( Ibound(j-1,i,k).GE.0 ) THEN
                      x1 = chch1
                      xx1 = x1
C
C7C-----ACCUMULATE POSITIVE AND NEGATIVE FLOW.
                      IF ( x1.LT.ZERO ) THEN
                        chout = chout - xx1
!rsr                  ELSEIF ( x1.NE.ZERO ) THEN
                      ELSE
                        chin = chin + xx1
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C8------CALCULATE FLOW THROUGH THE RIGHT FACE.
              IF ( j.NE.Ncol ) THEN
                IF ( Ibound(j+1,i,k).NE.0 ) THEN
                  IF ( Ibound(j+1,i,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    IF ( Ilvda.GT.0 ) THEN
                      chch2 = dfr
                    ELSE
                      hdiff = Hnew(j, i, k) - Hnew(j+1, i, k)
                      chch2 = hdiff*Cr(j, i, k)
                    ENDIF
                    IF ( Ibound(j+1,i,k).GE.0 ) THEN
                      x2 = chch2
                      xx2 = x2
                      IF ( x2.LT.ZERO ) THEN
                        chout = chout - xx2
!rsr                  ELSEIF ( x2.NE.ZERO ) THEN
                      ELSE
                        chin = chin + xx2
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C9------CALCULATE FLOW THROUGH THE BACK FACE.
              IF ( i.NE.1 ) THEN
                IF ( Ibound(j,i-1,k).NE.0 ) THEN
                  IF ( Ibound(j,i-1,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    IF ( Ilvda.GT.0 ) THEN
                      chch3 = -dft
                    ELSE
                      hdiff = Hnew(j, i, k) - Hnew(j, i-1, k)
                      chch3 = hdiff*Cc(j, i-1, k)
                    ENDIF
                    IF ( Ibound(j,i-1,k).GE.0 ) THEN
                      x3 = chch3
                      xx3 = x3
                      IF ( x3.LT.ZERO ) THEN
                        chout = chout - xx3
!rsr                  ELSEIF ( x3.NE.ZERO ) THEN
                      ELSE
                        chin = chin + xx3
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C10-----CALCULATE FLOW THROUGH THE FRONT FACE.
              IF ( i.NE.Nrow ) THEN
                IF ( Ibound(j,i+1,k).NE.0 ) THEN
                  IF ( Ibound(j,i+1,k).GE.0 .OR. Ichflg.NE.0 ) THEN
                    IF ( Ilvda.GT.0 ) THEN
                      chch4 = dfb
                    ELSE
                      hdiff = Hnew(j, i, k) - Hnew(j, i+1, k)
                      chch4 = hdiff*Cc(j, i, k)
                    ENDIF
                    IF ( Ibound(j,i+1,k).GE.0 ) THEN
                      x4 = chch4
                      xx4 = x4
                      IF ( x4.LT.ZERO ) THEN
                        chout = chout - xx4
!rsr                  ELSEIF ( x4.NE.ZERO ) THEN
                      ELSE
                        chin = chin + xx4
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C11-----CALCULATE FLOW THROUGH THE UPPER FACE.
              IF ( k.NE.1 ) THEN
                IF ( Ibound(j,i,k-1).NE.0 ) THEN
                  IF ( Ibound(j,i,k-1).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hd = Hnew(j, i, k)
                    IF ( Lthuf(k).NE.0 ) THEN
                      tmp = hd
                      top = Botm(j, i, Lbotm(k)-1)
                      IF ( tmp.LT.top ) hd = top
                    ENDIF
                    hdiff = hd - Hnew(j, i, k-1)
                    chch5 = hdiff*Cv(j, i, k-1)
                    IF ( Ibound(j,i,k-1).GE.0 ) THEN
                      x5 = chch5
                      xx5 = x5
                      IF ( x5.LT.ZERO ) THEN
                        chout = chout - xx5
!rsr                  ELSEIF ( x5.NE.ZERO ) THEN
                      ELSE
                        chin = chin + xx5
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C12-----CALCULATE FLOW THROUGH THE LOWER FACE.
              IF ( k.NE.Nlay ) THEN
                IF ( Ibound(j,i,k+1).NE.0 ) THEN
                  IF ( Ibound(j,i,k+1).GE.0 .OR. Ichflg.NE.0 ) THEN
                    hd = Hnew(j, i, k+1)
                    IF ( Lthuf(k+1).NE.0 ) THEN
                      tmp = hd
                      top = Botm(j, i, Lbotm(k+1)-1)
                      IF ( tmp.LT.top ) hd = top
                    ENDIF
                    hdiff = Hnew(j, i, k) - hd
                    chch6 = hdiff*Cv(j, i, k)
                    IF ( Ibound(j,i,k+1).GE.0 ) THEN
                      x6 = chch6
                      xx6 = x6
                      IF ( x6.LT.ZERO ) THEN
                        chout = chout - xx6
!rsr                  ELSEIF ( x6.NE.ZERO ) THEN
                      ELSE
                        chin = chin + xx6
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
C
C13-----SUM THE FLOWS THROUGH SIX FACES OF CONSTANT HEAD CELL, AND
C13-----STORE SUM IN BUFFER.
              rate = chch1 + chch2 + chch3 + chch4 + chch5 + chch6
 
cbirk  calculate flow to or from conduit
              IF ( Ncond(j,i,k).NE.0 ) THEN
                nncond = Ncond(j, i, k)
                hdiff = B(nncond) - Hnew(j, i, k)
                x7 = -Mod2(nncond)*hdiff
                xx7 = x7
                IF ( xx7.LT.ZERO ) THEN
                  chout = chout - xx7
                ELSEIF ( xx7.GT.ZERO ) THEN
                  chin = chin + xx7
                ENDIF
              ENDIF
cbirk add conduit flow x7 to rate
              rate = rate + xx7
 
 
              Buff(j, i, k) = rate
C
C14-----PRINT THE FLOW FOR THE CELL IF REQUESTED.
              IF ( ibd.LT.0 ) THEN
                IF ( ibdlbl.EQ.0 ) WRITE (Iout, 9001) text, Kper, Kstp
                WRITE (Iout, 9002) k, i, j, rate
                ibdlbl = 1
              ENDIF
C
C15-----IF SAVING CELL-BY-CELL FLOW IN LIST, WRITE FLOW FOR CELL.
              IF ( ibd.EQ.2 ) CALL UBDSVA(Ihufcb, Ncol, Nrow, j, i, k,  &
     &             rate, Ibound, Nlay)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C
C16-----IF SAVING CELL-BY-CELL FLOW IN 3-D ARRAY, WRITE THE ARRAY.
      IF ( ibd.EQ.1 ) CALL UBUDSV(Kstp, Kper, text, Ihufcb, Buff, Ncol, &
     &                            Nrow, Nlay, Iout)
C
C17-----SAVE TOTAL CONSTANT HEAD FLOWS AND VOLUMES IN VBVL TABLE
C17-----FOR INCLUSION IN BUDGET. PUT LABELS IN VBNM TABLE.
      cin = chin
      cout = chout
      Vbvl(1, Msum) = Vbvl(1, Msum) + cin*Delt
      Vbvl(2, Msum) = Vbvl(2, Msum) + cout*Delt
      Vbvl(3, Msum) = cin
      Vbvl(4, Msum) = cout
      Vbnm(Msum) = text
      Msum = Msum + 1
 
 9001 FORMAT (1X, /, 1X, A, '   PERIOD', I3, '   STEP', I3)
 9002 FORMAT (1X, 'LAYER', I3, '   ROW', I4, '   COL', I4, '   RATE',   &
     &        1PG15.6)
C
C18-----RETURN.
      END SUBROUTINE CFPHUF7BDCH
c======================================================================= 
! ======================================================================
c======================================================================= 
c=======================================================================
      SUBROUTINE GWF2CFP1BD(Kper, Kstp, Incoc, Msum)
c=======================================================================
c
c     20JAN1998 CON5BD
c     *********************************************************************
c     CALCULATE VOLUMETRIC BUDGET FOR CONDUITS
c     *********************************************************************
c
c     This subroutine calculates rates and volumes transferred between the
c     fissured system (modflow) and the conduit system (conduit).
c
      USE CFPMODULE, ONLY:Mxnode, Nbr, B, Mod2, Matflow, Nodebot, ZERO, &
     &    Qmat, Mode, Ktsno, Ktstu, B_mat, B_mat_o

      USE GLOBAL, ONLY:Hnew, Ncol, Nrow, Nlay, Iout, Ibound, Buff

      USE GWFBASMODULE, ONLY:Delt, Pertim, Totim, Vbvl, Vbnm, Icbcfl

      IMPLICIT NONE
      EXTERNAL CONBUD, NODEBUD, FLOW_OUTPUT, BUDGET_OUTPUT, NWBOUT
      EXTERNAL TS1OUT

c     SPECIFICATIONS:
c     ---------------------------------------------------------------------
c     INPUT:
c     DELT     Length of the current time step
c     HCON(MXNODE)   Head in the conduit system [L]
c     HNEW(NCOL,NROW,NLAY) Head in the fissured system [L]
c     IBOUND(NCOL,NROW,NLAY) Status of each cell (see Modflow documentation)
c     ICBCFL   Flag for saving or printing cell-by-cell flow terms (see
c		     Modflow documentation: output control)
c     ICONCB   Flag and a unit number:
c		>0   unit number on which cell-by-cell flow terms
c		     will be recorded whenever ICBCFL is set
c		=0   cell-by-cell flow terms will not be printed
c		     or recorded
c		<0   exchange between fissured and conduit system
c		     will be printed whenever ICBCFL is set
c     IOUT     Unit number for writing the listing file
c     KPER     Stress period counter
c     KSTP     Time step counter
c     MOD(MXNODE)    Exchange coefficient for exchange between conduit and
c                    fissured system [L**2/T]
c     MXNODE   Number of nodes (conduit system)
c     NCOL     Number of columns
c     NEIBR(MXNODE,12) Neighbour nodes, tubes, location of node n:
c          (n,1) node number
c          (n,2) neighbour node 1
c          (n,3) neighbour node 2
c          (n,4) neighbour node 3
c          (n,5) neighbour node 4
c          (n,6) tube connecting node n and node 1
c          (n,7) tube connecting node n and node 2
c          (n,8) tube connecting node n and node 3
c          (n,9) tube connecting node n and node 4
c          (n,10) column
c          (n,11) row
c          (n,12) layer
c     NLAY     Number of layers
c     NROW     Number of rows
c
c
c     OUTPUT:
c     MATFLOW(MXNODE) Array in which exchange rates are saved [L**3/T]
c     MSUM            Counter for budget terms
c     VBNM(MSUM)      Labels for budget terms
c     VBVL(4,MSUM)    Flows for the volumetric budget term n:
c         (1,n) total flow into the fissured system during the simulation
c         (2,n) total flow out of the fissured system during the simulation
c         (3,n) flow rate into the fissured system for the current time step
c         (4,n) flow rate out of the fissured system for the current time step
c
c
c     INTERNAL:
c     BUFF(NCOL,NROW,NLAY) buffer used to accumulatem information
c     HHCON    hcon(ic,ir,il)
c     HHNEW    hnew(ic,ir,il)
c     I        Index for nodes
c     IBD      Cell-by-cell budget flag
c     IBDLBL   Flag used when printing cell-by-cell budget values in the
c              listing file so that the label is printed only once
c     IC       Index for columns
c     IL       Index for layers
c     IR       Index for rows
c     RATE     Exchange rate into the cell of the fissured system
c              from the node of the conduit system [L**3/T]
c     RATIN    Accumulator to which inflows are added [L**3/T]
c     RATOUT   Accumulator to which outflows are added [L**3/T]
c     TEXT     Label that identifies conduit data
c
! Arguments
      INTEGER, INTENT(IN) :: Kper, Kstp, Incoc
      INTEGER, INTENT(INOUT) :: Msum
! Local Variables
      INTEGER i, ibd, ibdlbl, ic, il, ir, iconcb
      DOUBLE PRECISION rate, ratin, ratout, hhnew, hhcon
      CHARACTER(LEN=16) text
C
      DATA text/'           PIPES'/

c     ---------------------------------------------------------------------
      IF ( Mode.EQ.2 ) RETURN
c
c
CBARC**FOR NOW SET ICONCB TO 0, LATER THIS WILL BE READ FROM FILE
      iconcb = 0
c 
c---initialize cell-by-cell flow term flag (ibd),ibdlbl and accumulators
c      (ratin and ratout)
      ratin = ZERO
      ratout = ZERO
      ibdlbl = 0
      ibd = 0
      IF ( Icbcfl.NE.0 .AND. iconcb.LT.0 ) ibd = -1
      IF ( iconcb.GT.0 ) ibd = Icbcfl
c---if cell-by-cell flow terms are saved as a list, write header
      IF ( ibd.EQ.2 ) CALL UBDSV2(Kstp, Kper, text, iconcb, Ncol, Nrow, &
     &                            Nlay, Mxnode, Iout, Delt, Pertim,     &
     &                            Totim, Ibound)
c---clear buffer
      DO il = 1, Nlay
        DO ir = 1, Nrow
          DO ic = 1, Ncol
            Buff(ic, ir, il) = 0
          ENDDO
        ENDDO
      ENDDO
c
c---for each conduit node accumulate exchange flow
      DO i = 1, Mxnode
c
c---get layer, row, column of cell containing conduit node
        ic = Nbr(i, 2)
        ir = Nbr(i, 3)
        il = Nbr(i, 4)
c---if cell is no flow move to next node
        IF ( Ibound(ic,ir,il).NE.0 ) THEN
c
c---get heads of fissured and conduit system
 
          hhnew = Hnew(ic, ir, il)
cbarc**for perched cases**
          IF ( hhnew.LT.Nodebot(i) ) hhnew = Nodebot(i)
cbarc**for dry conduit cases**
          hhcon = B(i)
          IF ( hhcon.LT.Nodebot(i) ) hhcon = Nodebot(i)
          rate = ZERO
c
c---calculate exchange rate
cbarc**need something in here for perched cases, and others ?
          rate = Mod2(i)*(hhcon-hhnew) 
c 
cbarc***add qmat for budget output
          Qmat(i) = rate
c---save exchange rate in matflow
          Matflow(i) = rate
c
c---print the individual rates if requested (iconcb<0)
          IF ( ibd.LT.0 ) THEN
            IF ( ibdlbl.EQ.0 ) WRITE (Iout, 9001) text, Kper, Kstp
            WRITE (Iout, 9002) i, il, ir, ic, rate
            ibdlbl = 1
          ENDIF
c
c---add rate to buffer
          Buff(ic, ir, il) = Buff(ic, ir, il) + rate
c
c---add rate to ratin if flow is into fissured system
          IF ( rate.GT.ZERO ) THEN
            ratin = ratin + rate
c---subtract rate from ratout if flow is into conduit system
          ELSEIF ( rate.LT.ZERO ) THEN
            ratout = ratout - rate
          ENDIF
        ENDIF
c
c---if saving cell-by-cell flows in list, write flow
        IF ( ibd.EQ.2 ) CALL UBDSVA(iconcb, Ncol, Nrow, ic, ir, il,     &
     &                              rate, Ibound, Nlay)
      ENDDO
c
c---if cell-by-cell flow terms will be saved as 3-D array
c---call ubudsv to record them
      IF ( ibd.EQ.1 ) CALL UBUDSV(Kstp, Kper, text, iconcb, Buff, Ncol, &
     &                            Nrow, Nlay, Iout)
c
c---move rates, volumes, labels into arrays for printing
      Vbvl(3, Msum) = ratin
      Vbvl(4, Msum) = ratout
      Vbvl(1, Msum) = Vbvl(1, Msum) + ratin*Delt
      Vbvl(2, Msum) = Vbvl(2, Msum) + ratout*Delt
      Vbnm(Msum) = text
c
c---increment budget term counter
      Msum = Msum + 1

Cbirk----BUDGET OF THE CONDUIT SYSTEM
      CALL CONBUD
Cbirk----BUDGET OF EVERY NODE
      CALL NODEBUD
Cbirk----CONDUIT PIPE FLOW
      CALL FLOW_OUTPUT(Kper, Kstp)
C--OUTPUT OF CONDUIT BUDGET
      CALL BUDGET_OUTPUT(Kper, Kstp)
C--WRITE NODE WATER BUDGET
      CALL NWBOUT(Kper, Kstp)
C--TIME SERIES OUTPUT
c
      IF ( Incoc.GT.0 ) CALL TS1OUT
c
cbarc**preserve old heads in conduit.
      B_mat_o = B_mat
c
 9001 FORMAT (1X, /1X, A, '   PERIOD', I3, '   STEP', I3)
 9002 FORMAT (1X, 'NODE', I4, '   LAYER', I3, '   ROW', I4, '   COL',   &
     &        I4, '   RATE', 1PG15.6)
c
      END SUBROUTINE GWF2CFP1BD
c======================================================================= 
! ======================================================================
c======================================================================= 
      SUBROUTINE CONBUD
C
CSEBA
C ------ VERSION 2 10DEZ1998 BUDGET
C     *****************************************************************
C       CALCULATE THE CONDUIT BUDGET
C     *****************************************************************
c
      USE CFPMODULE, ONLY:ZERO, NNOD, Qbdir, Mxnode, Nbr, Beghead,      &
     &    Matflow, Bud_source, Bud_sink, Bud_matin, Bud_matout, B,      &
     &    Bud_qbdir, Total_budget, Bud_total_step, Ts_in_mat, Ts_out,   &
     &    Ts_out_mat, Ts_bud_sink, Ts_bud_source, Ts_qbdir, Ts_in,      &
     &    Diff_tot, Diff_ts, Tot_flow, Ts_tot_flow, Itube, Dtube,       &
     &    Ku_in_mat, Ku_out_mat, Ku_qbdir, Geohight, Con_data, B_mat_o, &
     &    Bud_storage, Bud_storage_in, Bud_storage_out, Ts_bud_storage, &
     &    Ts_bud_storage_in, Ts_bud_storage_out, Node_loca, Qstor,      &
     &    Tortuos, ONE8TH, NEARZERO, TWOPII, TWO
c
      USE GWFBASMODULE, ONLY:Totim
c
      IMPLICIT NONE
      INTRINSIC DABS, DSQRT, ASIN, SIN
C
C ------ INPUT
C MXNODE  	NUMBER OF NODES
C MAT_DIR	STORE EXCHANGE COMING IN (> 0) OR OUT (< 0)
C		OF THE MATRIX
C QBDIR  	FLOW RATE DIRECTLY IN CONDUIT
C BEG_HEAD 	CONTAINING THE HEADS READ FROM FILE
C NEIBR  	ARRAY CONTAINING THE CONDUITSTRUCTUR:
C		NODE, NEIGHBOUR NODE  1, 2, 3, 4, TUBE NR. 1, 2, 3, 4,
C               MODFLOWROW, -COLUMN
C TUBE  	MATRIX WITH TUBE NR., NODE_BEGIN, NODE_END
C        	Q m/s (IF NODE_BEGIN PRESSURE > NODE_END PRESSURE THEN Q >= 0),
C        	CHEMISTRY: 0 NOT CALCULATED, 1 CALCULATED
C GEOTIMES	DURATION OF THE 'CHEMICAL TIMESTEP' OF EVERY STRESS
C		PERIOD
c
C
C ------ OUTPUT
C KU_IN_MAT     CUMULATIVE FLOW IN THE MATRIX
C KU_OUT_MAT    CUMULATIVE FLOW OUT OF THE MATRIX
C KU_QBDIR      CUMULATIVE FLOW RATE DIRECTLY IN CONDUIT
C BUD_SOURCE    FLOW OF SOURCE
C BUD_SINK      FLOW OF SINK = FLOW OUT OF THE CONDUIT SYSTEM
C BUD_MATIN     TOTAL FLOW IN CONDUIT SYSTEM COMING FROM MATRIX
C BUD_MATOUT    TOTAL FLOW IN MATRIX
C BUD_QBDIR     TOTAL DIRECT INFLOW IN CONDUIT SYSTEM
C TOTAL_BUDGET  TOTAL BUDGET DIFFERENCE
C BUD_TOTAL_STEP   TOTAL BUDGET DIFFERENCE IN THE LAST TIMESTEP
! Local Variables
      INTEGER i, itest, j, fix_node, flow_tube
      DOUBLE PRECISION wettdnew, wettdold, vnew, vold, vchange, modtourt
      DOUBLE PRECISION dknot, theta, fixbudget
      DOUBLE PRECISION tubetop1, tubebot1, ltourt
!     DOUBLE PRECISION x, y, z, length
!     ------------------------------------------------------------------
c
C
Cseba--CALCULATE RATES FOR TIMESTEP
C
      Ts_in_mat = ZERO
      Ts_out_mat = ZERO
      Ts_qbdir = ZERO
      Ts_bud_sink = ZERO
      Ts_bud_source = ZERO
      Ts_bud_storage_in = ZERO
      Ts_bud_storage_out = ZERO
      Ts_bud_storage = ZERO
cbarc**storage changes here
      vchange = ZERO
C
C--GO THROUGH ALL NODES
      DO i = 1, Mxnode
c 
        Qstor(i) = ZERO
C
C--DIRECT INFLOW IN CONDUIT SYSTEM
        Ts_qbdir = Ts_qbdir + Qbdir(i)
c 
C
C--MATRIX IN- AND OUT-FLOW
        IF ( Matflow(i).LT.ZERO ) THEN
          Ts_in_mat = Ts_in_mat + (-1.D0*Matflow(i))
        ELSE
          Ts_out_mat = Ts_out_mat + (-1.D0*Matflow(i))
        ENDIF
cbarc**storage changes for partially-filled conduits
cb-----------------------------------------------------------------
c         bud_storage = ZERO
c 
        DO j = 1, NNOD
          itest = Nbr(i, j+4+NNOD)
cbarc**itest is a tube number !!!
          IF ( itest.NE.0 ) THEN
            tubetop1 = Geohight(i) + Con_data(itest, 2)/TWO
            tubebot1 = Geohight(i) - Con_data(itest, 2)/TWO
c 
cbarc**only in partially filled cases
            IF ( B(i).LT.tubetop1 .AND. B(i).GT.tubebot1 ) THEN
c 
cbarc**determine l (length) !rsr?? not used??
!             x = DABS(Node_loca(i,2)-Node_loca(Nbr(i,j),2))
!             y = DABS(Node_loca(i,3)-Node_loca(Nbr(i,j),3))
!             z = DABS(Node_loca(i,4)-Node_loca(Nbr(i,j),4))
!             length = 1.D0
cbarc**for cases of z=0
!             IF ( z.LT.NEARZERO ) THEN
!               IF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
!                 length = y/TWO
!               ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
!                 length = x/TWO
!               ELSE
!                 length = DSQRT(x**TWO+y**TWO)/TWO
!               ENDIF
cbarc**for cases of z>0
!             ELSEIF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
!               length = DSQRT(y**TWO+z**TWO)/TWO
!             ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
!               length = DSQRT(x**TWO+z**TWO)/TWO
!             ELSE
!               length = z
!             ENDIF
c  
              modtourt = Tortuos(itest)
              ltourt = (modtourt-1.D0)/TWO + 1.0D0
              wettdnew = B(i) - tubebot1
              dknot = Con_data(itest, 2)
              theta = TWO*ASIN(TWO*DSQRT((dknot/TWO)**TWO               &
     &                -(wettdnew-dknot/TWO)**TWO)/dknot)
              IF ( B(i).GE.Geohight(i) ) theta = TWOPII - theta
              vnew = ONE8TH*(theta-SIN(theta))*dknot**TWO*ltourt
c 
cbarc**last iteration.
              wettdold = B_mat_o(i) - tubebot1
              theta = TWO*ASIN(TWO*DSQRT((dknot/TWO)**TWO               &
     &                -(wettdold-dknot/TWO)**TWO)/dknot)
c 
              IF ( B_mat_o(i).GE.Geohight(i) ) theta = TWOPII - theta
              vold = ONE8TH*(theta-SIN(theta))*dknot**TWO*ltourt
              vchange = vnew - vold
              Ts_bud_storage = Ts_bud_storage + vchange
c 
cbarc**endif for partially filled statement
            ENDIF
cbarc**endif for itest statement
          ENDIF
cbarc**enddo for nnod do
        ENDDO
c 
cbarc**add qstor for budget output
        Qstor(i) = Ts_bud_storage
c  
        IF ( Ts_bud_storage.GT.ZERO ) THEN
          Ts_bud_storage_out = Ts_bud_storage
        ELSE
          Ts_bud_storage_in = Ts_bud_storage
        ENDIF
c 
cbarc**what about dry cases?
c 
C--BUDGET OF SOURCES AND SINKS
c 
!rsr    IF ( Beghead(i).NE.-1.D0 ) THEN
        IF ( DABS(Beghead(i)+1.D0).GT.NEARZERO ) THEN
c
          fix_node = i
!         qmixbud - 0.D0
C--FLOW INTO THE FIXPOTENTIAL FROM FISSURED SYSTEM
          fixbudget = 1.D0*Matflow(i)
C--add flow of direct recharge into fixed potential
          fixbudget = fixbudget - Qbdir(i)
cbarc***add storage changes
          fixbudget = fixbudget - Qstor(i)
cbarc**acount for tube flow
          DO j = 1, NNOD
            IF ( Nbr(fix_node,j+4+NNOD).NE.0 ) THEN
              flow_tube = Nbr(fix_node, j+4+NNOD)
              IF ( Itube(flow_tube,2).EQ.fix_node ) THEN
                fixbudget = fixbudget + Dtube(flow_tube, 1)
              ELSE
                fixbudget = fixbudget - Dtube(flow_tube, 1)
              ENDIF
            ENDIF
          ENDDO
C--ADD SINK OR SOURCE TO THE BUDGET
cbarc**residual being assigned as source or sink
c 
          IF ( fixbudget.GT.0 ) THEN
C--THE FIXED HEAD NODE IS A SOURCE
            Ts_bud_source = Ts_bud_source + fixbudget
          ELSE
C--THE FIXED HEAD NODE IS A SINK
            Ts_bud_sink = Ts_bud_sink + fixbudget
          ENDIF
c 
cbarc**endif for beghead statement
        ENDIF
cbarc**enddo for mxnode do
      ENDDO
C--TOTAL INPUT THIS TIMESTEP
      Ts_in = Ts_bud_source + Ts_qbdir + Ts_in_mat +                    &
     &        DABS(Ts_bud_storage_in)
c 
C--TOTAL OUTPUT THIS TIMESTEP
      Ts_out = DABS(Ts_bud_sink) + DABS(Ts_out_mat)                     &
     &         + (Ts_bud_storage_out)
c 
C
C--CALCULATE CUMMULATIVE BUDGET:
cb-----------------------------------------------------------------
cbarc**add storage changes here
C     Bud_total_step = 0.D0
      DO i = 1, Mxnode
C
C DIRECT INFLOW IN THE CONDUIT SYSTEM
        Ku_qbdir(i) = Ku_qbdir(i) + (Qbdir(i)*Totim)
        Bud_qbdir = Bud_qbdir + (Qbdir(i)*Totim)
        Bud_total_step = Bud_total_step + (Qbdir(i)*Totim)
C
C DISTINGUISH BETWEEN IN- OR OUTFLOW OF THE MATRIX
        IF ( Matflow(i).LT.ZERO ) THEN
          Ku_in_mat(i) = Ku_in_mat(i) + (-1.D0*Matflow(i)*Totim)
          Bud_matin = Bud_matin + (-1.D0*Matflow(i)*Totim)
          Bud_total_step = Bud_total_step + (-1.D0*Matflow(i)*Totim)
        ELSE
          Ku_out_mat(i) = Ku_out_mat(i) + (-1.D0*Matflow(i)*Totim)
          Bud_matout = Bud_matout + (-1.D0*Matflow(i)*Totim)
          Bud_total_step = Bud_total_step + (-1.D0*Matflow(i)*Totim)
        ENDIF
cbarc*storage changes here**
cbarc***correct for storage changes in partially-filled conduits
cbarc**i is for nodes, j is for neighbors.
cb-----------------------------------------------------------------
C       bud_storage = 0.0
 
        DO j = 1, NNOD
          itest = Nbr(i, j+4+NNOD)
          IF ( itest.NE.0 ) THEN
            tubetop1 = Geohight(i) + Con_data(itest, 2)/TWO
            tubebot1 = Geohight(i) - Con_data(itest, 2)/TWO
c 
cbarc**only in partially filled cases
            IF ( B(i).LT.tubetop1 .AND. B(i).GT.tubebot1 ) THEN
cbarc**determine l (length) !rsr?? not used??
!             x = DABS(Node_loca(i,2)-Node_loca(Nbr(i,j),2))
!             y = DABS(Node_loca(i,3)-Node_loca(Nbr(i,j),3))
!             z = DABS(Node_loca(i,4)-Node_loca(Nbr(i,j),4))
!             length = 1.D0
cbarc**for cases of z=0
!             IF ( z.LT.NEARZERO ) THEN
!               IF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
!                 length = y/TWO
!               ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
!                 length = x/TWO
!               ELSE
!                 length = DSQRT(x**TWO+y**TWO)/TWO
!               ENDIF
cbarc**for cases of z>0
!             ELSEIF ( x.LT.NEARZERO .AND. y.GT.ZERO ) THEN
!               length = DSQRT(y**TWO+z**TWO)/TWO
!             ELSEIF ( x.GT.ZERO .AND. y.LT.NEARZERO ) THEN
!               length = DSQRT(x**TWO+z**TWO)/TWO
!             ELSE
!               length = z
!             ENDIF
c 
              modtourt = Tortuos(itest)
              ltourt = (modtourt-1.D0)/TWO + 1.0D0
              wettdnew = B(i) - tubebot1
              dknot = Con_data(itest, 2)
              theta = TWO*ASIN(TWO*DSQRT((dknot/TWO)**TWO               &
     &                -(wettdnew-dknot/TWO)**TWO)/dknot)
              IF ( B(i).GE.Geohight(i) ) theta = TWOPII - theta
              vnew = ONE8TH*(theta-SIN(theta))*dknot**TWO*ltourt
c 
cbarc**reset last iteration.
              wettdold = B_mat_o(i) - tubebot1
              theta = TWO*ASIN(TWO*DSQRT((dknot/TWO)**TWO               &
     &                -(wettdold-dknot/TWO)**TWO)/dknot)
              IF ( B_mat_o(i).GE.Geohight(i) ) theta = TWOPII - theta
              vold = ONE8TH*(theta-SIN(theta))*dknot**TWO*ltourt
              vchange = vnew - vold
              Bud_storage = Bud_storage + vchange
            ENDIF
          ENDIF
        ENDDO
c 
        IF ( Bud_storage.LE.ZERO ) THEN
          Bud_storage_in = Bud_storage
          Bud_total_step = Bud_total_step + Bud_storage
        ENDIF
        IF ( Bud_storage.GT.ZERO ) THEN
          Bud_storage_out = Bud_storage
          Bud_total_step = Bud_total_step + Bud_storage
        ENDIF
C
C--BUDGET OF SOURCES AND SINKS
cb----------------------------------------------------
!rsr    IF ( Beghead(i).NE.-1.D0 ) THEN
        IF ( DABS(Beghead(i)+1.D0).GT.NEARZERO ) THEN
c
          fix_node = i
!         qmixbud - 0.D0
C--FLOW INTO THE FIXPOTENTIAL FROM FISSURED SYSTEM
          fixbudget = (1)*Matflow(i)*Totim
C--DIRECT RECHARGE
          fixbudget = fixbudget - Qbdir(i)*Totim
cbarc***add storage changes
          fixbudget = fixbudget - Bud_storage*Totim
C--FLOW IN CONDUITS
          DO j = 1, NNOD
            IF ( Nbr(fix_node,j+4+NNOD).NE.0 ) THEN
              flow_tube = Nbr(fix_node, j+4+NNOD)
              IF ( Itube(flow_tube,2).EQ.fix_node ) THEN
                fixbudget = fixbudget + (Dtube(flow_tube,1)*Totim)
              ELSE
                fixbudget = fixbudget - (Dtube(flow_tube,1)*Totim)
              ENDIF
            ENDIF
          ENDDO
C ADD SINK OR SOURCE TO THE BUDGET
c 
          IF ( fixbudget.GT.0 ) THEN
C THE FIXED HEAD NODE IS A SOURCE
            Bud_source = Bud_source + fixbudget
            Bud_total_step = Bud_total_step + fixbudget
          ELSE
C THE FIXED HEAD NODE IS A SINK
            Bud_sink = Bud_sink + fixbudget
            Bud_total_step = Bud_total_step + fixbudget
          ENDIF
c 
cbarc**endif for beghead statement
        ENDIF
C
c 
      ENDDO
C
C ADD BUDGET DIFFERENCE OF THE TIMESTEP TO TOTAL BUDGET DIFFERENCE
      Total_budget = Total_budget + DABS(Bud_total_step)
C
C--CALCULATE ACCURRACY OF BUDGET
      Diff_tot = Bud_source + Bud_qbdir + Bud_matin +                   &
     &           DABS(Bud_storage_in) - DABS(Bud_sink)                  &
     &           - DABS(Bud_matout) - Bud_storage_out
      Diff_ts = Ts_bud_source + Ts_qbdir + Ts_in_mat +                  &
     &          DABS(Ts_bud_storage_in) - DABS(Ts_bud_sink)             &
     &          - DABS(Ts_out_mat) - Ts_bud_storage_out
      Tot_flow = Bud_source + Bud_qbdir + Bud_matin + Bud_storage_in +  &
     &           DABS(Bud_sink) + DABS(Bud_matout)                      &
     &           + DABS(Bud_storage_out)
      Ts_tot_flow = Ts_bud_source + Ts_qbdir + Ts_in_mat +              &
     &              DABS(Ts_bud_storage_in) + DABS(Ts_bud_sink)         &
     &              + DABS(Ts_out_mat) + Ts_bud_storage_out
C
      END SUBROUTINE CONBUD
c====================================================================== 
! =====================================================================
c====================================================================== 
      SUBROUTINE NODEBUD
C
C--VERSION 2                   SUBROUTINE NODEBD                      19071999
C******************************************************************************
C                   CALCULATE WATER BUDGET FOR EVERY NODE
C******************************************************************************
C
c
      USE CFPMODULE, ONLY:NNOD, Mxnode, Nbr, Beghead, Qmat, Qtub, Qfix, &
     &    Nodin, Nodout, Qtubin, Qtubout, B_mat, B_mat_o, Nstor, Itube, &
     &    Nodetop, Nodebot, Geohight, Con_data, Qbdir, Dtube, TWOPII,   &
     &    ONE8TH, ZERO, TWO, NEARZERO
c
CBARC**WHAT ABOUT TUBE      
CBARC**WHAT ABOUT TUBE, rsr TUBE(i,1), TUBE(i,2), TUBE(i,3) in ITUBE
CBARC**WHAT ABOUT TUBE, rsr TUBE(i,4), TUBE(i,4) in DTUBE
c
      IMPLICIT NONE
      INTRINSIC DSQRT, SIN
! Local Variables
      INTEGER i, itest, j, n, t, bnod, enod
      DOUBLE PRECISION wettdnew, wettdold, vnew, vold, vchange
      DOUBLE PRECISION dknot, theta, qt
C
C     NODIN  SUM OF INFLOW TO NODE, DIMENSION(MXNODE)
C     NODOUT SUM OF OUTFLOW FROM NODE, DIMENSION(MXNODE)
C     QDIR   FLOW FROM DIRECT RECHARGE INTO NODE, DIMENSION(MXNODE)
C     QFIX   FLOW FROM FIXED HEAD INTO NODE, DIMENSION(MXNODE)
C     QMAT   FLOW FROM NODE INTO FISSURED SYSTEM, DIMENSION(MXNODE)
C     QTUB   FLOW FROM TUBES INTO NODE, DIMENSION(MXNODE,NNOD)
C     QTUBIN SUM OF INFLOW FROM TUBES INTO NODE, DIMENSION(MXNODE)
C     QTUBOUT SUM OF OUTFLOW FROM NODES INTO TUBES, DIMENSION(MXNODE)
C     QWD    DRAINFLOW DUE TO DRY NODES WITH EXCHANGE
C     QWDBUD BUDGET OF DRAININFLOW FOR EACH NODE
C      INTEGER MXNODE,MXTUBE,N,T,NNOD, i,j
C      PARAMETER(NNOD=6)
C      DOUBLE PRECISION NEIBR(MXNODE,(4+2*NNOD)),TUBE(MXTUBE,5),
C     1       QMAT(MXNODE),QDIR(MXNODE),QTUB(MXNODE,NNOD),NODIN(MXNODE),
C     2       NODOUT(MXNODE),QT,BNOD,ENOD,BEG_HEAD(MXNODE),QFIX(MXNODE),
C     3       QTUBIN(MXNODE),QTUBOUT(MXNODE),QWD(MXNODE,4),
C     4       QWDBUD(MXNODE)
C
C ---------------------------------------------------------------------
C---------CLEAR QTUB,QFIX,NODIN,NODOUT,QTUBIN,QTUBOUT
      DO i = 1, Mxnode
        DO j = 1, NNOD
          Qtub(i, j) = ZERO
        ENDDO
        Qfix(i) = ZERO
        Nodin(i) = ZERO
        Nodout(i) = ZERO
        Qtubin(i) = ZERO
        Qtubout(i) = ZERO
c 
      ENDDO
C
C-----LOOP OVER NODES
      DO n = 1, Mxnode
C---------ADD DIRECT RECHARGE
        IF ( Qbdir(n).GT.ZERO ) THEN
          Nodin(n) = Nodin(n) + Qbdir(n)
        ELSE
          Nodout(n) = Nodout(n) - Qbdir(n)
        ENDIF
c 
C---------ADD EXCHANGE WITH MATRIX
 
        IF ( Qmat(n).LT.ZERO ) THEN
          Nodin(n) = Nodin(n) - Qmat(n)
        ELSE
          Nodout(n) = Nodout(n) + Qmat(n)
        ENDIF
cbarc--------add storage term-----
        Nstor(n) = ZERO
        DO j = 1, NNOD
c
          vchange = ZERO
          vnew = ZERO
          vold = ZERO
          itest = Nbr(n, j+4+NNOD)
cbarc**itest is a tube number !!!
          IF ( itest.NE.0 ) THEN
 
cbarc**only in partially filled cases
            IF ( B_mat(n).LT.Nodetop(n) .AND. B_mat(n).GT.Nodebot(n) )  &
     &           THEN
              wettdnew = B_mat(n) - Nodebot(n)
              dknot = Con_data(itest, 2)
              theta = TWO*ASIN(TWO*DSQRT((dknot/TWO)**TWO               &
     &                -(wettdnew-dknot/TWO)**TWO)/dknot)
              IF ( B_mat(n).GE.Geohight(n) ) theta = TWOPII - theta
              vnew = ONE8TH*(theta-SIN(theta))*dknot**TWO
cbarc**last iteration.
              wettdold = B_mat_o(n) - Nodebot(n)
              theta = TWO*ASIN(TWO*DSQRT((dknot/TWO)**TWO               &
     &                -(wettdold-dknot/TWO)**TWO)/dknot)
              IF ( B_mat_o(n).GE.Geohight(n) ) theta = TWOPII - theta
              vold = ONE8TH*(theta-SIN(theta))*dknot**TWO
              vchange = vnew - vold
              Nstor(n) = vchange
CBARC**endif for partially-filled cases
            ENDIF
cbarc**endif for itest statement
          ENDIF
cbarc**enddo for nnod loop
        ENDDO
c 
        IF ( Nstor(n).LT.0 ) THEN
          Nodin(n) = Nodin(n) - Nstor(n)
        ELSE
          Nodout(n) = Nodout(n) + Nstor(n)
        ENDIF
c 
C---------SAVE FLOW FROM TUBES IN QTUB AND ADD IT TO NODIN OR NODOUT RESP.
C---------LOOP OVER TUBES WHICH ARE CONNECTED WITH THE NODE
        DO t = 1, NNOD
          IF ( Nbr(n,t+4+NNOD).NE.0 ) THEN
            qt = Dtube(Nbr(n,t+4+NNOD), 1)
            bnod = Itube(Nbr(n,t+4+NNOD), 2)
            enod = Itube(Nbr(n,t+4+NNOD), 3)
            IF ( qt.LT.ZERO .AND. n.EQ.bnod ) THEN
              Qtub(n, t) = -qt
              Nodin(n) = Nodin(n) + Qtub(n, t)
              Qtubin(n) = Qtubin(n) + Qtub(n, t)
            ELSEIF ( qt.GT.ZERO .AND. n.EQ.enod ) THEN
              Qtub(n, t) = qt
              Nodin(n) = Nodin(n) + Qtub(n, t)
              Qtubin(n) = Qtubin(n) + Qtub(n, t)
            ELSEIF ( qt.LT.ZERO .AND. n.EQ.enod ) THEN
              Qtub(n, t) = qt
              Nodout(n) = Nodout(n) - Qtub(n, t)
              Qtubout(n) = Qtubout(n) + Qtub(n, t)
            ELSEIF ( qt.GT.ZERO .AND. n.EQ.bnod ) THEN
              Qtub(n, t) = -qt
              Nodout(n) = Nodout(n) - Qtub(n, t)
              Qtubout(n) = Qtubout(n) + Qtub(n, t)
            ENDIF
          ENDIF
        ENDDO
C-----FIXED HEAD NODE: DIFFERENCE BETWEEN INFLOW AND OUTFLOW IS SINK OR SOURCE
c 
cbarc**change so this works with fixed head  below sealevel
cb          IF(BEGHEAD(N).GE.0)THEN
!rsr    IF ( Beghead(n).NE.-1.D0 ) THEN
        IF ( DABS(Beghead(n)+1.D0).GT.NEARZERO ) THEN
          Qfix(n) = Nodout(n) - Nodin(n)
c 
C-----------FIXED HEAD IS A SOURCE
          IF ( Qfix(n).GT.ZERO ) Nodin(n) = Nodin(n) + Qfix(n)
c 
C-----------FIXED HEAD IS A SINK
          IF ( Qfix(n).LT.ZERO ) Nodout(n) = Nodout(n) - Qfix(n)
c 
        ENDIF
      ENDDO
C
      END SUBROUTINE NODEBUD
C---------------------------------------------------------------------
c---------------------------------------------------------------------
c---------------------------------------------------------------------